/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 4;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 5;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 9;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 11;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SImode))
        return -1;
      return 12;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x3) != E_VNx64QImode
          || !aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x3) != E_VNx32HImode
          || !aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      return 1;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x3) != E_VNx16SImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x3) != E_VNx8DImode
          || !aligned_register_operand (operands[1], E_VNx8DImode))
        return -1;
      return 3;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x3) != E_VNx32BFmode
          || !aligned_register_operand (operands[1], E_VNx32BFmode))
        return -1;
      return 4;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x3) != E_VNx32HFmode
          || !aligned_register_operand (operands[1], E_VNx32HFmode))
        return -1;
      return 5;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 6;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x3) != E_VNx8DFmode
          || !aligned_register_operand (operands[1], E_VNx8DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern77 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern77 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern77 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern77 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern77 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern77 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern77 (x3, 
E_VNx8QImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern77 (x3, 
E_VNx4QImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern77 (x3, 
E_VNx2QImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern77 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern77 (x3, 
E_VNx4HImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern77 (x3, 
E_VNx2HImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern77 (x3, 
E_VNx2SImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (pattern77 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (pattern77 (x3, 
E_VNx4HFmode) != 0)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (pattern77 (x3, 
E_VNx2HFmode) != 0)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (pattern77 (x3, 
E_VNx8BFmode) != 0)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (pattern77 (x3, 
E_VNx4BFmode) != 0)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (pattern77 (x3, 
E_VNx2BFmode) != 0)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (pattern77 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (pattern77 (x3, 
E_VNx2SFmode) != 0)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (pattern77 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern147 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx4SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx8BFmode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_VNx8BFmode))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern202 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern208 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern208 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern208 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern211 (x3); /* [-1, 3] */

    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 351)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 351)
        return -1;
      x9 = XVECEXP (x8, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      res = pattern215 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i2))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 168)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 93)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (!const_int_operand (x7, E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[2] = x10;
      operands[3] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          return pattern245 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern245 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[1] = x12;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[3] = x10;
      operands[4] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          res = pattern249 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern249 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      if (GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[4], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !register_operand (operands[4], E_VNx8HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (pattern265 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_VNx2BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx2DImode:
      return 0;

    case E_VNx1TImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x9 = XVECEXP (x2, 0, 5);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[4] = x9;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[0], E_VNx16QImode)
              || GET_MODE (x2) != E_VNx16QImode
              || !register_operand (operands[1], E_VNx16QImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[2], E_VNx16BImode))
                return -1;
              return 0;

            case E_VNx1TImode:
              if (!register_operand (operands[2], E_VNx2BImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_VNx8HImode:
          res = pattern279 (x2, 
E_VNx8HImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_VNx4SImode:
          res = pattern280 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_VNx2DImode:
          res = pattern281 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_VNx8BFmode:
          res = pattern279 (x2, 
E_VNx8BFmode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_VNx8HFmode:
          res = pattern279 (x2, 
E_VNx8HFmode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        case E_VNx4SFmode:
          res = pattern280 (x2, 
E_VNx4SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_VNx2DFmode:
          res = pattern281 (x2, 
E_VNx2DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern282 (x2, 
E_VNx16BImode, 
E_VNx16QImode) != 0)
            return -1;
          return 16;

        case E_VNx8HImode:
          if (pattern282 (x2, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 17;

        case E_VNx4SImode:
          if (pattern282 (x2, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern282 (x2, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        case E_VNx8BFmode:
          if (pattern283 (x2, 
E_VNx8BImode, 
E_VNx8BFmode, 
E_VNx8HImode) != 0)
            return -1;
          return 20;

        case E_VNx8HFmode:
          if (pattern283 (x2, 
E_VNx8BImode, 
E_VNx8HFmode, 
E_VNx8HImode) != 0)
            return -1;
          return 21;

        case E_VNx4SFmode:
          if (pattern283 (x2, 
E_VNx4BImode, 
E_VNx4SFmode, 
E_VNx4SImode) != 0)
            return -1;
          return 22;

        case E_VNx2DFmode:
          if (pattern283 (x2, 
E_VNx2BImode, 
E_VNx2DFmode, 
E_VNx2DImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern319 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern322 (x1); /* [-1, 4] */
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!aarch64_simd_or_scalar_imm_zero (operands[2], E_V8QImode))
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern321 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern321 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern321 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx4SImode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x1) != E_QImode
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode))
                return -1;
              return 0;

            case E_HImode:
              if (pattern339 (x1, 
E_SImode, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case CONST_VECTOR:
          res = pattern340 (x1);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != i1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x1) != E_V8QImode
                  || GET_MODE (x2) != E_V8SImode
                  || pattern341 (x4, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              return 6;

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x1) != E_V4HImode
                  || GET_MODE (x2) != E_V4DImode
                  || pattern342 (x4, 
E_V4SImode, 
E_V4DImode) != 0)
                return -1;
              return 7;

            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x1) != E_V2SImode
                  || GET_MODE (x2) != E_V2TImode
                  || pattern343 (x4, 
E_V2DImode, 
E_V2TImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x1) != E_QImode
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[1], E_HImode)
                  || !aarch64_int_rnd_operand (operands[3], E_SImode)
                  || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode))
                return -1;
              return 9;

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x1) != E_HImode
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode
                  || GET_MODE (x5) != E_DImode
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_int_rnd_operand (operands[3], E_DImode)
                  || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode))
                return -1;
              return 10;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_TImode
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode
                  || !register_operand (operands[1], E_DImode)
                  || !aarch64_int_rnd_operand (operands[3], E_TImode)
                  || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern386 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern396 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern406 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern420 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern420 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern420 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern434 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern433 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern433 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern433 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[3], i1)
      || !register_operand (operands[1], E_V8QImode))
    return -1;
  return 0;
}

int
pattern445 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern448 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern453 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern455 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  return pattern454 (x4, 
67, 
E_DImode, 
USE); /* [-1, 0] */
}

int
pattern459 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern213 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_select_half (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_select_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[4], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      return 0;

    case E_VNx4QImode:
      return 1;

    case E_VNx2QImode:
      return 2;

    case E_VNx4HImode:
      return 3;

    case E_VNx2HImode:
      return 4;

    case E_VNx2SImode:
      return 5;

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !memory_operand (operands[1], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern496 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern504 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern504 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern504 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || GET_MODE (x2) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  return 0;
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!aarch64_imm3 (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern519 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern519 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern563 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CC_NZCmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  return 0;
}

int
pattern569 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern574 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!register_operand (operands[1], E_VNx4HImode))
        return -1;
      return 1;

    case E_VNx2HImode:
      if (!register_operand (operands[1], E_VNx2HImode))
        return -1;
      return 2;

    case E_VNx4SImode:
      if (!register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 3;

    case E_VNx2SImode:
      if (!register_operand (operands[1], E_VNx2SImode))
        return -1;
      return 4;

    case E_VNx2DImode:
      if (!register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_orr_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern601 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern613 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern617 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern617 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern617 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern617 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern625 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern623 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern623 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V8HImode:
      if (pattern624 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern624 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern624 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern632 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern640 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i4))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern656 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern655 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern655 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern668 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  x10 = XEXP (x1, 1);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern667 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern667 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern667 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern676 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern677 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CC_NZCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern676 (x5, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern676 (x5, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern676 (x5, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern676 (x5, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern688 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_imm24 (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_imm24 (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 2;

        case E_DImode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern697 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern696 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern696 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern696 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern696 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern696 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern696 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern696 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern696 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern696 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern696 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern709 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_lanes_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_stp_reg_operand (operands[1], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern713 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern711 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern711 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern711 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern711 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern711 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern711 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern711 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern711 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern711 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern711 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (pattern711 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (pattern711 (x1, 
E_VNx4HFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (pattern711 (x1, 
E_VNx2HFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (pattern711 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (pattern711 (x1, 
E_VNx4BFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (pattern711 (x1, 
E_VNx2BFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (pattern711 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (pattern711 (x1, 
E_VNx2SFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (pattern711 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 18;

    case E_VNx32QImode:
      if (pattern712 (x1, 
E_VNx32QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 19;

    case E_VNx16HImode:
      if (pattern712 (x1, 
E_VNx16HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 20;

    case E_VNx8SImode:
      if (pattern712 (x1, 
E_VNx8SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 21;

    case E_VNx4DImode:
      if (pattern712 (x1, 
E_VNx4DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 22;

    case E_VNx16BFmode:
      if (pattern712 (x1, 
E_VNx16BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 23;

    case E_VNx16HFmode:
      if (pattern712 (x1, 
E_VNx16HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 24;

    case E_VNx8SFmode:
      if (pattern712 (x1, 
E_VNx8SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 25;

    case E_VNx4DFmode:
      if (pattern712 (x1, 
E_VNx4DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 26;

    case E_VNx48QImode:
      if (pattern712 (x1, 
E_VNx48QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 27;

    case E_VNx24HImode:
      if (pattern712 (x1, 
E_VNx24HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 28;

    case E_VNx12SImode:
      if (pattern712 (x1, 
E_VNx12SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 29;

    case E_VNx6DImode:
      if (pattern712 (x1, 
E_VNx6DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 30;

    case E_VNx24BFmode:
      if (pattern712 (x1, 
E_VNx24BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 31;

    case E_VNx24HFmode:
      if (pattern712 (x1, 
E_VNx24HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 32;

    case E_VNx12SFmode:
      if (pattern712 (x1, 
E_VNx12SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 33;

    case E_VNx6DFmode:
      if (pattern712 (x1, 
E_VNx6DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 34;

    case E_VNx64QImode:
      if (pattern712 (x1, 
E_VNx64QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 35;

    case E_VNx32HImode:
      if (pattern712 (x1, 
E_VNx32HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 36;

    case E_VNx16SImode:
      if (pattern712 (x1, 
E_VNx16SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 37;

    case E_VNx8DImode:
      if (pattern712 (x1, 
E_VNx8DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 38;

    case E_VNx32BFmode:
      if (pattern712 (x1, 
E_VNx32BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 39;

    case E_VNx32HFmode:
      if (pattern712 (x1, 
E_VNx32HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 40;

    case E_VNx16SFmode:
      if (pattern712 (x1, 
E_VNx16SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 41;

    case E_VNx8DFmode:
      if (pattern712 (x1, 
E_VNx8DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 42;

    default:
      return -1;
    }
}

int
pattern773 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern772 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern772 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern780 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_one (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern791 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern797 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode)
          || !register_operand (operands[1], i1))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern817 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_cnt_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern823 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case VEC_SELECT:
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      x3 = XEXP (x1, 1);
      operands[5] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != VEC_SELECT
          || GET_MODE (x2) != E_HFmode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 2;

        case E_V4SFmode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern838 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern845 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern852 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern862 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern868 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern875 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern880 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern883 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern888 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  return pattern887 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern894 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_plus_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_plus_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern901 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern905 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern912 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern923 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  x13 = XEXP (x9, 1);
  operands[3] = x13;
  return pattern922 (x1); /* [-1, 1] */
}

int
pattern931 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XVECEXP (x3, 0, 0);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern930 (x1, 
E_VNx8BFmode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern930 (x1, 
E_VNx8HFmode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern930 (x1, 
E_VNx4SFmode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern930 (x1, 
E_VNx2DFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern939 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern944 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ldff1_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern948 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern953 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern960 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern968 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern974 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern979 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern985 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 98)
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0)
    return -1;
  return 0;
}

int
pattern989 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern358 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern358 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern994 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern998 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1004 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1011 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SFmode
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V2SFmode:
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1021 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1029 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern1028 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern1028 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern1028 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1036 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 2);
  operands[1] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1035 (); /* [-1, 3] */

    case E_DImode:
      res = pattern1035 ();
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1048 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      return pattern1046 (x1); /* [-1, 6] */

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1043 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 7;

            case E_VNx8HFmode:
              if (pattern1043 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 8;

            case E_VNx4SFmode:
              if (pattern1043 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return -1;
              return 9;

            case E_VNx2DFmode:
              if (pattern1043 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return -1;
              return 10;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1047 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 11;

            case E_VNx4SFmode:
              if (pattern1047 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return -1;
              return 12;

            case E_VNx2DFmode:
              if (pattern1047 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return -1;
              return 13;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1075 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SFmode
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1083 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern1082 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern1082 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern1082 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1095 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  operands[1] = x4;
  if (!aarch64_sve_ptrue_svpattern_immediate (operands[1], E_VNx16BImode))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 128
      || GET_MODE (x5) != E_VNx16BImode)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[3] = x7;
  x8 = XVECEXP (x5, 0, 0);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[5] = x9;
  if (!aarch64_simd_imm_zero (operands[5], E_VNx16BImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x10))
    {
    case SET:
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1042 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1042 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1042 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1042 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1108 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1108 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1108 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern850 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern850 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern850 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode
      || !register_operand (operands[5], E_VNx2BImode))
    return -1;
  return 0;
}

int
pattern1139 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1147 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1154 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[1], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1168 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_fp_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_fp_zero (operands[3], i1))
    return -1;
  operands[5] = x1;
  if (!aarch64_reg_or_fp_zero (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!memory_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!aarch64_reg_or_fp_zero (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1179 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[3], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[3], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[3], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[3], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[3], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[3], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[3], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[3], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[3], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1230 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[4] = x3;
  if (!register_operand (operands[4], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[5] = x4;
  if (!memory_operand (operands[5], E_SImode))
    return -1;
  x5 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x5, 0);
  operands[6] = x7;
  if (!register_operand (operands[6], E_DImode))
    return -1;
  x8 = XEXP (x6, 0);
  operands[7] = x8;
  if (!memory_operand (operands[7], E_SImode))
    return -1;
  return 0;
}

int
pattern1242 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1248 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  x6 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  return pattern1099 (x7, 
i1); /* [-1, 1] */
}

int
pattern1256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_SImode:
      return pattern1255 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1255 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  operands[5] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[6] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern464 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern464 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern464 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1286 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1299 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1315 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_carry_operation (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !aarch64_carry_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1329 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[2], E_VNx16BFmode)
          || !aligned_register_operand (operands[3], E_VNx16BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[2], E_VNx32BFmode)
          || !aligned_register_operand (operands[3], E_VNx32BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[2], E_VNx16HFmode)
          || !aligned_register_operand (operands[3], E_VNx16HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[2], E_VNx32HFmode)
          || !aligned_register_operand (operands[3], E_VNx32HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1339 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1344 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || pattern1294 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1357 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_operator (operands[7], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[10] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !aarch64_stp_reg_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[4]))
    return -1;
  return 0;
}

int
pattern1367 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (!cc_register (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 113)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      x11 = XVECEXP (x7, 0, 0);
      operands[5] = x11;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 7; /* ccmpccsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 8; /* ccmpccdi */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1262 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 766 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 9; /* ccmpccfpsf */
              break;

            case 1:
              if (
#line 766 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 10; /* ccmpccfpdf */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1262 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 766 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 11; /* ccmpccfpesf */

        case 1:
          if (!
#line 766 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 12; /* ccmpccfpedf */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 113)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != COMPARE)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x12 = XVECEXP (x6, 0, 0);
      operands[5] = x12;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[2] = x13;
      x14 = XEXP (x7, 1);
      operands[3] = x14;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 13; /* ccmpccsi_rev */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 14; /* ccmpccdi_rev */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1263 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 803 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 15; /* ccmpccfpsf_rev */
              break;

            case 1:
              if (
#line 803 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 16; /* ccmpccfpdf_rev */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1263 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 803 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 17; /* ccmpccfpesf_rev */

        case 1:
          if (!
#line 803 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 18; /* ccmpccfpedf_rev */

        default:
          return -1;
        }

    case LABEL_REF:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[0] = x3;
      operands[1] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      return 19; /* condjump */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x6;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      operands[1] = x3;
      operands[2] = x5;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1054 (x2, 
E_QImode) != 0
              || !
#line 4565 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 457; /* *cmovqi_insn */

        case E_HImode:
          if (pattern1054 (x2, 
E_HImode) != 0
              || !
#line 4565 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 458; /* *cmovhi_insn */

        case E_SImode:
          if (pattern1054 (x2, 
E_SImode) != 0
              || !
#line 4565 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 459; /* *cmovsi_insn */

        case E_DImode:
          if (pattern1054 (x2, 
E_DImode) != 0
              || !
#line 4565 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 460; /* *cmovdi_insn */

        case E_SFmode:
          if (pattern1055 (x2, 
E_SFmode) != 0
              || !
#line 4642 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 465; /* *cmovsf_insn */

        case E_DFmode:
          if (pattern1055 (x2, 
E_DFmode) != 0
              || !
#line 4642 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 466; /* *cmovdf_insn */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != ZERO_EXTEND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      operands[1] = x3;
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 464; /* *cmovdi_insn_uxtw */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4467; /* aarch64_simd_ld3rv8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4468; /* aarch64_simd_ld3rv4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4469; /* aarch64_simd_ld3rv2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4470; /* aarch64_simd_ld3rdi */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4471; /* aarch64_simd_ld3rv4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4472; /* aarch64_simd_ld3rv2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4473; /* aarch64_simd_ld3rdf */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4474; /* aarch64_simd_ld3rv4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4475; /* aarch64_simd_ld3rv16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4476; /* aarch64_simd_ld3rv8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4477; /* aarch64_simd_ld3rv4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4478; /* aarch64_simd_ld3rv2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4479; /* aarch64_simd_ld3rv8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4480; /* aarch64_simd_ld3rv4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4481; /* aarch64_simd_ld3rv2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !
#line 7674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4482; /* aarch64_simd_ld3rv8bf */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8385 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4805; /* aarch64_ld2v8qi_dreg */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8385 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4806; /* aarch64_ld2v4hi_dreg */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8385 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4807; /* aarch64_ld2v2si_dreg */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8385 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4808; /* aarch64_ld2v4hf_dreg */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8385 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4809; /* aarch64_ld2v2sf_dreg */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8385 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4810; /* aarch64_ld2v4bf_dreg */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4811; /* aarch64_ld2di_dreg */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4812; /* aarch64_ld2df_dreg */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11156; /* aarch64_pmov_to_vnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11157; /* aarch64_pmov_to_vnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11158; /* aarch64_pmov_to_vnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11159; /* aarch64_pmov_to_vnx2di */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern61 (x1))
    {
    case 0:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5024; /* aarch64_rev64v8qi */

    case 1:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5033; /* aarch64_rev64v16qi */

    case 2:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5036; /* aarch64_rev64v4hi */

    case 3:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5045; /* aarch64_rev64v8hi */

    case 4:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5048; /* aarch64_rev64v2si */

    case 5:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5057; /* aarch64_rev64v4si */

    case 6:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5060; /* aarch64_rev64v2di */

    case 7:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5063; /* aarch64_rev64v4hf */

    case 8:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5072; /* aarch64_rev64v8hf */

    case 9:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5075; /* aarch64_rev64v4bf */

    case 10:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5084; /* aarch64_rev64v8bf */

    case 11:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5087; /* aarch64_rev64v2sf */

    case 12:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5096; /* aarch64_rev64v4sf */

    case 13:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5099; /* aarch64_rev64v2df */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern72 (x1))
    {
    case 0:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12917; /* aarch64_sve_uzpvnx64qi */

    case 1:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12919; /* aarch64_sve_uzpvnx32hi */

    case 2:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12921; /* aarch64_sve_uzpvnx16si */

    case 3:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12923; /* aarch64_sve_uzpvnx8di */

    case 4:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12925; /* aarch64_sve_uzpvnx32bf */

    case 5:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12927; /* aarch64_sve_uzpvnx32hf */

    case 6:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12929; /* aarch64_sve_uzpvnx16sf */

    case 7:
      if (!
#line 3894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12931; /* aarch64_sve_uzpvnx8df */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern54 (x1))
    {
    case 0:
      if (!(
#line 6857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 902; /* nearbyinthf2 */

    case 1:
      if (!
#line 6857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 909; /* nearbyintsf2 */

    case 2:
      if (!
#line 6857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 916; /* nearbyintdf2 */

    case 3:
      if (!(
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2501; /* nearbyintv4hf2 */

    case 4:
      if (!(
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2514; /* nearbyintv8hf2 */

    case 5:
      if (!
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2529; /* nearbyintv2sf2 */

    case 6:
      if (!
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2542; /* nearbyintv4sf2 */

    case 7:
      if (!
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2549; /* nearbyintv2df2 */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      switch (XINT (x3, 1))
        {
        case 316:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern875 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6921; /* aarch64_pred_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern875 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6924; /* aarch64_pred_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern875 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6927; /* aarch64_pred_revbvnx4si */

            case E_VNx2DImode:
              if (pattern875 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6930; /* aarch64_pred_revbvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern875 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6922; /* aarch64_pred_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern875 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6925; /* aarch64_pred_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern875 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6928; /* aarch64_pred_revhvnx4si */

            case E_VNx2DImode:
              if (pattern875 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6931; /* aarch64_pred_revhvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern875 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6923; /* aarch64_pred_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern875 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6926; /* aarch64_pred_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern875 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6929; /* aarch64_pred_revwvnx4si */

            case E_VNx2DImode:
              if (pattern875 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3329 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6932; /* aarch64_pred_revwvnx2di */

            default:
              return -1;
            }

        case 320:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              switch (pattern995 (x2, 
E_VNx16QImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 8))
                    return -1;
                  return 6933; /* aarch64_sve_revbhw_vnx16qivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 8))
                    return -1;
                  return 6952; /* aarch64_sve_revbhw_vnx16qivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 8))
                    return -1;
                  return 6971; /* aarch64_sve_revbhw_vnx16qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8QImode:
              switch (pattern995 (x2, 
E_VNx8QImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6934; /* aarch64_sve_revbhw_vnx8qivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6953; /* aarch64_sve_revbhw_vnx8qivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6972; /* aarch64_sve_revbhw_vnx8qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4QImode:
              switch (pattern995 (x2, 
E_VNx4QImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6935; /* aarch64_sve_revbhw_vnx4qivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6954; /* aarch64_sve_revbhw_vnx4qivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6973; /* aarch64_sve_revbhw_vnx4qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2QImode:
              switch (pattern995 (x2, 
E_VNx2QImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6936; /* aarch64_sve_revbhw_vnx2qivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6955; /* aarch64_sve_revbhw_vnx2qivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6974; /* aarch64_sve_revbhw_vnx2qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HImode:
              switch (pattern995 (x2, 
E_VNx8HImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6937; /* aarch64_sve_revbhw_vnx8hivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6956; /* aarch64_sve_revbhw_vnx8hivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6975; /* aarch64_sve_revbhw_vnx8hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HImode:
              switch (pattern995 (x2, 
E_VNx4HImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6938; /* aarch64_sve_revbhw_vnx4hivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6957; /* aarch64_sve_revbhw_vnx4hivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6976; /* aarch64_sve_revbhw_vnx4hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HImode:
              switch (pattern995 (x2, 
E_VNx2HImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6939; /* aarch64_sve_revbhw_vnx2hivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6958; /* aarch64_sve_revbhw_vnx2hivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6977; /* aarch64_sve_revbhw_vnx2hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern995 (x2, 
E_VNx4SImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6940; /* aarch64_sve_revbhw_vnx4sivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6959; /* aarch64_sve_revbhw_vnx4sivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6978; /* aarch64_sve_revbhw_vnx4sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SImode:
              switch (pattern995 (x2, 
E_VNx2SImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6941; /* aarch64_sve_revbhw_vnx2sivnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6960; /* aarch64_sve_revbhw_vnx2sivnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6979; /* aarch64_sve_revbhw_vnx2sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern995 (x2, 
E_VNx2DImode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6942; /* aarch64_sve_revbhw_vnx2divnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6961; /* aarch64_sve_revbhw_vnx2divnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6980; /* aarch64_sve_revbhw_vnx2divnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HFmode:
              switch (pattern995 (x2, 
E_VNx8HFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6943; /* aarch64_sve_revbhw_vnx8hfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6962; /* aarch64_sve_revbhw_vnx8hfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6981; /* aarch64_sve_revbhw_vnx8hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HFmode:
              switch (pattern995 (x2, 
E_VNx4HFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6944; /* aarch64_sve_revbhw_vnx4hfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6963; /* aarch64_sve_revbhw_vnx4hfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6982; /* aarch64_sve_revbhw_vnx4hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HFmode:
              switch (pattern995 (x2, 
E_VNx2HFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6945; /* aarch64_sve_revbhw_vnx2hfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6964; /* aarch64_sve_revbhw_vnx2hfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6983; /* aarch64_sve_revbhw_vnx2hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx8BFmode:
              switch (pattern995 (x2, 
E_VNx8BFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6946; /* aarch64_sve_revbhw_vnx8bfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6965; /* aarch64_sve_revbhw_vnx8bfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6984; /* aarch64_sve_revbhw_vnx8bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4BFmode:
              switch (pattern995 (x2, 
E_VNx4BFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6947; /* aarch64_sve_revbhw_vnx4bfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6966; /* aarch64_sve_revbhw_vnx4bfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6985; /* aarch64_sve_revbhw_vnx4bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2BFmode:
              switch (pattern995 (x2, 
E_VNx2BFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6948; /* aarch64_sve_revbhw_vnx2bfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6967; /* aarch64_sve_revbhw_vnx2bfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6986; /* aarch64_sve_revbhw_vnx2bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SFmode:
              switch (pattern995 (x2, 
E_VNx4SFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6949; /* aarch64_sve_revbhw_vnx4sfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6968; /* aarch64_sve_revbhw_vnx4sfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6987; /* aarch64_sve_revbhw_vnx4sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SFmode:
              switch (pattern995 (x2, 
E_VNx2SFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6950; /* aarch64_sve_revbhw_vnx2sfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6969; /* aarch64_sve_revbhw_vnx2sfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6988; /* aarch64_sve_revbhw_vnx2sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DFmode:
              switch (pattern995 (x2, 
E_VNx2DFmode))
                {
                case 0:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6951; /* aarch64_sve_revbhw_vnx2dfvnx8bi */

                case 1:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6970; /* aarch64_sve_revbhw_vnx2dfvnx4bi */

                case 2:
                  if (!
#line 3348 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6989; /* aarch64_sve_revbhw_vnx2dfvnx2bi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 26:
          if (pattern942 (x2) != 0
              || !
#line 3465 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12677; /* aarch64_pred_urecpevnx4si */

        case 111:
          if (pattern942 (x2) != 0
              || !
#line 3465 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12678; /* aarch64_pred_ursqrtevnx4si */

        case 317:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1057 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12828; /* aarch64_pred_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1057 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12829; /* aarch64_pred_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1057 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12830; /* aarch64_pred_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1057 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12831; /* aarch64_pred_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1057 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12832; /* aarch64_pred_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1057 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12833; /* aarch64_pred_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1057 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12834; /* aarch64_pred_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1057 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12835; /* aarch64_pred_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_58 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4855; /* aarch64_trn2v8qi */

    case 1:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4867; /* aarch64_trn2v16qi */

    case 2:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4879; /* aarch64_trn2v4hi */

    case 3:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4891; /* aarch64_trn2v8hi */

    case 4:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4903; /* aarch64_trn2v2si */

    case 5:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4915; /* aarch64_trn2v4si */

    case 6:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4921; /* aarch64_trn2v2di */

    case 7:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4933; /* aarch64_trn2v4hf */

    case 8:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4945; /* aarch64_trn2v8hf */

    case 9:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4957; /* aarch64_trn2v4bf */

    case 10:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4969; /* aarch64_trn2v8bf */

    case 11:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4981; /* aarch64_trn2v2sf */

    case 12:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4993; /* aarch64_trn2v4sf */

    case 13:
      if (!
#line 8636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4999; /* aarch64_trn2v2df */

    case 14:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10544; /* aarch64_sve_trn2vnx16qi */

    case 15:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10554; /* aarch64_sve_trn2vnx8qi */

    case 16:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10564; /* aarch64_sve_trn2vnx4qi */

    case 17:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10574; /* aarch64_sve_trn2vnx2qi */

    case 18:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10584; /* aarch64_sve_trn2vnx8hi */

    case 19:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10594; /* aarch64_sve_trn2vnx4hi */

    case 20:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10604; /* aarch64_sve_trn2vnx2hi */

    case 21:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10614; /* aarch64_sve_trn2vnx4si */

    case 22:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10624; /* aarch64_sve_trn2vnx2si */

    case 23:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10634; /* aarch64_sve_trn2vnx2di */

    case 24:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10644; /* aarch64_sve_trn2vnx8hf */

    case 25:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10654; /* aarch64_sve_trn2vnx4hf */

    case 26:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10664; /* aarch64_sve_trn2vnx2hf */

    case 27:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10674; /* aarch64_sve_trn2vnx8bf */

    case 28:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10684; /* aarch64_sve_trn2vnx4bf */

    case 29:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10694; /* aarch64_sve_trn2vnx2bf */

    case 30:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10704; /* aarch64_sve_trn2vnx4sf */

    case 31:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10714; /* aarch64_sve_trn2vnx2sf */

    case 32:
      if (!
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10724; /* aarch64_sve_trn2vnx2df */

    case 33:
      if (!
#line 9336 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10805; /* aarch64_sve_trn2vnx16bi */

    case 34:
      if (!
#line 9336 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10811; /* aarch64_sve_trn2vnx8bi */

    case 35:
      if (!
#line 9336 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10817; /* aarch64_sve_trn2vnx4bi */

    case 36:
      if (!
#line 9336 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10823; /* aarch64_sve_trn2vnx2bi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern77 (x3, 
E_V8QImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3312; /* aarch64_suqaddv8qi */

        case E_V16QImode:
          if (pattern77 (x3, 
E_V16QImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3318; /* aarch64_suqaddv16qi */

        case E_V4HImode:
          if (pattern77 (x3, 
E_V4HImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3320; /* aarch64_suqaddv4hi */

        case E_V8HImode:
          if (pattern77 (x3, 
E_V8HImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3326; /* aarch64_suqaddv8hi */

        case E_V2SImode:
          if (pattern77 (x3, 
E_V2SImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3328; /* aarch64_suqaddv2si */

        case E_V4SImode:
          if (pattern77 (x3, 
E_V4SImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3334; /* aarch64_suqaddv4si */

        case E_V2DImode:
          if (pattern77 (x3, 
E_V2DImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3336; /* aarch64_suqaddv2di */

        case E_QImode:
          if (pattern77 (x3, 
E_QImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3338; /* aarch64_suqaddqi */

        case E_HImode:
          if (pattern77 (x3, 
E_HImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3340; /* aarch64_suqaddhi */

        case E_SImode:
          if (pattern77 (x3, 
E_SImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3342; /* aarch64_suqaddsi */

        case E_DImode:
          if (pattern77 (x3, 
E_DImode) != 0
              || !
#line 5382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3344; /* aarch64_suqadddi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern795 (x3, 
E_VNx16QImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11633; /* aarch64_sve_suqaddvnx16qi_const */

        case E_VNx8HImode:
          if (pattern795 (x3, 
E_VNx8HImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11634; /* aarch64_sve_suqaddvnx8hi_const */

        case E_VNx4SImode:
          if (pattern795 (x3, 
E_VNx4SImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11635; /* aarch64_sve_suqaddvnx4si_const */

        case E_VNx2DImode:
          if (pattern795 (x3, 
E_VNx2DImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11636; /* aarch64_sve_suqaddvnx2di_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!(
#line 7445 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1101; /* fmin_nanhf3 */

    case 1:
      if (!
#line 7445 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1105; /* fmin_nansf3 */

    case 2:
      if (!
#line 7445 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1109; /* fmin_nandf3 */

    case 3:
      if (!(
#line 3363 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2685; /* fmin_nanv4hf3 */

    case 4:
      if (!(
#line 3363 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2695; /* fmin_nanv8hf3 */

    case 5:
      if (!
#line 3363 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2701; /* fmin_nanv2sf3 */

    case 6:
      if (!
#line 3363 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2711; /* fmin_nanv4sf3 */

    case 7:
      if (!
#line 3363 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2715; /* fmin_nanv2df3 */

    case 8:
      if (!(
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12305; /* *aarch64_sve_fminvnx16bf */

    case 9:
      if (!(
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12309; /* *aarch64_sve_fminvnx32bf */

    case 10:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12313; /* *aarch64_sve_fminvnx16hf */

    case 11:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12317; /* *aarch64_sve_fminvnx8sf */

    case 12:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12321; /* *aarch64_sve_fminvnx4df */

    case 13:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12325; /* *aarch64_sve_fminvnx32hf */

    case 14:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12329; /* *aarch64_sve_fminvnx16sf */

    case 15:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12333; /* *aarch64_sve_fminvnx8df */

    case 16:
      if (!(
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12337; /* aarch64_sve_single_fminvnx16bf */

    case 17:
      if (!(
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12341; /* aarch64_sve_single_fminvnx32bf */

    case 18:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12345; /* aarch64_sve_single_fminvnx16hf */

    case 19:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12349; /* aarch64_sve_single_fminvnx8sf */

    case 20:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12353; /* aarch64_sve_single_fminvnx4df */

    case 21:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12357; /* aarch64_sve_single_fminvnx32hf */

    case 22:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12361; /* aarch64_sve_single_fminvnx16sf */

    case 23:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12365; /* aarch64_sve_single_fminvnx8df */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern114 (x1))
    {
    case 0:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6541; /* extract_after_last_vnx16qi */

    case 1:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6543; /* extract_after_last_vnx8qi */

    case 2:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6545; /* extract_after_last_vnx4qi */

    case 3:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6547; /* extract_after_last_vnx2qi */

    case 4:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6549; /* extract_after_last_vnx8hi */

    case 5:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6551; /* extract_after_last_vnx4hi */

    case 6:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6553; /* extract_after_last_vnx2hi */

    case 7:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6555; /* extract_after_last_vnx4si */

    case 8:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6557; /* extract_after_last_vnx2si */

    case 9:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6559; /* extract_after_last_vnx2di */

    case 10:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6561; /* extract_after_last_vnx8hf */

    case 11:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6563; /* extract_after_last_vnx4hf */

    case 12:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6565; /* extract_after_last_vnx2hf */

    case 13:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6567; /* extract_after_last_vnx8bf */

    case 14:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6569; /* extract_after_last_vnx4bf */

    case 15:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6571; /* extract_after_last_vnx2bf */

    case 16:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6573; /* extract_after_last_vnx4sf */

    case 17:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6575; /* extract_after_last_vnx2sf */

    case 18:
      if (!
#line 3164 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6577; /* extract_after_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern124 (x3, 
E_V8HImode, 
E_V8QImode) != 0
              || !
#line 5048 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3221; /* aarch64_pmullv8qi */

        case E_TImode:
          if (pattern124 (x3, 
E_TImode, 
E_DImode) != 0
              || !
#line 9827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5242; /* aarch64_crypto_pmulldi */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V8QImode)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_V8QImode
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!vect_par_cnst_hi_half (operands[3], E_V16QImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      x9 = XEXP (x5, 1);
      if (!rtx_equal_p (x9, operands[3])
          || !
#line 5063 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3222; /* aarch64_pmull_hiv16qi_insn */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3714; /* aarch64_sqrshlv8qi */

    case 1:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3722; /* aarch64_sqrshlv16qi */

    case 2:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3730; /* aarch64_sqrshlv4hi */

    case 3:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3738; /* aarch64_sqrshlv8hi */

    case 4:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3746; /* aarch64_sqrshlv2si */

    case 5:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3754; /* aarch64_sqrshlv4si */

    case 6:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3758; /* aarch64_sqrshlv2di */

    case 7:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3762; /* aarch64_sqrshlqi */

    case 8:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3766; /* aarch64_sqrshlhi */

    case 9:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3770; /* aarch64_sqrshlsi */

    case 10:
      if (!
#line 6523 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3778; /* aarch64_sqrshldi */

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern118 (x1))
    {
    case 0:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9027; /* *iorvnx8hf3 */

    case 1:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9030; /* *iorvnx4hf3 */

    case 2:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9033; /* *iorvnx2hf3 */

    case 3:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9036; /* *iorvnx8bf3 */

    case 4:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9039; /* *iorvnx4bf3 */

    case 5:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9042; /* *iorvnx2bf3 */

    case 6:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9045; /* *iorvnx4sf3 */

    case 7:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9048; /* *iorvnx2sf3 */

    case 8:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9051; /* *iorvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12885; /* aarch64_sve_uzpvnx32qi */

    case 1:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12887; /* aarch64_sve_uzpvnx16hi */

    case 2:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12889; /* aarch64_sve_uzpvnx8si */

    case 3:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12891; /* aarch64_sve_uzpvnx4di */

    case 4:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12893; /* aarch64_sve_uzpvnx16bf */

    case 5:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12895; /* aarch64_sve_uzpvnx16hf */

    case 6:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12897; /* aarch64_sve_uzpvnx8sf */

    case 7:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12899; /* aarch64_sve_uzpvnx4df */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern98 (x1))
    {
    case 0:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3644; /* aarch64_sshlv8qi */

    case 1:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3656; /* aarch64_sshlv16qi */

    case 2:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3660; /* aarch64_sshlv4hi */

    case 3:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3672; /* aarch64_sshlv8hi */

    case 4:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3676; /* aarch64_sshlv2si */

    case 5:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3688; /* aarch64_sshlv4si */

    case 6:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3692; /* aarch64_sshlv2di */

    case 7:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3696; /* aarch64_sshldi */

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  switch (pattern708 ())
    {
    case 0:
      if (!
#line 191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11168; /* aarch64_pmov_lane_from_vnx16qi */

    case 1:
      if (!
#line 191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11169; /* aarch64_pmov_lane_from_vnx8hi */

    case 2:
      if (!
#line 191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11170; /* aarch64_pmov_lane_from_vnx4si */

    case 3:
      if (!
#line 191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11171; /* aarch64_pmov_lane_from_vnx2di */

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern128 (x1))
    {
    case 0:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12153; /* aarch64_sve_umullbvnx8hi */

    case 1:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12174; /* aarch64_sve_umullbvnx4si */

    case 2:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12195; /* aarch64_sve_umullbvnx2di */

    case 3:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12203; /* aarch64_sve_umullb_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12209; /* aarch64_sve_umullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12949; /* aarch64_sve_bextvnx16qi */

    case 1:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12952; /* aarch64_sve_bextvnx8hi */

    case 2:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12955; /* aarch64_sve_bextvnx4si */

    case 3:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12958; /* aarch64_sve_bextvnx2di */

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12562; /* aarch64_sve_sqcadd270vnx16qi */

    case 1:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12566; /* aarch64_sve_sqcadd270vnx8hi */

    case 2:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12570; /* aarch64_sve_sqcadd270vnx4si */

    case 3:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12574; /* aarch64_sve_sqcadd270vnx2di */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern109 (x1))
    {
    case 0:
      if (!
#line 10081 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5320; /* aarch64_f2cvtlv8hf */

    case 1:
      if (!
#line 10081 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5322; /* aarch64_f2cvtlv8bf */

    case 2:
      if (!
#line 10094 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5324; /* aarch64_f2cvtlv8hf_high */

    case 3:
      if (!
#line 10094 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5326; /* aarch64_f2cvtlv8bf_high */

    default:
      return -1;
    }
}

 int
recog_200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1122 (x2))
        {
        case 0:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10877; /* *cond_fixuns_trunc_nontruncvnx8hfvnx8hi_relaxed */
          break;

        case 1:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10879; /* *cond_fixuns_trunc_nontruncvnx4sfvnx8hi_relaxed */
          break;

        case 2:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10881; /* *cond_fixuns_trunc_nontruncvnx2dfvnx8hi_relaxed */
          break;

        case 3:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10883; /* *cond_fixuns_trunc_nontruncvnx8hfvnx4si_relaxed */
          break;

        case 4:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10885; /* *cond_fixuns_trunc_nontruncvnx4sfvnx4si_relaxed */
          break;

        case 5:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10887; /* *cond_fixuns_trunc_nontruncvnx2dfvnx4si_relaxed */
          break;

        case 6:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10889; /* *cond_fixuns_trunc_nontruncvnx8hfvnx2di_relaxed */
          break;

        case 7:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10891; /* *cond_fixuns_trunc_nontruncvnx4sfvnx2di_relaxed */
          break;

        case 8:
          if (
#line 9511 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10893; /* *cond_fixuns_trunc_nontruncvnx2dfvnx2di_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1123 (x2))
        {
        case 0:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10895; /* *cond_fixuns_trunc_nontruncvnx8hfvnx8hi_strict */
          break;

        case 1:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10897; /* *cond_fixuns_trunc_nontruncvnx4sfvnx8hi_strict */
          break;

        case 2:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10899; /* *cond_fixuns_trunc_nontruncvnx2dfvnx8hi_strict */
          break;

        case 3:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10901; /* *cond_fixuns_trunc_nontruncvnx8hfvnx4si_strict */
          break;

        case 4:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10903; /* *cond_fixuns_trunc_nontruncvnx4sfvnx4si_strict */
          break;

        case 5:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10905; /* *cond_fixuns_trunc_nontruncvnx2dfvnx4si_strict */
          break;

        case 6:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10907; /* *cond_fixuns_trunc_nontruncvnx8hfvnx2di_strict */
          break;

        case 7:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10909; /* *cond_fixuns_trunc_nontruncvnx4sfvnx2di_strict */
          break;

        case 8:
          if (
#line 9534 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10911; /* *cond_fixuns_trunc_nontruncvnx2dfvnx2di_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
      || pattern1124 (x2, 
E_VNx2DFmode, 
E_VNx4SImode) != 0
      || !
#line 9568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 10913; /* *cond_fixuns_trunc_truncvnx2dfvnx4si */
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11836; /* *cond_uqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11844; /* *cond_uqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11852; /* *cond_uqshlvnx16qi_any */
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11687; /* *cond_urshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11734; /* *cond_urshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11774; /* *cond_urshlvnx16qi_any */
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11697; /* *cond_uqrshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11742; /* *cond_uqrshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11782; /* *cond_uqrshlvnx8hi_any */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11683; /* *cond_uhaddvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11730; /* *cond_uhaddvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11770; /* *cond_uhaddvnx16qi_any */
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11703; /* *cond_sqrshlvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11747; /* *cond_sqrshlvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11787; /* *cond_sqrshlvnx4si_any */
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1107 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8547; /* *cond_mulvnx8bf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8693; /* *cond_mulvnx8bf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8797; /* *cond_mulvnx8bf_any_relaxed */

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8560; /* *cond_mulvnx8hf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8706; /* *cond_mulvnx8hf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8810; /* *cond_mulvnx8hf_any_relaxed */

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8573; /* *cond_mulvnx4sf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8719; /* *cond_mulvnx4sf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8823; /* *cond_mulvnx4sf_any_relaxed */

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8586; /* *cond_mulvnx2df_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8732; /* *cond_mulvnx2df_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8836; /* *cond_mulvnx2df_any_relaxed */

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8647; /* *cond_mulvnx8hf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8897; /* *cond_mulvnx8hf_any_const_relaxed */

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8654; /* *cond_mulvnx4sf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8904; /* *cond_mulvnx4sf_any_const_relaxed */

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8661; /* *cond_mulvnx2df_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8911; /* *cond_mulvnx2df_any_const_relaxed */

        default:
          return -1;
        }

    case 1L:
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern1107 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8599; /* *cond_mulvnx8bf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8745; /* *cond_mulvnx8bf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8849; /* *cond_mulvnx8bf_any_strict */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8612; /* *cond_mulvnx8hf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8758; /* *cond_mulvnx8hf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8862; /* *cond_mulvnx8hf_any_strict */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8625; /* *cond_mulvnx4sf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8771; /* *cond_mulvnx4sf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8875; /* *cond_mulvnx4sf_any_strict */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8638; /* *cond_mulvnx2df_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8784; /* *cond_mulvnx2df_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8888; /* *cond_mulvnx2df_any_strict */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5592 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8668; /* *cond_mulvnx8hf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8918; /* *cond_mulvnx8hf_any_const_strict */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5592 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8675; /* *cond_mulvnx4sf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8925; /* *cond_mulvnx4sf_any_const_strict */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5592 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8682; /* *cond_mulvnx2df_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8932; /* *cond_mulvnx2df_any_const_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XINT (x3, 1))
    {
    case 299:
      return recog_195 (x1, insn, pnum_clobbers);

    case 351:
      return recog_196 (x1, insn, pnum_clobbers);

    case 380:
      switch (pattern871 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7239; /* *cond_negvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7305; /* *cond_negvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7250; /* *cond_negvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7316; /* *cond_negvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7261; /* *cond_negvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7327; /* *cond_negvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7272; /* *cond_negvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7338; /* *cond_negvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7283; /* *cond_negvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7349; /* *cond_negvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7294; /* *cond_negvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7360; /* *cond_negvnx2df_any_strict */

        default:
          return -1;
        }

    case 383:
      switch (pattern871 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7240; /* *cond_frecpxvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7306; /* *cond_frecpxvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7251; /* *cond_frecpxvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7317; /* *cond_frecpxvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7262; /* *cond_frecpxvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7328; /* *cond_frecpxvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7273; /* *cond_frecpxvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7339; /* *cond_frecpxvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7284; /* *cond_frecpxvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7350; /* *cond_frecpxvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7295; /* *cond_frecpxvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7361; /* *cond_frecpxvnx2df_any_strict */

        default:
          return -1;
        }

    case 384:
      switch (pattern871 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7241; /* *cond_roundvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7307; /* *cond_roundvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7252; /* *cond_roundvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7318; /* *cond_roundvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7263; /* *cond_roundvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7329; /* *cond_roundvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7274; /* *cond_roundvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7340; /* *cond_roundvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7285; /* *cond_roundvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7351; /* *cond_roundvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7296; /* *cond_roundvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7362; /* *cond_roundvnx2df_any_strict */

        default:
          return -1;
        }

    case 385:
      switch (pattern871 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7242; /* *cond_nearbyintvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7308; /* *cond_nearbyintvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7253; /* *cond_nearbyintvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7319; /* *cond_nearbyintvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7264; /* *cond_nearbyintvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7330; /* *cond_nearbyintvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7275; /* *cond_nearbyintvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7341; /* *cond_nearbyintvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7286; /* *cond_nearbyintvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7352; /* *cond_nearbyintvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7297; /* *cond_nearbyintvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7363; /* *cond_nearbyintvnx2df_any_strict */

        default:
          return -1;
        }

    case 386:
      switch (pattern871 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7243; /* *cond_floorvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7309; /* *cond_floorvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7254; /* *cond_floorvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7320; /* *cond_floorvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7265; /* *cond_floorvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7331; /* *cond_floorvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7276; /* *cond_floorvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7342; /* *cond_floorvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7287; /* *cond_floorvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7353; /* *cond_floorvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7298; /* *cond_floorvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7364; /* *cond_floorvnx2df_any_strict */

        default:
          return -1;
        }

    case 387:
      return recog_206 (x1, insn, pnum_clobbers);

    case 388:
      return recog_205 (x1, insn, pnum_clobbers);

    case 389:
      return recog_204 (x1, insn, pnum_clobbers);

    case 390:
      return recog_203 (x1, insn, pnum_clobbers);

    case 392:
      return recog_202 (x1, insn, pnum_clobbers);

    case 369:
      return recog_201 (x1, insn, pnum_clobbers);

    case 370:
      return recog_200 (x1, insn, pnum_clobbers);

    case 394:
      return recog_199 (x1, insn, pnum_clobbers);

    case 397:
      return recog_198 (x1, insn, pnum_clobbers);

    case 368:
      return recog_197 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern856 (x2))
        {
        case 0:
          if (!
#line 2894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12541; /* *cond_sadalpvnx8hi_2 */

        case 1:
          if (!
#line 2894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12543; /* *cond_sadalpvnx4si_2 */

        case 2:
          if (!
#line 2894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12545; /* *cond_sadalpvnx2di_2 */

        case 3:
          if (!
#line 2917 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12547; /* *cond_sadalpvnx8hi_z */

        case 4:
          if (!
#line 2917 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12549; /* *cond_sadalpvnx4si_z */

        case 5:
          if (!
#line 2917 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12551; /* *cond_sadalpvnx2di_z */

        default:
          return -1;
        }

    case 103:
      switch (pattern856 (x2))
        {
        case 0:
          if (!
#line 2894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12542; /* *cond_uadalpvnx8hi_2 */

        case 1:
          if (!
#line 2894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12544; /* *cond_uadalpvnx4si_2 */

        case 2:
          if (!
#line 2894 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12546; /* *cond_uadalpvnx2di_2 */

        case 3:
          if (!
#line 2917 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12548; /* *cond_uadalpvnx8hi_z */

        case 4:
          if (!
#line 2917 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12550; /* *cond_uadalpvnx4si_z */

        case 5:
          if (!
#line 2917 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12552; /* *cond_uadalpvnx2di_z */

        default:
          return -1;
        }

    case 438:
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4SFmode:
              if (pattern1162 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
                  || !
#line 3178 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12641; /* *cond_fcvtltvnx4sf_relaxed */

            case E_VNx2DFmode:
              if (pattern1162 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
                  || !
#line 3178 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12642; /* *cond_fcvtltvnx2df_relaxed */

            default:
              return -1;
            }

        case 1L:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4SFmode:
              if (pattern1162 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
                  || !
#line 3197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12643; /* *cond_fcvtltvnx4sf_strict */

            case E_VNx2DFmode:
              if (pattern1162 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
                  || !
#line 3197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12644; /* *cond_fcvtltvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 440:
      if (GET_MODE (x3) != E_VNx4SFmode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 0L:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          if (!
#line 3279 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 12656; /* *cond_fcvtxvnx4sf_any_relaxed */

        case 1L:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1])
              || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 12657; /* *cond_fcvtxvnx4sf_any_strict */

        default:
          return -1;
        }

    case 442:
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern1163 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 3563 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12684; /* *cond_flogbvnx8hf */

            case E_VNx4SImode:
              if (pattern1163 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 3563 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12685; /* *cond_flogbvnx4sf */

            case E_VNx2DImode:
              if (pattern1163 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 3563 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12686; /* *cond_flogbvnx2df */

            default:
              return -1;
            }

        case 1L:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern1163 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 3586 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12687; /* *cond_flogbvnx8hf_strict */

            case E_VNx4SImode:
              if (pattern1163 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 3586 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12688; /* *cond_flogbvnx4sf_strict */

            case E_VNx2DImode:
              if (pattern1163 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 3586 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12689; /* *cond_flogbvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern735 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7498; /* *cond_usaddvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7668; /* *cond_usaddvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7838; /* *cond_usaddvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7515; /* *cond_usaddvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7685; /* *cond_usaddvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7855; /* *cond_usaddvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7532; /* *cond_usaddvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7702; /* *cond_usaddvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7872; /* *cond_usaddvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7549; /* *cond_usaddvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7719; /* *cond_usaddvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7889; /* *cond_usaddvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7566; /* *cond_usaddvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7736; /* *cond_usaddvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7906; /* *cond_usaddvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7583; /* *cond_usaddvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7753; /* *cond_usaddvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7923; /* *cond_usaddvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7600; /* *cond_usaddvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7770; /* *cond_usaddvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7940; /* *cond_usaddvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7617; /* *cond_usaddvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7787; /* *cond_usaddvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7957; /* *cond_usaddvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7634; /* *cond_usaddvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7804; /* *cond_usaddvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7974; /* *cond_usaddvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7651; /* *cond_usaddvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7821; /* *cond_usaddvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7991; /* *cond_usaddvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern595 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6749; /* *cond_qnegvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6839; /* *cond_qnegvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6758; /* *cond_qnegvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6848; /* *cond_qnegvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6767; /* *cond_qnegvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6857; /* *cond_qnegvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6776; /* *cond_qnegvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6866; /* *cond_qnegvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6785; /* *cond_qnegvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6875; /* *cond_qnegvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6794; /* *cond_qnegvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6884; /* *cond_qnegvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6803; /* *cond_qnegvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6893; /* *cond_qnegvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6812; /* *cond_qnegvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6902; /* *cond_qnegvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6821; /* *cond_qnegvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6911; /* *cond_qnegvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6830; /* *cond_qnegvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6920; /* *cond_qnegvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (pattern802 (x3, 
E_VNx32QImode, 
E_VNx16BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6316; /* vec_mask_store_lanesvnx32qivnx16qi */

    case E_VNx16HImode:
      if (pattern802 (x3, 
E_VNx16HImode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6317; /* vec_mask_store_lanesvnx16hivnx8hi */

    case E_VNx8SImode:
      if (pattern802 (x3, 
E_VNx8SImode, 
E_VNx4BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6318; /* vec_mask_store_lanesvnx8sivnx4si */

    case E_VNx4DImode:
      if (pattern802 (x3, 
E_VNx4DImode, 
E_VNx2BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6319; /* vec_mask_store_lanesvnx4divnx2di */

    case E_VNx16BFmode:
      if (pattern802 (x3, 
E_VNx16BFmode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6320; /* vec_mask_store_lanesvnx16bfvnx8bf */

    case E_VNx16HFmode:
      if (pattern802 (x3, 
E_VNx16HFmode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6321; /* vec_mask_store_lanesvnx16hfvnx8hf */

    case E_VNx8SFmode:
      if (pattern802 (x3, 
E_VNx8SFmode, 
E_VNx4BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6322; /* vec_mask_store_lanesvnx8sfvnx4sf */

    case E_VNx4DFmode:
      if (pattern802 (x3, 
E_VNx4DFmode, 
E_VNx2BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6323; /* vec_mask_store_lanesvnx4dfvnx2df */

    case E_VNx48QImode:
      if (pattern802 (x3, 
E_VNx48QImode, 
E_VNx16BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6324; /* vec_mask_store_lanesvnx48qivnx16qi */

    case E_VNx24HImode:
      if (pattern802 (x3, 
E_VNx24HImode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6325; /* vec_mask_store_lanesvnx24hivnx8hi */

    case E_VNx12SImode:
      if (pattern802 (x3, 
E_VNx12SImode, 
E_VNx4BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6326; /* vec_mask_store_lanesvnx12sivnx4si */

    case E_VNx6DImode:
      if (pattern802 (x3, 
E_VNx6DImode, 
E_VNx2BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6327; /* vec_mask_store_lanesvnx6divnx2di */

    case E_VNx24BFmode:
      if (pattern802 (x3, 
E_VNx24BFmode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6328; /* vec_mask_store_lanesvnx24bfvnx8bf */

    case E_VNx24HFmode:
      if (pattern802 (x3, 
E_VNx24HFmode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6329; /* vec_mask_store_lanesvnx24hfvnx8hf */

    case E_VNx12SFmode:
      if (pattern802 (x3, 
E_VNx12SFmode, 
E_VNx4BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6330; /* vec_mask_store_lanesvnx12sfvnx4sf */

    case E_VNx6DFmode:
      if (pattern802 (x3, 
E_VNx6DFmode, 
E_VNx2BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6331; /* vec_mask_store_lanesvnx6dfvnx2df */

    case E_VNx64QImode:
      if (pattern802 (x3, 
E_VNx64QImode, 
E_VNx16BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6332; /* vec_mask_store_lanesvnx64qivnx16qi */

    case E_VNx32HImode:
      if (pattern802 (x3, 
E_VNx32HImode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6333; /* vec_mask_store_lanesvnx32hivnx8hi */

    case E_VNx16SImode:
      if (pattern802 (x3, 
E_VNx16SImode, 
E_VNx4BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6334; /* vec_mask_store_lanesvnx16sivnx4si */

    case E_VNx8DImode:
      if (pattern802 (x3, 
E_VNx8DImode, 
E_VNx2BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6335; /* vec_mask_store_lanesvnx8divnx2di */

    case E_VNx32BFmode:
      if (pattern802 (x3, 
E_VNx32BFmode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6336; /* vec_mask_store_lanesvnx32bfvnx8bf */

    case E_VNx32HFmode:
      if (pattern802 (x3, 
E_VNx32HFmode, 
E_VNx8BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6337; /* vec_mask_store_lanesvnx32hfvnx8hf */

    case E_VNx16SFmode:
      if (pattern802 (x3, 
E_VNx16SFmode, 
E_VNx4BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6338; /* vec_mask_store_lanesvnx16sfvnx4sf */

    case E_VNx8DFmode:
      if (pattern802 (x3, 
E_VNx8DFmode, 
E_VNx2BImode) != 0
          || !
#line 2378 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6339; /* vec_mask_store_lanesvnx8dfvnx2df */

    default:
      return -1;
    }
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9842 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
            return -1;
          return 10972; /* aarch64_sve_fcvt_truncvnx4sfvnx8hf */

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9842 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10973; /* aarch64_sve_fcvt_truncvnx2dfvnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4SFmode:
              if (!register_operand (operands[2], E_VNx4SFmode)
                  || !
#line 9842 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                return -1;
              return 10974; /* aarch64_sve_fcvt_truncvnx4sfvnx4sf */

            case E_VNx8HFmode:
              if (!register_operand (operands[2], E_VNx8HFmode)
                  || !
#line 9999 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                return -1;
              return 10983; /* aarch64_sve_fcvt_nontruncvnx8hfvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9842 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10975; /* aarch64_sve_fcvt_truncvnx2dfvnx4sf */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (pattern880 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx8BFmode) != 0
          || !
#line 9899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
        return -1;
      return 10980; /* aarch64_sve_fcvt_truncvnx4sfvnx8bf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[2], E_VNx8HFmode)
              || !
#line 9999 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10984; /* aarch64_sve_fcvt_nontruncvnx8hfvnx2df */

        case E_VNx4SFmode:
          if (!register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9999 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10986; /* aarch64_sve_fcvt_nontruncvnx4sfvnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9990; /* while_wrsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10000; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10010; /* while_wrsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10020; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10030; /* while_wrsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10040; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10050; /* while_wrsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10060; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9982; /* while_ultsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9992; /* while_ultdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10002; /* while_ultsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10012; /* while_ultdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10022; /* while_ultsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10032; /* while_ultdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10042; /* while_ultsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10052; /* while_ultdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern188 (x1))
    {
    case 0:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11321; /* aarch64_st1vnx32qi */

    case 1:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11323; /* aarch64_st1vnx16hi */

    case 2:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11325; /* aarch64_st1vnx8si */

    case 3:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11327; /* aarch64_st1vnx4di */

    case 4:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11329; /* aarch64_st1vnx16bf */

    case 5:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11331; /* aarch64_st1vnx16hf */

    case 6:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11333; /* aarch64_st1vnx8sf */

    case 7:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11335; /* aarch64_st1vnx4df */

    case 8:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11337; /* aarch64_st1vnx64qi */

    case 9:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11339; /* aarch64_st1vnx32hi */

    case 10:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11341; /* aarch64_st1vnx16si */

    case 11:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11343; /* aarch64_st1vnx8di */

    case 12:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11345; /* aarch64_st1vnx32bf */

    case 13:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11347; /* aarch64_st1vnx32hf */

    case 14:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11349; /* aarch64_st1vnx16sf */

    case 15:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11351; /* aarch64_st1vnx8df */

    default:
      return -1;
    }
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1066 (x2))
        {
        case 0:
          if (!
#line 914 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13339; /* aarch64_sme_readvnx4di */

        case 1:
          if (!
#line 914 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13340; /* aarch64_sme_readvnx8di */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_SImode))
        return -1;
      switch (pattern1066 (x2))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13341; /* *aarch64_sme_readvnx4di_plus */

        case 1:
          if (!
#line 926 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13342; /* *aarch64_sme_readvnx8di_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern806 (x3, 
E_VNx16QImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12069; /* aarch64_sve_srivnx16qi */

    case E_VNx8HImode:
      if (pattern806 (x3, 
E_VNx8HImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12071; /* aarch64_sve_srivnx8hi */

    case E_VNx4SImode:
      if (pattern806 (x3, 
E_VNx4SImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12073; /* aarch64_sve_srivnx4si */

    case E_VNx2DImode:
      if (pattern806 (x3, 
E_VNx2DImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12075; /* aarch64_sve_srivnx2di */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (pattern880 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12681; /* aarch64_pred_flogbvnx8hf */

    case E_VNx4SImode:
      if (pattern880 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12682; /* aarch64_pred_flogbvnx4sf */

    case E_VNx2DImode:
      if (pattern880 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12683; /* aarch64_pred_flogbvnx2df */

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12576; /* aarch64_sve_cmla90vnx16qi */

    case 1:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12584; /* aarch64_sve_cmla90vnx8hi */

    case 2:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12592; /* aarch64_sve_cmla90vnx4si */

    case 3:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12600; /* aarch64_sve_cmla90vnx2di */

    case 4:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12608; /* aarch64_cmla90_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12616; /* aarch64_cmla90_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12625; /* aarch64_sve_cdot180vnx4si */

    case 1:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12629; /* aarch64_sve_cdot180vnx2di */

    case 2:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12633; /* aarch64_cdot180_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12637; /* aarch64_cdot180_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11890; /* aarch64_sve_sbcltvnx16qi */

    case 1:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11898; /* aarch64_sve_sbcltvnx8hi */

    case 2:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11906; /* aarch64_sve_sbcltvnx4si */

    case 3:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11914; /* aarch64_sve_sbcltvnx2di */

    default:
      return -1;
    }
}

 int
recog_385 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern189 (x1, 
E_VNx16BImode))
    {
    case 0:
      if (!
#line 614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11438; /* aarch64_sve_pext8 */

    case 1:
      if (!
#line 614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11439; /* aarch64_sve_pext16 */

    case 2:
      if (!
#line 614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11440; /* aarch64_sve_pext32 */

    case 3:
      if (!
#line 614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11441; /* aarch64_sve_pext64 */

    default:
      return -1;
    }
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (XVECLEN (x3, 0) != 3)
    return -1;
  switch (XINT (x3, 1))
    {
    case 140:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10141; /* while_lesivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10151; /* while_ledivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10161; /* while_lesivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10171; /* while_ledivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10181; /* while_lesivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10191; /* while_ledivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10201; /* while_lesivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10211; /* while_ledivnx2bi_ptest */

        default:
          return -1;
        }

    case 141:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10142; /* while_ultsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10152; /* while_ultdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10162; /* while_ultsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10172; /* while_ultdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10182; /* while_ultsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10192; /* while_ultdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10202; /* while_ultsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10212; /* while_ultdivnx2bi_ptest */

        default:
          return -1;
        }

    case 142:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10143; /* while_ulesivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10153; /* while_uledivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10163; /* while_ulesivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10173; /* while_uledivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10183; /* while_ulesivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10193; /* while_uledivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10203; /* while_ulesivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10213; /* while_uledivnx2bi_ptest */

        default:
          return -1;
        }

    case 143:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10144; /* while_ltsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10154; /* while_ltdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10164; /* while_ltsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10174; /* while_ltdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10184; /* while_ltsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10194; /* while_ltdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10204; /* while_ltsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10214; /* while_ltdivnx2bi_ptest */

        default:
          return -1;
        }

    case 136:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10145; /* while_gesivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10155; /* while_gedivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10165; /* while_gesivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10175; /* while_gedivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10185; /* while_gesivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10195; /* while_gedivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10205; /* while_gesivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10215; /* while_gedivnx2bi_ptest */

        default:
          return -1;
        }

    case 137:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10146; /* while_gtsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10156; /* while_gtdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10166; /* while_gtsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10176; /* while_gtdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10186; /* while_gtsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10196; /* while_gtdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10206; /* while_gtsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10216; /* while_gtdivnx2bi_ptest */

        default:
          return -1;
        }

    case 138:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10147; /* while_ugtsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10157; /* while_ugtdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10167; /* while_ugtsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10177; /* while_ugtdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10187; /* while_ugtsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10197; /* while_ugtdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10207; /* while_ugtsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10217; /* while_ugtdivnx2bi_ptest */

        default:
          return -1;
        }

    case 139:
      return recog_392 (x1, insn, pnum_clobbers);

    case 144:
      return recog_391 (x1, insn, pnum_clobbers);

    case 145:
      return recog_390 (x1, insn, pnum_clobbers);

    case 302:
      if (GET_MODE (x3) != E_VNx16BImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[5] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!register_operand (operands[3], E_VNx16BImode)
          || !
#line 10248 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 11010; /* *aarch64_brkn_ptest */

    default:
      return -1;
    }
}

 int
recog_434 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern251 (x1))
    {
    case 0:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13522; /* aarch64_sme_udotvnx4sivnx32qi */

    case 1:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13525; /* aarch64_sme_udotvnx4sivnx64qi */

    case 2:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13528; /* aarch64_sme_udotvnx4sivnx16hi */

    case 3:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13531; /* aarch64_sme_udotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13534; /* aarch64_sme_udotvnx2divnx32qi */

    case 5:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13537; /* aarch64_sme_udotvnx2divnx64qi */

    case 6:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13540; /* aarch64_sme_udotvnx2divnx16hi */

    case 7:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13543; /* aarch64_sme_udotvnx2divnx32hi */

    case 8:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13570; /* aarch64_sme_single_udotvnx4sivnx32qi */

    case 9:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13573; /* aarch64_sme_single_udotvnx4sivnx64qi */

    case 10:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13576; /* aarch64_sme_single_udotvnx4sivnx16hi */

    case 11:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13579; /* aarch64_sme_single_udotvnx4sivnx32hi */

    case 12:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13582; /* aarch64_sme_single_udotvnx2divnx32qi */

    case 13:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13585; /* aarch64_sme_single_udotvnx2divnx64qi */

    case 14:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13588; /* aarch64_sme_single_udotvnx2divnx16hi */

    case 15:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13591; /* aarch64_sme_single_udotvnx2divnx32hi */

    case 16:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13623; /* aarch64_sme_lane_udotvnx4sivnx32qi */

    case 17:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13631; /* aarch64_sme_lane_udotvnx4sivnx64qi */

    case 18:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13639; /* aarch64_sme_lane_udotvnx4sivnx16hi */

    case 19:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13647; /* aarch64_sme_lane_udotvnx4sivnx32hi */

    case 20:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13655; /* aarch64_sme_lane_udotvnx2divnx32qi */

    case 21:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13663; /* aarch64_sme_lane_udotvnx2divnx64qi */

    case 22:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13671; /* aarch64_sme_lane_udotvnx2divnx16hi */

    case 23:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13679; /* aarch64_sme_lane_udotvnx2divnx32hi */

    case 24:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13546; /* *aarch64_sme_udotvnx4sivnx32qi_plus */

    case 25:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13549; /* *aarch64_sme_udotvnx4sivnx64qi_plus */

    case 26:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13552; /* *aarch64_sme_udotvnx4sivnx16hi_plus */

    case 27:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13555; /* *aarch64_sme_udotvnx4sivnx32hi_plus */

    case 28:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13558; /* *aarch64_sme_udotvnx2divnx32qi_plus */

    case 29:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13561; /* *aarch64_sme_udotvnx2divnx64qi_plus */

    case 30:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13564; /* *aarch64_sme_udotvnx2divnx16hi_plus */

    case 31:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13567; /* *aarch64_sme_udotvnx2divnx32hi_plus */

    case 32:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13594; /* *aarch64_sme_single_udotvnx4sivnx32qi_plus */

    case 33:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13597; /* *aarch64_sme_single_udotvnx4sivnx64qi_plus */

    case 34:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13600; /* *aarch64_sme_single_udotvnx4sivnx16hi_plus */

    case 35:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13603; /* *aarch64_sme_single_udotvnx4sivnx32hi_plus */

    case 36:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13606; /* *aarch64_sme_single_udotvnx2divnx32qi_plus */

    case 37:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13609; /* *aarch64_sme_single_udotvnx2divnx64qi_plus */

    case 38:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13612; /* *aarch64_sme_single_udotvnx2divnx16hi_plus */

    case 39:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13615; /* *aarch64_sme_single_udotvnx2divnx32hi_plus */

    case 40:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13687; /* *aarch64_sme_lane_udotvnx4sivnx32qi_plus */

    case 41:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13695; /* *aarch64_sme_lane_udotvnx4sivnx64qi_plus */

    case 42:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13703; /* *aarch64_sme_lane_udotvnx4sivnx16hi_plus */

    case 43:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13711; /* *aarch64_sme_lane_udotvnx4sivnx32hi_plus */

    case 44:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13719; /* *aarch64_sme_lane_udotvnx2divnx32qi_plus */

    case 45:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13727; /* *aarch64_sme_lane_udotvnx2divnx64qi_plus */

    case 46:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13735; /* *aarch64_sme_lane_udotvnx2divnx16hi_plus */

    case 47:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13743; /* *aarch64_sme_lane_udotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 123:
      return recog_442 (x1, insn, pnum_clobbers);

    case 541:
      switch (pattern272 (x1))
        {
        case 0:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11385; /* aarch64_st1vnx32qi_strided4 */

        case 1:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11387; /* aarch64_st1vnx16hi_strided4 */

        case 2:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11389; /* aarch64_st1vnx8si_strided4 */

        case 3:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11391; /* aarch64_st1vnx4di_strided4 */

        case 4:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11393; /* aarch64_st1vnx16bf_strided4 */

        case 5:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11395; /* aarch64_st1vnx16hf_strided4 */

        case 6:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11397; /* aarch64_st1vnx8sf_strided4 */

        case 7:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11399; /* aarch64_st1vnx4df_strided4 */

        case 8:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11401; /* aarch64_st1vnx64qi_strided4 */

        case 9:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11403; /* aarch64_st1vnx32hi_strided4 */

        case 10:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11405; /* aarch64_st1vnx16si_strided4 */

        case 11:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11407; /* aarch64_st1vnx8di_strided4 */

        case 12:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11409; /* aarch64_st1vnx32bf_strided4 */

        case 13:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11411; /* aarch64_st1vnx32hf_strided4 */

        case 14:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11413; /* aarch64_st1vnx16sf_strided4 */

        case 15:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11415; /* aarch64_st1vnx8df_strided4 */

        default:
          return -1;
        }

    case 542:
      switch (pattern272 (x1))
        {
        case 0:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11386; /* aarch64_stnt1vnx32qi_strided4 */

        case 1:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11388; /* aarch64_stnt1vnx16hi_strided4 */

        case 2:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11390; /* aarch64_stnt1vnx8si_strided4 */

        case 3:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11392; /* aarch64_stnt1vnx4di_strided4 */

        case 4:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11394; /* aarch64_stnt1vnx16bf_strided4 */

        case 5:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11396; /* aarch64_stnt1vnx16hf_strided4 */

        case 6:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11398; /* aarch64_stnt1vnx8sf_strided4 */

        case 7:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11400; /* aarch64_stnt1vnx4df_strided4 */

        case 8:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11402; /* aarch64_stnt1vnx64qi_strided4 */

        case 9:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11404; /* aarch64_stnt1vnx32hi_strided4 */

        case 10:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11406; /* aarch64_stnt1vnx16si_strided4 */

        case 11:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11408; /* aarch64_stnt1vnx8di_strided4 */

        case 12:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11410; /* aarch64_stnt1vnx32bf_strided4 */

        case 13:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11412; /* aarch64_stnt1vnx32hf_strided4 */

        case 14:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11414; /* aarch64_stnt1vnx16sf_strided4 */

        case 15:
          if (!
#line 509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11416; /* aarch64_stnt1vnx8df_strided4 */

        default:
          return -1;
        }

    case 647:
      switch (pattern275 (x1))
        {
        case 0:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13018; /* aarch64_sme_ld1_horvnx16qi */

        case 1:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13020; /* aarch64_sme_ld1_horvnx8hi */

        case 2:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13022; /* aarch64_sme_ld1_horvnx4si */

        case 3:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13024; /* aarch64_sme_ld1_horvnx2di */

        case 4:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13026; /* aarch64_sme_ld1_horvnx1ti */

        case 5:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 13028; /* aarch64_sme_ld1_horvnx16qi_plus */

        case 6:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13030; /* aarch64_sme_ld1_horvnx8hi_plus */

        case 7:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13032; /* aarch64_sme_ld1_horvnx4si_plus */

        case 8:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13034; /* aarch64_sme_ld1_horvnx2di_plus */

        case 9:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 128))
            return -1;
          return 13036; /* aarch64_sme_ld1_horvnx1ti_plus */

        default:
          return -1;
        }

    case 648:
      switch (pattern275 (x1))
        {
        case 0:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13019; /* aarch64_sme_ld1_vervnx16qi */

        case 1:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13021; /* aarch64_sme_ld1_vervnx8hi */

        case 2:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13023; /* aarch64_sme_ld1_vervnx4si */

        case 3:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13025; /* aarch64_sme_ld1_vervnx2di */

        case 4:
          if (!
#line 484 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13027; /* aarch64_sme_ld1_vervnx1ti */

        case 5:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 13029; /* aarch64_sme_ld1_vervnx16qi_plus */

        case 6:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13031; /* aarch64_sme_ld1_vervnx8hi_plus */

        case 7:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13033; /* aarch64_sme_ld1_vervnx4si_plus */

        case 8:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13035; /* aarch64_sme_ld1_vervnx2di_plus */

        case 9:
          if (!
#line 499 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 128))
            return -1;
          return 13037; /* aarch64_sme_ld1_vervnx1ti_plus */

        default:
          return -1;
        }

    case 661:
      switch (pattern278 (x1))
        {
        case 0:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13043; /* aarch64_sme_st1_horvnx16qi */

        case 1:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13045; /* aarch64_sme_st1_horvnx8hi */

        case 2:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13047; /* aarch64_sme_st1_horvnx4si */

        case 3:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13049; /* aarch64_sme_st1_horvnx2di */

        case 4:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13051; /* aarch64_sme_st1_horvnx1ti */

        case 5:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13053; /* aarch64_sme_st1_horvnx16qi_plus */

        case 6:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13055; /* aarch64_sme_st1_horvnx8hi_plus */

        case 7:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13057; /* aarch64_sme_st1_horvnx4si_plus */

        case 8:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13059; /* aarch64_sme_st1_horvnx2di_plus */

        case 9:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 128))
            return -1;
          return 13061; /* aarch64_sme_st1_horvnx1ti_plus */

        default:
          return -1;
        }

    case 662:
      switch (pattern278 (x1))
        {
        case 0:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13044; /* aarch64_sme_st1_vervnx16qi */

        case 1:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13046; /* aarch64_sme_st1_vervnx8hi */

        case 2:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13048; /* aarch64_sme_st1_vervnx4si */

        case 3:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13050; /* aarch64_sme_st1_vervnx2di */

        case 4:
          if (!
#line 586 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13052; /* aarch64_sme_st1_vervnx1ti */

        case 5:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13054; /* aarch64_sme_st1_vervnx16qi_plus */

        case 6:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13056; /* aarch64_sme_st1_vervnx8hi_plus */

        case 7:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13058; /* aarch64_sme_st1_vervnx4si_plus */

        case 8:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13060; /* aarch64_sme_st1_vervnx2di_plus */

        case 9:
          if (!
#line 601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 128))
            return -1;
          return 13062; /* aarch64_sme_st1_vervnx1ti_plus */

        default:
          return -1;
        }

    case 650:
      switch (pattern284 (x1))
        {
        case 0:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13067; /* aarch64_sme_read_horvnx16qivnx16qi */

        case 1:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13099; /* aarch64_sme_read_horvnx1tivnx16qi */

        case 2:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13069; /* aarch64_sme_read_horvnx8hivnx8hi */

        case 3:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13101; /* aarch64_sme_read_horvnx1tivnx8hi */

        case 4:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13071; /* aarch64_sme_read_horvnx4sivnx4si */

        case 5:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13103; /* aarch64_sme_read_horvnx1tivnx4si */

        case 6:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13073; /* aarch64_sme_read_horvnx2divnx2di */

        case 7:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13105; /* aarch64_sme_read_horvnx1tivnx2di */

        case 8:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13075; /* aarch64_sme_read_horvnx8hivnx8bf */

        case 9:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13107; /* aarch64_sme_read_horvnx1tivnx8bf */

        case 10:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13077; /* aarch64_sme_read_horvnx8hivnx8hf */

        case 11:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13109; /* aarch64_sme_read_horvnx1tivnx8hf */

        case 12:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13079; /* aarch64_sme_read_horvnx4sivnx4sf */

        case 13:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13111; /* aarch64_sme_read_horvnx1tivnx4sf */

        case 14:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13081; /* aarch64_sme_read_horvnx2divnx2df */

        case 15:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13113; /* aarch64_sme_read_horvnx1tivnx2df */

        case 16:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 8))
            return -1;
          return 13083; /* *aarch64_sme_read_horvnx16qivnx16qi_plus */

        case 17:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13085; /* *aarch64_sme_read_horvnx8hivnx8hi_plus */

        case 18:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13087; /* *aarch64_sme_read_horvnx4sivnx4si_plus */

        case 19:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13089; /* *aarch64_sme_read_horvnx2divnx2di_plus */

        case 20:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13091; /* *aarch64_sme_read_horvnx8hivnx8bf_plus */

        case 21:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13093; /* *aarch64_sme_read_horvnx8hivnx8hf_plus */

        case 22:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13095; /* *aarch64_sme_read_horvnx4sivnx4sf_plus */

        case 23:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13097; /* *aarch64_sme_read_horvnx2divnx2df_plus */

        default:
          return -1;
        }

    case 651:
      switch (pattern284 (x1))
        {
        case 0:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13068; /* aarch64_sme_read_vervnx16qivnx16qi */

        case 1:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13100; /* aarch64_sme_read_vervnx1tivnx16qi */

        case 2:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13070; /* aarch64_sme_read_vervnx8hivnx8hi */

        case 3:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13102; /* aarch64_sme_read_vervnx1tivnx8hi */

        case 4:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13072; /* aarch64_sme_read_vervnx4sivnx4si */

        case 5:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13104; /* aarch64_sme_read_vervnx1tivnx4si */

        case 6:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13074; /* aarch64_sme_read_vervnx2divnx2di */

        case 7:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13106; /* aarch64_sme_read_vervnx1tivnx2di */

        case 8:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13076; /* aarch64_sme_read_vervnx8hivnx8bf */

        case 9:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13108; /* aarch64_sme_read_vervnx1tivnx8bf */

        case 10:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13078; /* aarch64_sme_read_vervnx8hivnx8hf */

        case 11:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13110; /* aarch64_sme_read_vervnx1tivnx8hf */

        case 12:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13080; /* aarch64_sme_read_vervnx4sivnx4sf */

        case 13:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13112; /* aarch64_sme_read_vervnx1tivnx4sf */

        case 14:
          if (!
#line 667 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13082; /* aarch64_sme_read_vervnx2divnx2df */

        case 15:
          if (!
#line 697 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13114; /* aarch64_sme_read_vervnx1tivnx2df */

        case 16:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 8))
            return -1;
          return 13084; /* *aarch64_sme_read_vervnx16qivnx16qi_plus */

        case 17:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13086; /* *aarch64_sme_read_vervnx8hivnx8hi_plus */

        case 18:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13088; /* *aarch64_sme_read_vervnx4sivnx4si_plus */

        case 19:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13090; /* *aarch64_sme_read_vervnx2divnx2di_plus */

        case 20:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13092; /* *aarch64_sme_read_vervnx8hivnx8bf_plus */

        case 21:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13094; /* *aarch64_sme_read_vervnx8hivnx8hf_plus */

        case 22:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13096; /* *aarch64_sme_read_vervnx4sivnx4sf_plus */

        case 23:
          if (!
#line 682 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13098; /* *aarch64_sme_read_vervnx2divnx2df_plus */

        default:
          return -1;
        }

    case 680:
      switch (pattern285 (x1))
        {
        case 0:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13163; /* aarch64_sme_write_horvnx16qivnx16qi */

        case 1:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13165; /* aarch64_sme_write_horvnx8hivnx8hi */

        case 2:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13171; /* aarch64_sme_write_horvnx8hivnx8bf */

        case 3:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13173; /* aarch64_sme_write_horvnx8hivnx8hf */

        case 4:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13167; /* aarch64_sme_write_horvnx4sivnx4si */

        case 5:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13175; /* aarch64_sme_write_horvnx4sivnx4sf */

        case 6:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13169; /* aarch64_sme_write_horvnx2divnx2di */

        case 7:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13177; /* aarch64_sme_write_horvnx2divnx2df */

        case 8:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13195; /* aarch64_sme_write_horvnx1tivnx16qi */

        case 9:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13197; /* aarch64_sme_write_horvnx1tivnx8hi */

        case 10:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13199; /* aarch64_sme_write_horvnx1tivnx4si */

        case 11:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13201; /* aarch64_sme_write_horvnx1tivnx2di */

        case 12:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13203; /* aarch64_sme_write_horvnx1tivnx8bf */

        case 13:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13205; /* aarch64_sme_write_horvnx1tivnx8hf */

        case 14:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13207; /* aarch64_sme_write_horvnx1tivnx4sf */

        case 15:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13209; /* aarch64_sme_write_horvnx1tivnx2df */

        case 16:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 13179; /* *aarch64_sme_write_horvnx16qivnx16qi_plus */

        case 17:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13181; /* *aarch64_sme_write_horvnx8hivnx8hi_plus */

        case 18:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13187; /* *aarch64_sme_write_horvnx8hivnx8bf_plus */

        case 19:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13189; /* *aarch64_sme_write_horvnx8hivnx8hf_plus */

        case 20:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13183; /* *aarch64_sme_write_horvnx4sivnx4si_plus */

        case 21:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13191; /* *aarch64_sme_write_horvnx4sivnx4sf_plus */

        case 22:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13185; /* *aarch64_sme_write_horvnx2divnx2di_plus */

        case 23:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13193; /* *aarch64_sme_write_horvnx2divnx2df_plus */

        default:
          return -1;
        }

    case 681:
      switch (pattern285 (x1))
        {
        case 0:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13164; /* aarch64_sme_write_vervnx16qivnx16qi */

        case 1:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13166; /* aarch64_sme_write_vervnx8hivnx8hi */

        case 2:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13172; /* aarch64_sme_write_vervnx8hivnx8bf */

        case 3:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13174; /* aarch64_sme_write_vervnx8hivnx8hf */

        case 4:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13168; /* aarch64_sme_write_vervnx4sivnx4si */

        case 5:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13176; /* aarch64_sme_write_vervnx4sivnx4sf */

        case 6:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13170; /* aarch64_sme_write_vervnx2divnx2di */

        case 7:
          if (!
#line 777 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13178; /* aarch64_sme_write_vervnx2divnx2df */

        case 8:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13196; /* aarch64_sme_write_vervnx1tivnx16qi */

        case 9:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13198; /* aarch64_sme_write_vervnx1tivnx8hi */

        case 10:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13200; /* aarch64_sme_write_vervnx1tivnx4si */

        case 11:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13202; /* aarch64_sme_write_vervnx1tivnx2di */

        case 12:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13204; /* aarch64_sme_write_vervnx1tivnx8bf */

        case 13:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13206; /* aarch64_sme_write_vervnx1tivnx8hf */

        case 14:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13208; /* aarch64_sme_write_vervnx1tivnx4sf */

        case 15:
          if (!
#line 807 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13210; /* aarch64_sme_write_vervnx1tivnx2df */

        case 16:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 13180; /* *aarch64_sme_write_vervnx16qivnx16qi_plus */

        case 17:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13182; /* *aarch64_sme_write_vervnx8hivnx8hi_plus */

        case 18:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13188; /* *aarch64_sme_write_vervnx8hivnx8bf_plus */

        case 19:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13190; /* *aarch64_sme_write_vervnx8hivnx8hf_plus */

        case 20:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13184; /* *aarch64_sme_write_vervnx4sivnx4si_plus */

        case 21:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13192; /* *aarch64_sme_write_vervnx4sivnx4sf_plus */

        case 22:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13186; /* *aarch64_sme_write_vervnx2divnx2di_plus */

        case 23:
          if (!
#line 792 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13194; /* *aarch64_sme_write_vervnx2divnx2df_plus */

        default:
          return -1;
        }

    case 635:
      switch (pattern287 (x1))
        {
        case 0:
          if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13437; /* aarch64_sme_addhavnx4si */

        case 1:
          if (!(
#line 1135 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
            return -1;
          return 13439; /* aarch64_sme_addhavnx2di */

        default:
          return -1;
        }

    case 636:
      switch (pattern287 (x1))
        {
        case 0:
          if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13438; /* aarch64_sme_addvavnx4si */

        case 1:
          if (!(
#line 1135 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
            return -1;
          return 13440; /* aarch64_sme_addvavnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_466 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern628 (x2, 
E_SImode) != 0)
            return -1;
          return 383; /* *msubsi */

        case E_DImode:
          if (pattern628 (x2, 
E_DImode) != 0)
            return -1;
          return 384; /* *msubdi */

        case E_V8QImode:
          if (pattern629 (x2, 
E_V8QImode) != 0
              || !
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2038; /* aarch64_mlsv8qi */

        case E_V16QImode:
          if (pattern629 (x2, 
E_V16QImode) != 0
              || !
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2041; /* aarch64_mlsv16qi */

        case E_V4HImode:
          if (pattern629 (x2, 
E_V4HImode) != 0
              || !
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2042; /* aarch64_mlsv4hi */

        case E_V8HImode:
          if (pattern629 (x2, 
E_V8HImode) != 0
              || !
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2045; /* aarch64_mlsv8hi */

        case E_V2SImode:
          if (pattern629 (x2, 
E_V2SImode) != 0
              || !
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2046; /* aarch64_mlsv2si */

        case E_V4SImode:
          if (pattern629 (x2, 
E_V4SImode) != 0
              || !
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2049; /* aarch64_mlsv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern749 (x2))
                {
                case 0:
                  return 393; /* msubsidi4 */

                case 1:
                  if (!
#line 2203 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2278; /* aarch64_smlslv8qi */

                case 2:
                  if (!
#line 2203 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2280; /* aarch64_smlslv4hi */

                case 3:
                  if (!
#line 2203 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2282; /* aarch64_smlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern751 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2218 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2284; /* aarch64_smlsl_nv4hi */

                case 1:
                  if (!
#line 2218 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2286; /* aarch64_smlsl_nv2si */

                case 2:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2346; /* aarch64_vec_smlsl_lane_v4hi */

                case 3:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2348; /* aarch64_vec_smlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2350; /* aarch64_vec_smlsl_lane_v2si */

                case 5:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2352; /* aarch64_vec_smlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern957 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2099 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2252; /* *aarch64_smlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2258; /* aarch64_smlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2099 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2254; /* *aarch64_smlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2260; /* aarch64_smlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2099 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2256; /* *aarch64_smlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2262; /* aarch64_smlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern959 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2146 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2264; /* aarch64_smlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2146 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2266; /* aarch64_smlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2547 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2354; /* aarch64_smlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2585 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2358; /* aarch64_smlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2547 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2356; /* aarch64_smlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2585 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2360; /* aarch64_smlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern749 (x2))
                {
                case 0:
                  return 394; /* umsubsidi4 */

                case 1:
                  if (!
#line 2203 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2279; /* aarch64_umlslv8qi */

                case 2:
                  if (!
#line 2203 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2281; /* aarch64_umlslv4hi */

                case 3:
                  if (!
#line 2203 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2283; /* aarch64_umlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern751 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2218 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2285; /* aarch64_umlsl_nv4hi */

                case 1:
                  if (!
#line 2218 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2287; /* aarch64_umlsl_nv2si */

                case 2:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2347; /* aarch64_vec_umlsl_lane_v4hi */

                case 3:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2349; /* aarch64_vec_umlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2351; /* aarch64_vec_umlsl_lane_v2si */

                case 5:
                  if (!
#line 2524 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2353; /* aarch64_vec_umlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern957 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2099 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2253; /* *aarch64_umlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2259; /* aarch64_umlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2099 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2255; /* *aarch64_umlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2261; /* aarch64_umlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2099 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2257; /* *aarch64_umlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2263; /* aarch64_umlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern959 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2146 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2265; /* aarch64_umlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2146 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2267; /* aarch64_umlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2547 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2355; /* aarch64_umlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2585 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2359; /* aarch64_umlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2547 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2357; /* aarch64_umlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2585 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2361; /* aarch64_umlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern1177 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2050; /* *aarch64_mls_eltv4hi */

                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2058; /* *aarch64_mls_elt_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1177 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2053; /* *aarch64_mls_eltv8hi */

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2061; /* *aarch64_mls_elt_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1177 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2054; /* *aarch64_mls_eltv2si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2062; /* *aarch64_mls_elt_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1177 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2057; /* *aarch64_mls_eltv4si */

                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2065; /* *aarch64_mls_elt_to_64v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x5;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern960 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2066; /* aarch64_mls_nv4hi */

            case E_V8HImode:
              if (pattern960 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2069; /* aarch64_mls_nv8hi */

            case E_V2SImode:
              if (pattern960 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2070; /* aarch64_mls_nv2si */

            case E_V4SImode:
              if (pattern960 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2073; /* aarch64_mls_nv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x11 = XVECEXP (x4, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern1140 (x2, 
E_VNx8HImode) != 0
              || !
#line 1510 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11926; /* aarch64_sve_sub_mul_lane_vnx8hi */

        case E_VNx4SImode:
          if (pattern1140 (x2, 
E_VNx4SImode) != 0
              || !
#line 1510 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11927; /* aarch64_sve_sub_mul_lane_vnx4si */

        case E_VNx2DImode:
          if (pattern1140 (x2, 
E_VNx2DImode) != 0
              || !
#line 1510 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11928; /* aarch64_sve_sub_mul_lane_vnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (XVECLEN (x4, 0) == 1)
    {
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern824 (x2, 
E_V8QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1261; /* aarch64_dup_lanev8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1275; /* aarch64_dup_lane_to_128v8qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V16QImode:
          if (pattern824 (x2, 
E_V16QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1262; /* aarch64_dup_lanev16qi */
                  break;

                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1276; /* aarch64_dup_lane_to_64v16qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4HImode:
          if (pattern824 (x2, 
E_V4HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1263; /* aarch64_dup_lanev4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1277; /* aarch64_dup_lane_to_128v4hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HImode:
          if (pattern824 (x2, 
E_V8HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1264; /* aarch64_dup_lanev8hi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1278; /* aarch64_dup_lane_to_64v8hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2SImode:
          if (pattern824 (x2, 
E_V2SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1265; /* aarch64_dup_lanev2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1279; /* aarch64_dup_lane_to_128v2si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SImode:
          if (pattern824 (x2, 
E_V4SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1266; /* aarch64_dup_lanev4si */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1280; /* aarch64_dup_lane_to_64v4si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DImode:
          if (pattern825 (x2, 
E_V2DImode, 
E_DImode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1267; /* aarch64_dup_lanev2di */
          break;

        case E_V4HFmode:
          if (pattern824 (x2, 
E_V4HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1268; /* aarch64_dup_lanev4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1281; /* aarch64_dup_lane_to_128v4hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HFmode:
          if (pattern824 (x2, 
E_V8HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1269; /* aarch64_dup_lanev8hf */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1282; /* aarch64_dup_lane_to_64v8hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4BFmode:
          if (pattern825 (x2, 
E_V4BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1270; /* aarch64_dup_lanev4bf */
          break;

        case E_V8BFmode:
          if (pattern825 (x2, 
E_V8BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1271; /* aarch64_dup_lanev8bf */
          break;

        case E_V2SFmode:
          if (pattern824 (x2, 
E_V2SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1272; /* aarch64_dup_lanev2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1283; /* aarch64_dup_lane_to_128v2sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern824 (x2, 
E_V4SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1273; /* aarch64_dup_lanev4sf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1284; /* aarch64_dup_lane_to_64v4sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DFmode:
          if (pattern825 (x2, 
E_V2DFmode, 
E_DFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1274; /* aarch64_dup_lanev2df */
          break;

        case E_VNx16QImode:
          if (pattern826 (x2, 
E_VNx16QImode, 
E_QImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 8 / 8, 0, 63)))
            return 10487; /* aarch64_sve_dup_lanevnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern826 (x2, 
E_VNx8QImode, 
E_QImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10488; /* aarch64_sve_dup_lanevnx8qi */
          break;

        case E_VNx4QImode:
          if (pattern826 (x2, 
E_VNx4QImode, 
E_QImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10489; /* aarch64_sve_dup_lanevnx4qi */
          break;

        case E_VNx2QImode:
          if (pattern826 (x2, 
E_VNx2QImode, 
E_QImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10490; /* aarch64_sve_dup_lanevnx2qi */
          break;

        case E_VNx8HImode:
          if (pattern826 (x2, 
E_VNx8HImode, 
E_HImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10491; /* aarch64_sve_dup_lanevnx8hi */
          break;

        case E_VNx4HImode:
          if (pattern826 (x2, 
E_VNx4HImode, 
E_HImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10492; /* aarch64_sve_dup_lanevnx4hi */
          break;

        case E_VNx2HImode:
          if (pattern826 (x2, 
E_VNx2HImode, 
E_HImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10493; /* aarch64_sve_dup_lanevnx2hi */
          break;

        case E_VNx4SImode:
          if (pattern826 (x2, 
E_VNx4SImode, 
E_SImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10494; /* aarch64_sve_dup_lanevnx4si */
          break;

        case E_VNx2SImode:
          if (pattern826 (x2, 
E_VNx2SImode, 
E_SImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10495; /* aarch64_sve_dup_lanevnx2si */
          break;

        case E_VNx2DImode:
          if (pattern826 (x2, 
E_VNx2DImode, 
E_DImode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10496; /* aarch64_sve_dup_lanevnx2di */
          break;

        case E_VNx8HFmode:
          if (pattern826 (x2, 
E_VNx8HFmode, 
E_HFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10497; /* aarch64_sve_dup_lanevnx8hf */
          break;

        case E_VNx4HFmode:
          if (pattern826 (x2, 
E_VNx4HFmode, 
E_HFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10498; /* aarch64_sve_dup_lanevnx4hf */
          break;

        case E_VNx2HFmode:
          if (pattern826 (x2, 
E_VNx2HFmode, 
E_HFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10499; /* aarch64_sve_dup_lanevnx2hf */
          break;

        case E_VNx8BFmode:
          if (pattern826 (x2, 
E_VNx8BFmode, 
E_BFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10500; /* aarch64_sve_dup_lanevnx8bf */
          break;

        case E_VNx4BFmode:
          if (pattern826 (x2, 
E_VNx4BFmode, 
E_BFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10501; /* aarch64_sve_dup_lanevnx4bf */
          break;

        case E_VNx2BFmode:
          if (pattern826 (x2, 
E_VNx2BFmode, 
E_BFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10502; /* aarch64_sve_dup_lanevnx2bf */
          break;

        case E_VNx4SFmode:
          if (pattern826 (x2, 
E_VNx4SFmode, 
E_SFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10503; /* aarch64_sve_dup_lanevnx4sf */
          break;

        case E_VNx2SFmode:
          if (pattern826 (x2, 
E_VNx2SFmode, 
E_SFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10504; /* aarch64_sve_dup_lanevnx2sf */
          break;

        case E_VNx2DFmode:
          if (pattern826 (x2, 
E_VNx2DFmode, 
E_DFmode) == 0
              && 
#line 9176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10505; /* aarch64_sve_dup_lanevnx2df */
          break;

        default:
          break;
        }
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x2) != E_VNx16QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
            return -1;
          return 6438; /* aarch64_vec_duplicate_vqvnx16qi_be */

        case E_VNx16QImode:
          if (!register_operand (operands[1], E_VNx16QImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (QImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (QImode), 0, 63)))
            return -1;
          return 10506; /* aarch64_sve_dupq_lanevnx16qi */

        default:
          return -1;
        }

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
            return -1;
          return 6439; /* aarch64_vec_duplicate_vqvnx8hi_be */

        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HImode), 0, 63)))
            return -1;
          return 10507; /* aarch64_sve_dupq_lanevnx8hi */

        default:
          return -1;
        }

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
            return -1;
          return 6440; /* aarch64_vec_duplicate_vqvnx4si_be */

        case E_VNx4SImode:
          if (!register_operand (operands[1], E_VNx4SImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SImode), 0, 63)))
            return -1;
          return 10508; /* aarch64_sve_dupq_lanevnx4si */

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
            return -1;
          return 6441; /* aarch64_vec_duplicate_vqvnx2di_be */

        case E_VNx2DImode:
          if (!register_operand (operands[1], E_VNx2DImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DImode), 0, 63)))
            return -1;
          return 10509; /* aarch64_sve_dupq_lanevnx2di */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x2) != E_VNx8BFmode
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
            return -1;
          return 6442; /* aarch64_vec_duplicate_vqvnx8bf_be */

        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (BFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (BFmode), 0, 63)))
            return -1;
          return 10510; /* aarch64_sve_dupq_lanevnx8bf */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x2) != E_VNx8HFmode
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
            return -1;
          return 6443; /* aarch64_vec_duplicate_vqvnx8hf_be */

        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HFmode), 0, 63)))
            return -1;
          return 10511; /* aarch64_sve_dupq_lanevnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
            return -1;
          return 6444; /* aarch64_vec_duplicate_vqvnx4sf_be */

        case E_VNx4SFmode:
          if (!register_operand (operands[1], E_VNx4SFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SFmode), 0, 63)))
            return -1;
          return 10512; /* aarch64_sve_dupq_lanevnx4sf */

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2822 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
            return -1;
          return 6445; /* aarch64_vec_duplicate_vqvnx2df_be */

        case E_VNx2DFmode:
          if (!register_operand (operands[1], E_VNx2DFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9204 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DFmode), 0, 63)))
            return -1;
          return 10513; /* aarch64_sve_dupq_lanevnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[0]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern841 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V16QImode, operands[1], operands[2])))
            return 2952; /* load_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern841 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HImode, operands[1], operands[2])))
            return 2953; /* load_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern841 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8BFmode, operands[1], operands[2])))
            return 2954; /* load_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern841 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HFmode, operands[1], operands[2])))
            return 2955; /* load_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern841 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SImode, operands[1], operands[2])))
            return 2956; /* load_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern841 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SFmode, operands[1], operands[2])))
            return 2957; /* load_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern841 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SImode, operands[1], operands[2])))
            return 2958; /* load_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern841 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SFmode, operands[1], operands[2])))
            return 2959; /* load_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern841 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DImode, operands[1], operands[2])))
            return 2960; /* load_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern841 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4304 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DFmode, operands[1], operands[2])))
            return 2961; /* load_pair_lanesdf */
          break;

        case E_VNx16QImode:
          if (pattern842 (x2, 
E_VNx8QImode, 
E_VNx16QImode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10833; /* aarch64_pack_partialvnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern842 (x2, 
E_VNx4QImode, 
E_VNx8QImode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10834; /* aarch64_pack_partialvnx8qi */
          break;

        case E_VNx8HImode:
          if (pattern842 (x2, 
E_VNx4HImode, 
E_VNx8HImode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10835; /* aarch64_pack_partialvnx8hi */
          break;

        case E_VNx8HFmode:
          if (pattern842 (x2, 
E_VNx4HFmode, 
E_VNx8HFmode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10836; /* aarch64_pack_partialvnx8hf */
          break;

        case E_VNx8BFmode:
          if (pattern842 (x2, 
E_VNx4BFmode, 
E_VNx8BFmode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10837; /* aarch64_pack_partialvnx8bf */
          break;

        case E_VNx4QImode:
          if (pattern842 (x2, 
E_VNx2QImode, 
E_VNx4QImode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10838; /* aarch64_pack_partialvnx4qi */
          break;

        case E_VNx4HImode:
          if (pattern842 (x2, 
E_VNx2HImode, 
E_VNx4HImode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10839; /* aarch64_pack_partialvnx4hi */
          break;

        case E_VNx4HFmode:
          if (pattern842 (x2, 
E_VNx2HFmode, 
E_VNx4HFmode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10840; /* aarch64_pack_partialvnx4hf */
          break;

        case E_VNx4BFmode:
          if (pattern842 (x2, 
E_VNx2BFmode, 
E_VNx4BFmode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10841; /* aarch64_pack_partialvnx4bf */
          break;

        case E_VNx4SImode:
          if (pattern842 (x2, 
E_VNx2SImode, 
E_VNx4SImode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10842; /* aarch64_pack_partialvnx4si */
          break;

        case E_VNx4SFmode:
          if (pattern842 (x2, 
E_VNx2SFmode, 
E_VNx4SFmode) == 0
              && 
#line 9386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10843; /* aarch64_pack_partialvnx4sf */
          break;

        default:
          break;
        }
      break;

    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern843 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2962; /* store_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern843 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2963; /* store_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern843 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2964; /* store_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern843 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2965; /* store_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern843 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2966; /* store_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern843 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2967; /* store_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern843 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2968; /* store_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern843 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2969; /* store_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern843 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2970; /* store_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern843 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4334 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2971; /* store_pair_lanesdf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V8QImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
            return 2972; /* *aarch64_combine_internalv8qi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V8QImode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
        return -1;
      return 2982; /* *aarch64_combine_internal_bev8qi */

    case E_V8HImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
            return 2973; /* *aarch64_combine_internalv4hi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
        return -1;
      return 2983; /* *aarch64_combine_internal_bev4hi */

    case E_V8BFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4BFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
            return 2974; /* *aarch64_combine_internalv4bf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4BFmode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
        return -1;
      return 2984; /* *aarch64_combine_internal_bev4bf */

    case E_V8HFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
            return 2975; /* *aarch64_combine_internalv4hf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HFmode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
        return -1;
      return 2985; /* *aarch64_combine_internal_bev4hf */

    case E_V4SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
            return 2976; /* *aarch64_combine_internalv2si */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
        return -1;
      return 2986; /* *aarch64_combine_internal_bev2si */

    case E_V4SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
            return 2977; /* *aarch64_combine_internalv2sf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
        return -1;
      return 2987; /* *aarch64_combine_internal_bev2sf */

    case E_V2SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SImode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
            return 2978; /* *aarch64_combine_internalsi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
        return -1;
      return 2988; /* *aarch64_combine_internal_besi */

    case E_V2SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SFmode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
            return 2979; /* *aarch64_combine_internalsf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
        return -1;
      return 2989; /* *aarch64_combine_internal_besf */

    case E_V2DImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DImode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
            return 2980; /* *aarch64_combine_internaldi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
        return -1;
      return 2990; /* *aarch64_combine_internal_bedi */

    case E_V2DFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DFmode)
              && 
#line 4353 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
            return 2981; /* *aarch64_combine_internaldf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
        return -1;
      return 2991; /* *aarch64_combine_internal_bedf */

    default:
      return -1;
    }
}

 int
recog_502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (pattern322 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1369; /* subv8qi3_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1373; /* subv4hi3_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1377; /* subv2si3_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2372; /* subv4hf3_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2376; /* subv2sf3_vec_concatz_le */

            default:
              return -1;
            }

        case MULT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[2] = x6;
              operands[1] = x4;
              x7 = XEXP (x5, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1032 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2039; /* aarch64_mlsv8qi_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1032 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2043; /* aarch64_mlsv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1032 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2047; /* aarch64_mlsv2si_vec_concatz_le */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x9 = XEXP (x6, 0);
              switch (GET_CODE (x9))
                {
                case VEC_SELECT:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != PARALLEL
                      || XVECLEN (x10, 0) != 1)
                    return -1;
                  operands[4] = x4;
                  x11 = XEXP (x9, 0);
                  operands[1] = x11;
                  x12 = XVECEXP (x10, 0, 0);
                  operands[2] = x12;
                  if (!immediate_operand (operands[2], E_SImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x8 = XEXP (x2, 1);
                  operands[5] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1242 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[1], E_V4HImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2051; /* *aarch64_mls_eltv4hi_vec_concatz_le */

                        case E_V8HImode:
                          if (!register_operand (operands[1], E_V8HImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2059; /* *aarch64_mls_elt_to_128v4hi_vec_concatz_le */

                        default:
                          return -1;
                        }

                    case E_V4SImode:
                      if (pattern1242 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[1], E_V2SImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2055; /* *aarch64_mls_eltv2si_vec_concatz_le */

                        case E_V4SImode:
                          if (!register_operand (operands[1], E_V4SImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2063; /* *aarch64_mls_elt_to_128v2si_vec_concatz_le */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[3] = x9;
                  operands[1] = x4;
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  x8 = XEXP (x2, 1);
                  operands[4] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1090 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1746 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2067; /* aarch64_mls_nv4hi_vec_concatz_le */

                    case E_V4SImode:
                      if (pattern1090 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1746 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2071; /* aarch64_mls_nv2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern428 (x2, 
SMIN))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1644; /* aarch64_sabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1652; /* aarch64_sabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1660; /* aarch64_sabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern428 (x2, 
UMIN))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1647; /* aarch64_uabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1655; /* aarch64_uabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1663; /* aarch64_uabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 6; /* jump */
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x2))
            {
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
              res = recog_475 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
              res = recog_476 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x2;
          if (aarch64_movti_operand (operands[1], E_TImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (nonimmediate_operand (operands[0], E_TImode)
                  && 
#line 1711 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], TImode)
    || aarch64_reg_or_zero (operands[1], TImode))))
                return 75; /* *movti_aarch64 */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (register_operand (operands[0], E_VNx16QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16QImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx16QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx16QImode)))))
            return 5552; /* *aarch64_sve_movvnx16qi_no_ldr_str */
          break;

        case E_VNx8QImode:
          if (register_operand (operands[0], E_VNx8QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8QImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8QImode)))))
            return 5553; /* *aarch64_sve_movvnx8qi_no_ldr_str */
          break;

        case E_VNx4QImode:
          if (register_operand (operands[0], E_VNx4QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4QImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4QImode)))))
            return 5554; /* *aarch64_sve_movvnx4qi_no_ldr_str */
          break;

        case E_VNx2QImode:
          if (register_operand (operands[0], E_VNx2QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2QImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2QImode)))))
            return 5555; /* *aarch64_sve_movvnx2qi_no_ldr_str */
          break;

        case E_VNx8HImode:
          if (register_operand (operands[0], E_VNx8HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HImode)))))
            return 5556; /* *aarch64_sve_movvnx8hi_no_ldr_str */
          break;

        case E_VNx4HImode:
          if (register_operand (operands[0], E_VNx4HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HImode)))))
            return 5557; /* *aarch64_sve_movvnx4hi_no_ldr_str */
          break;

        case E_VNx2HImode:
          if (register_operand (operands[0], E_VNx2HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HImode)))))
            return 5558; /* *aarch64_sve_movvnx2hi_no_ldr_str */
          break;

        case E_VNx4SImode:
          if (register_operand (operands[0], E_VNx4SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SImode)))))
            return 5559; /* *aarch64_sve_movvnx4si_no_ldr_str */
          break;

        case E_VNx2SImode:
          if (register_operand (operands[0], E_VNx2SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SImode)))))
            return 5560; /* *aarch64_sve_movvnx2si_no_ldr_str */
          break;

        case E_VNx2DImode:
          if (register_operand (operands[0], E_VNx2DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DImode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DImode)))))
            return 5561; /* *aarch64_sve_movvnx2di_no_ldr_str */
          break;

        case E_VNx8HFmode:
          if (register_operand (operands[0], E_VNx8HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HFmode)))))
            return 5562; /* *aarch64_sve_movvnx8hf_no_ldr_str */
          break;

        case E_VNx4HFmode:
          if (register_operand (operands[0], E_VNx4HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HFmode)))))
            return 5563; /* *aarch64_sve_movvnx4hf_no_ldr_str */
          break;

        case E_VNx2HFmode:
          if (register_operand (operands[0], E_VNx2HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HFmode)))))
            return 5564; /* *aarch64_sve_movvnx2hf_no_ldr_str */
          break;

        case E_VNx8BFmode:
          if (register_operand (operands[0], E_VNx8BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8BFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8BFmode)))))
            return 5565; /* *aarch64_sve_movvnx8bf_no_ldr_str */
          break;

        case E_VNx4BFmode:
          if (register_operand (operands[0], E_VNx4BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4BFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4BFmode)))))
            return 5566; /* *aarch64_sve_movvnx4bf_no_ldr_str */
          break;

        case E_VNx2BFmode:
          if (register_operand (operands[0], E_VNx2BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2BFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2BFmode)))))
            return 5567; /* *aarch64_sve_movvnx2bf_no_ldr_str */
          break;

        case E_VNx4SFmode:
          if (register_operand (operands[0], E_VNx4SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SFmode)))))
            return 5568; /* *aarch64_sve_movvnx4sf_no_ldr_str */
          break;

        case E_VNx2SFmode:
          if (register_operand (operands[0], E_VNx2SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SFmode)))))
            return 5569; /* *aarch64_sve_movvnx2sf_no_ldr_str */
          break;

        case E_VNx2DFmode:
          if (register_operand (operands[0], E_VNx2DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DFmode)
              && 
#line 728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DFmode)))))
            return 5570; /* *aarch64_sve_movvnx2df_no_ldr_str */
          break;

        case E_VNx32QImode:
          if (register_operand (operands[0], E_VNx32QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32QImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5676; /* *aarch64_sve_movvnx32qi_be */
          break;

        case E_VNx16HImode:
          if (register_operand (operands[0], E_VNx16HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5677; /* *aarch64_sve_movvnx16hi_be */
          break;

        case E_VNx8SImode:
          if (register_operand (operands[0], E_VNx8SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5678; /* *aarch64_sve_movvnx8si_be */
          break;

        case E_VNx4DImode:
          if (register_operand (operands[0], E_VNx4DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5679; /* *aarch64_sve_movvnx4di_be */
          break;

        case E_VNx16BFmode:
          if (register_operand (operands[0], E_VNx16BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16BFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5680; /* *aarch64_sve_movvnx16bf_be */
          break;

        case E_VNx16HFmode:
          if (register_operand (operands[0], E_VNx16HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5681; /* *aarch64_sve_movvnx16hf_be */
          break;

        case E_VNx8SFmode:
          if (register_operand (operands[0], E_VNx8SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5682; /* *aarch64_sve_movvnx8sf_be */
          break;

        case E_VNx4DFmode:
          if (register_operand (operands[0], E_VNx4DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5683; /* *aarch64_sve_movvnx4df_be */
          break;

        case E_VNx48QImode:
          if (register_operand (operands[0], E_VNx48QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx48QImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5684; /* *aarch64_sve_movvnx48qi_be */
          break;

        case E_VNx24HImode:
          if (register_operand (operands[0], E_VNx24HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5685; /* *aarch64_sve_movvnx24hi_be */
          break;

        case E_VNx12SImode:
          if (register_operand (operands[0], E_VNx12SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5686; /* *aarch64_sve_movvnx12si_be */
          break;

        case E_VNx6DImode:
          if (register_operand (operands[0], E_VNx6DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5687; /* *aarch64_sve_movvnx6di_be */
          break;

        case E_VNx24BFmode:
          if (register_operand (operands[0], E_VNx24BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24BFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5688; /* *aarch64_sve_movvnx24bf_be */
          break;

        case E_VNx24HFmode:
          if (register_operand (operands[0], E_VNx24HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5689; /* *aarch64_sve_movvnx24hf_be */
          break;

        case E_VNx12SFmode:
          if (register_operand (operands[0], E_VNx12SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5690; /* *aarch64_sve_movvnx12sf_be */
          break;

        case E_VNx6DFmode:
          if (register_operand (operands[0], E_VNx6DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5691; /* *aarch64_sve_movvnx6df_be */
          break;

        case E_VNx64QImode:
          if (register_operand (operands[0], E_VNx64QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx64QImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5692; /* *aarch64_sve_movvnx64qi_be */
          break;

        case E_VNx32HImode:
          if (register_operand (operands[0], E_VNx32HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5693; /* *aarch64_sve_movvnx32hi_be */
          break;

        case E_VNx16SImode:
          if (register_operand (operands[0], E_VNx16SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5694; /* *aarch64_sve_movvnx16si_be */
          break;

        case E_VNx8DImode:
          if (register_operand (operands[0], E_VNx8DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DImode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5695; /* *aarch64_sve_movvnx8di_be */
          break;

        case E_VNx32BFmode:
          if (register_operand (operands[0], E_VNx32BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32BFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5696; /* *aarch64_sve_movvnx32bf_be */
          break;

        case E_VNx32HFmode:
          if (register_operand (operands[0], E_VNx32HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5697; /* *aarch64_sve_movvnx32hf_be */
          break;

        case E_VNx16SFmode:
          if (register_operand (operands[0], E_VNx16SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5698; /* *aarch64_sve_movvnx16sf_be */
          break;

        case E_VNx8DFmode:
          if (register_operand (operands[0], E_VNx8DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DFmode)
              && 
#line 882 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5699; /* *aarch64_sve_movvnx8df_be */
          break;

        case E_VNx16BImode:
          if (nonimmediate_operand (operands[0], E_VNx16BImode)
              && aarch64_mov_operand (operands[1], E_VNx16BImode)
              && 
#line 974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BImode)
       || register_operand (operands[1], VNx16BImode))))
            return 5724; /* *aarch64_sve_movvnx16bi */
          break;

        case E_VNx8BImode:
          if (nonimmediate_operand (operands[0], E_VNx8BImode)
              && aarch64_mov_operand (operands[1], E_VNx8BImode)
              && 
#line 974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BImode)
       || register_operand (operands[1], VNx8BImode))))
            return 5725; /* *aarch64_sve_movvnx8bi */
          break;

        case E_VNx4BImode:
          if (nonimmediate_operand (operands[0], E_VNx4BImode)
              && aarch64_mov_operand (operands[1], E_VNx4BImode)
              && 
#line 974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BImode)
       || register_operand (operands[1], VNx4BImode))))
            return 5726; /* *aarch64_sve_movvnx4bi */
          break;

        case E_VNx2BImode:
          if (nonimmediate_operand (operands[0], E_VNx2BImode)
              && aarch64_mov_operand (operands[1], E_VNx2BImode)
              && 
#line 974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BImode)
       || register_operand (operands[1], VNx2BImode))))
            return 5727; /* *aarch64_sve_movvnx2bi */
          break;

        case E_VNx32BImode:
          if (nonimmediate_operand (operands[0], E_VNx32BImode)
              && aarch64_mov_operand (operands[1], E_VNx32BImode)
              && 
#line 1096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5736; /* movvnx32bi */
          break;

        case E_VNx64BImode:
          if (nonimmediate_operand (operands[0], E_VNx64BImode)
              && aarch64_mov_operand (operands[1], E_VNx64BImode)
              && 
#line 1096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5737; /* movvnx64bi */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == REG
          && GET_MODE (x2) == E_VNx16BImode)
        {
          switch (REGNO (x2))
            {
            case 85:
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 86
                  && GET_MODE (x3) == E_VNx16BImode
                  && 
#line 1158 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 5740; /* aarch64_copy_ffr_to_ffrt */
              break;

            case 86:
              operands[0] = x3;
              if (register_operand (operands[0], E_VNx16BImode)
                  && 
#line 1169 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 5741; /* aarch64_rdffr */
              break;

            default:
              break;
            }
        }
      operands[1] = x2;
      operands[0] = x3;
      res = recog_477 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && GET_CODE (x3) == REG
          && REGNO (x3) == 90
          && GET_MODE (x3) == E_DImode)
        return 13009; /* aarch64_clear_tpidr2 */
      break;

    case TRUNCATE:
      res = recog_479 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!subreg_lowpart_operator (x2, E_DImode))
    return -1;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 6475 "../../gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 846; /* *aarch64_bfidiqi_subreg_8 */

    case 1:
      if (!
#line 6475 "../../gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 847; /* *aarch64_bfidihi_subreg_8 */

    case 2:
      if (!
#line 6475 "../../gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 849; /* *aarch64_bfidisi_subreg_8 */

    case 3:
      if (!
#line 6475 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 848; /* *aarch64_bfidihi_subreg_16 */

    case 4:
      if (!
#line 6475 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 850; /* *aarch64_bfidisi_subreg_16 */

    case 5:
      if (!
#line 6475 "../../gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64))
        return -1;
      return 851; /* *aarch64_bfidisi_subreg_32 */

    default:
      return -1;
    }
}

 int
recog_514 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_482 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && GET_MODE (x3) == E_V8QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1247; /* aarch64_simd_dupv8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[0], E_V16QImode)
                      && GET_MODE (x3) == E_V16QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1248; /* aarch64_simd_dupv16qi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && GET_MODE (x3) == E_V4HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1249; /* aarch64_simd_dupv4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[0], E_V8HImode)
                      && GET_MODE (x3) == E_V8HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1250; /* aarch64_simd_dupv8hi */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1251; /* aarch64_simd_dupv2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x3) == E_V4SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1252; /* aarch64_simd_dupv4si */
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1253; /* aarch64_simd_dupv2di */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[0], E_V4HFmode)
                      && GET_MODE (x3) == E_V4HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1254; /* aarch64_simd_dupv4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[0], E_V8HFmode)
                      && GET_MODE (x3) == E_V8HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1255; /* aarch64_simd_dupv8hf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1256; /* aarch64_simd_dupv2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[0], E_V4SFmode)
                      && GET_MODE (x3) == E_V4SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1257; /* aarch64_simd_dupv4sf */
                  break;

                case E_V2DFmode:
                  if (register_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1258; /* aarch64_simd_dupv2df */
                  break;

                case E_V4BFmode:
                  if (register_operand (operands[0], E_V4BFmode)
                      && GET_MODE (x3) == E_V4BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1259; /* aarch64_simd_dupv4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[0], E_V8BFmode)
                      && GET_MODE (x3) == E_V8BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1260; /* aarch64_simd_dupv8bf */
                  break;

                default:
                  break;
                }
              break;

            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1313; /* aarch64_simd_stpv2si */
                  break;

                case E_V2SFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1314; /* aarch64_simd_stpv2sf */
                  break;

                case E_V2DImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1315; /* aarch64_simd_stpv2di */
                  break;

                case E_V2DFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1316; /* aarch64_simd_stpv2df */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (register_operand (operands[0], E_V8QImode)
                  && GET_MODE (x3) == E_V8QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5126; /* *aarch64_simd_ld1rv8qi */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5127; /* *aarch64_simd_ld1rv16qi */
              break;

            case E_V4HImode:
              if (register_operand (operands[0], E_V4HImode)
                  && GET_MODE (x3) == E_V4HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5128; /* *aarch64_simd_ld1rv4hi */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5129; /* *aarch64_simd_ld1rv8hi */
              break;

            case E_V2SImode:
              if (register_operand (operands[0], E_V2SImode)
                  && GET_MODE (x3) == E_V2SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5130; /* *aarch64_simd_ld1rv2si */
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x3) == E_V4SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5131; /* *aarch64_simd_ld1rv4si */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x3) == E_V2DImode
                  && aarch64_simd_struct_operand (operands[1], E_DImode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5132; /* *aarch64_simd_ld1rv2di */
              break;

            case E_V4HFmode:
              if (register_operand (operands[0], E_V4HFmode)
                  && GET_MODE (x3) == E_V4HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5133; /* *aarch64_simd_ld1rv4hf */
              break;

            case E_V8HFmode:
              if (register_operand (operands[0], E_V8HFmode)
                  && GET_MODE (x3) == E_V8HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5134; /* *aarch64_simd_ld1rv8hf */
              break;

            case E_V4BFmode:
              if (register_operand (operands[0], E_V4BFmode)
                  && GET_MODE (x3) == E_V4BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5135; /* *aarch64_simd_ld1rv4bf */
              break;

            case E_V8BFmode:
              if (register_operand (operands[0], E_V8BFmode)
                  && GET_MODE (x3) == E_V8BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5136; /* *aarch64_simd_ld1rv8bf */
              break;

            case E_V2SFmode:
              if (register_operand (operands[0], E_V2SFmode)
                  && GET_MODE (x3) == E_V2SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5137; /* *aarch64_simd_ld1rv2sf */
              break;

            case E_V4SFmode:
              if (register_operand (operands[0], E_V4SFmode)
                  && GET_MODE (x3) == E_V4SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5138; /* *aarch64_simd_ld1rv4sf */
              break;

            case E_V2DFmode:
              if (register_operand (operands[0], E_V2DFmode)
                  && GET_MODE (x3) == E_V2DFmode
                  && aarch64_simd_struct_operand (operands[1], E_DFmode)
                  && 
#line 8819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5139; /* *aarch64_simd_ld1rv2df */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      return recog_481 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          switch (pattern492 (x3))
            {
            case 0:
              return 106; /* *extendsidi2_aarch64 */

            case 1:
              return 111; /* *extendqidi2_aarch64 */

            case 2:
              return 113; /* *extendhidi2_aarch64 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern493 (x3))
            {
            case 0:
              return 110; /* *extendqisi2_aarch64 */

            case 1:
              return 112; /* *extendhisi2_aarch64 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 118; /* *extendqihi2_aarch64 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 9846 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5244; /* extendv8qiv8hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 9846 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5246; /* extendv4hiv4si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 9846 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5248; /* extendv2siv2di2 */

        case E_VNx16HImode:
          if (!aligned_register_operand (operands[0], E_VNx16HImode)
              || GET_MODE (x3) != E_VNx16HImode
              || !register_operand (operands[1], E_VNx16QImode)
              || !
#line 2201 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12100; /* extendvnx16qivnx16hi2 */

        case E_VNx8SImode:
          if (!aligned_register_operand (operands[0], E_VNx8SImode)
              || GET_MODE (x3) != E_VNx8SImode
              || !register_operand (operands[1], E_VNx8HImode)
              || !
#line 2201 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12102; /* extendvnx8hivnx8si2 */

        case E_VNx4DImode:
          if (!aligned_register_operand (operands[0], E_VNx4DImode)
              || GET_MODE (x3) != E_VNx4DImode
              || !register_operand (operands[1], E_VNx4SImode)
              || !
#line 2201 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12104; /* extendvnx4sivnx4di2 */

        case E_VNx32HImode:
          if (!aligned_register_operand (operands[0], E_VNx32HImode)
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[1], E_VNx32QImode)
              || !
#line 2209 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12106; /* extendvnx32qivnx32hi2 */

        case E_VNx16SImode:
          if (!aligned_register_operand (operands[0], E_VNx16SImode)
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[1], E_VNx16HImode)
              || !
#line 2209 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12108; /* extendvnx16hivnx16si2 */

        case E_VNx8DImode:
          if (!aligned_register_operand (operands[0], E_VNx8DImode)
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[1], E_VNx8SImode)
              || !
#line 2209 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12110; /* extendvnx8sivnx8di2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern289 (x3))
        {
        case 0:
          if (!
#line 6287 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 800; /* *extendsi_ashlqi */

        case 1:
          if (!
#line 6287 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 804; /* *extendsi_ashlhi */

        case 2:
          if (!
#line 6287 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 802; /* *extenddi_ashlqi */

        case 3:
          if (!
#line 6287 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 806; /* *extenddi_ashlhi */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern289 (x3))
        {
        case 0:
          if (!
#line 6313 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 812; /* *extendsi_ashrqi */

        case 1:
          if (!
#line 6313 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 814; /* *extendsi_ashrhi */

        case 2:
          if (!
#line 6313 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 813; /* *extenddi_ashrqi */

        case 3:
          if (!
#line 6313 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 815; /* *extenddi_ashrhi */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern365 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) == 0
              && 
#line 1970 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2230; /* aarch64_simd_vec_unpacks_hi_v16qi */
          break;

        case E_V4SImode:
          if (pattern365 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) == 0
              && 
#line 1970 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2232; /* aarch64_simd_vec_unpacks_hi_v8hi */
          break;

        case E_V2DImode:
          if (pattern365 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) == 0
              && 
#line 1970 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2234; /* aarch64_simd_vec_unpacks_hi_v4si */
          break;

        default:
          break;
        }
      if (XVECLEN (x5, 0) != 1)
        return -1;
      switch (pattern495 (x3))
        {
        case 0:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2920; /* *aarch64_get_lane_extendsiv8qi */

        case 1:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2922; /* *aarch64_get_lane_extendsiv16qi */

        case 2:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2924; /* *aarch64_get_lane_extendsiv4hi */

        case 3:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2926; /* *aarch64_get_lane_extendsiv8hi */

        case 4:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2921; /* *aarch64_get_lane_extenddiv8qi */

        case 5:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2923; /* *aarch64_get_lane_extenddiv16qi */

        case 6:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2925; /* *aarch64_get_lane_extenddiv4hi */

        case 7:
          if (!
#line 4231 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2927; /* *aarch64_get_lane_extenddiv8hi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 25)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern882 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 8)))
                return -1;
              return 5515; /* *aarch64_atomic_loadqi_rcpc_sext */

            case 1:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 16)))
                return -1;
              return 5517; /* *aarch64_atomic_loadhi_rcpc_sext */

            case 2:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 32)))
                return -1;
              return 5519; /* *aarch64_atomic_loadsi_rcpc_sext */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern882 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 8)))
                return -1;
              return 5516; /* *aarch64_atomic_loadqi_rcpc_sext */

            case 1:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 16)))
                return -1;
              return 5518; /* *aarch64_atomic_loadhi_rcpc_sext */

            case 2:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 32)))
                return -1;
              return 5520; /* *aarch64_atomic_loadsi_rcpc_sext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 3)
        return -1;
      switch (pattern600 (x3))
        {
        case 0:
          if (!
#line 10469 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11044; /* aarch64_sve_sqincsi_pat */

        case 1:
          if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11090; /* *aarch64_sve_sqincsivnx16bi_cntp */

        case 2:
          if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11092; /* *aarch64_sve_sqincsivnx8bi_cntp */

        case 3:
          if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11094; /* *aarch64_sve_sqincsivnx4bi_cntp */

        case 4:
          if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11096; /* *aarch64_sve_sqincsivnx2bi_cntp */

        default:
          return -1;
        }

    case SS_MINUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3)
        return -1;
      switch (pattern602 (x3))
        {
        case 0:
          if (!
#line 10619 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11059; /* aarch64_sve_sqdecsi_pat */

        case 1:
          if (!
#line 11056 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11123; /* *aarch64_sve_sqdecsivnx16bi_cntp */

        case 2:
          if (!
#line 11056 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11125; /* *aarch64_sve_sqdecsivnx8bi_cntp */

        case 3:
          if (!
#line 11056 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11127; /* *aarch64_sve_sqdecsivnx4bi_cntp */

        case 4:
          if (!
#line 11056 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11129; /* *aarch64_sve_sqdecsivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern36 (x3))
        {
        case 0:
          if (!
#line 7398 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 1087; /* *aarch64_uminsi3_cssc */

        case 1:
          if (!
#line 7398 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 1091; /* *aarch64_umindi3_cssc */

        case 2:
          if (!
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2083; /* uminv8qi3 */

        case 3:
          if (!
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2089; /* uminv16qi3 */

        case 4:
          if (!
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2099; /* uminv4hi3 */

        case 5:
          if (!
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2105; /* uminv8hi3 */

        case 6:
          if (!
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2115; /* uminv2si3 */

        case 7:
          if (!
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2121; /* uminv4si3 */

        case 8:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11469; /* *uminvnx32qi3 */

        case 9:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11473; /* *uminvnx16hi3 */

        case 10:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11477; /* *uminvnx8si3 */

        case 11:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11481; /* *uminvnx4di3 */

        case 12:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11485; /* *uminvnx64qi3 */

        case 13:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11489; /* *uminvnx32hi3 */

        case 14:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11493; /* *uminvnx16si3 */

        case 15:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11497; /* *uminvnx8di3 */

        case 16:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7433; /* *post_ra_uminvnx16qi3 */

        case 17:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7438; /* *post_ra_uminvnx8qi3 */

        case 18:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7443; /* *post_ra_uminvnx4qi3 */

        case 19:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7448; /* *post_ra_uminvnx2qi3 */

        case 20:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7453; /* *post_ra_uminvnx8hi3 */

        case 21:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7458; /* *post_ra_uminvnx4hi3 */

        case 22:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7463; /* *post_ra_uminvnx2hi3 */

        case 23:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7468; /* *post_ra_uminvnx4si3 */

        case 24:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7473; /* *post_ra_uminvnx2si3 */

        case 25:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7478; /* *post_ra_uminvnx2di3 */

        case 26:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7483; /* *post_ra_uminv2di3 */

        case 27:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11502; /* aarch64_sve_single_uminvnx32qi */

        case 28:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11507; /* aarch64_sve_single_uminvnx16hi */

        case 29:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11512; /* aarch64_sve_single_uminvnx8si */

        case 30:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11517; /* aarch64_sve_single_uminvnx4di */

        case 31:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11522; /* aarch64_sve_single_uminvnx64qi */

        case 32:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11527; /* aarch64_sve_single_uminvnx32hi */

        case 33:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11532; /* aarch64_sve_single_uminvnx16si */

        case 34:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11537; /* aarch64_sve_single_uminvnx8di */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern318 (x3))
        {
        case 0:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11587; /* aarch64_sve_uclampvnx16qi */

        case 1:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11589; /* aarch64_sve_uclampvnx8hi */

        case 2:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11591; /* aarch64_sve_uclampvnx4si */

        case 3:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11593; /* aarch64_sve_uclampvnx2di */

        case 4:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11603; /* aarch64_sve_uclamp_singlevnx32qi */

        case 5:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11605; /* aarch64_sve_uclamp_singlevnx16hi */

        case 6:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11607; /* aarch64_sve_uclamp_singlevnx8si */

        case 7:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11609; /* aarch64_sve_uclamp_singlevnx4di */

        case 8:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11611; /* aarch64_sve_uclamp_singlevnx64qi */

        case 9:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11613; /* aarch64_sve_uclamp_singlevnx32hi */

        case 10:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11615; /* aarch64_sve_uclamp_singlevnx16si */

        case 11:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11617; /* aarch64_sve_uclamp_singlevnx8di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern449 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3247; /* usaddv8qi3 */

        case 1:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3257; /* usaddv16qi3 */

        case 2:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3263; /* usaddv4hi3 */

        case 3:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3273; /* usaddv8hi3 */

        case 4:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3279; /* usaddv2si3 */

        case 5:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3289; /* usaddv4si3 */

        case 6:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3293; /* usaddv2di3 */

        case 7:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3297; /* usaddhi3 */

        case 8:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3301; /* usaddqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3308; /* usaddsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3310; /* usadddi3 */

        case 11:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8116; /* usaddvnx16qi3 */

        case 12:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8118; /* usaddvnx8hi3 */

        case 13:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8120; /* usaddvnx4si3 */

        case 14:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8122; /* usaddvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern333 (x3))
        {
        case 0:
          if (!
#line 10433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11042; /* aarch64_sve_uqincdi_pat */

        case 1:
          if (!
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11076; /* *aarch64_sve_uqincdivnx16bi_cntp */

        case 2:
          if (!
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11079; /* *aarch64_sve_uqincdivnx8bi_cntp */

        case 3:
          if (!
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11082; /* *aarch64_sve_uqincdivnx4bi_cntp */

        case 4:
          if (!
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11085; /* *aarch64_sve_uqincdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern337 (x3))
        {
        case 0:
          if (!
#line 10498 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11048; /* aarch64_sve_uqincvnx2di_pat */

        case 1:
          if (!
#line 10875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11100; /* *aarch64_sve_uqincvnx2di_cntp */

        case 2:
          if (!
#line 10519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11051; /* aarch64_sve_uqincvnx4si_pat */

        case 3:
          if (!
#line 10914 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11103; /* *aarch64_sve_uqincvnx4si_cntp */

        case 4:
          if (!
#line 10554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11054; /* *aarch64_sve_uqincvnx8hi_pat */

        case 5:
          if (!
#line 10955 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11106; /* *aarch64_sve_uqincvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10208; /* while_ugesivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10218; /* while_ugedivnx2bi_ptest */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10207; /* while_ugtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10217; /* while_ugtdivnx2bi_ptest */
}

 int
recog_580 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10166; /* while_gtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10176; /* while_gtdivnx8bi_ptest */
}

 int
recog_590 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10125; /* *while_gesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10135; /* *while_gedivnx2bi_cc */
}

 int
recog_600 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern675 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9990; /* while_wrsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10000; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10010; /* while_wrsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10020; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10030; /* while_wrsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10040; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10050; /* while_wrsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10060; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_604 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 127:
      if (pattern563 (x2) != 0)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (XWINT (x4, 0) == 1L)
        {
          res = recog_595 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !aarch64_sve_ptrue_flag (x4, E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      switch (GET_CODE (x6))
        {
        case AND:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
              if (REGNO (x7) != 86
                  || GET_MODE (x7) != E_VNx16BImode)
                return -1;
              operands[2] = x4;
              if (GET_MODE (x6) != E_VNx16BImode)
                return -1;
              x8 = XVECEXP (x3, 0, 1);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x6, 1);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              x10 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x10))
                {
                case CLOBBER:
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!scratch_operand (operands[0], E_VNx16BImode)
                      || !
#line 1199 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 5743; /* *aarch64_rdffr_z_ptest */

                case SET:
                  x12 = XEXP (x10, 1);
                  if (GET_CODE (x12) != AND
                      || GET_MODE (x12) != E_VNx16BImode)
                    return -1;
                  x13 = XEXP (x12, 0);
                  if (GET_CODE (x13) != REG
                      || REGNO (x13) != 86
                      || GET_MODE (x13) != E_VNx16BImode)
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!register_operand (operands[0], E_VNx16BImode))
                    return -1;
                  x14 = XEXP (x12, 1);
                  if (!rtx_equal_p (x14, operands[1])
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 5745; /* *aarch64_rdffr_z_cc */

                default:
                  return -1;
                }

            case AND:
              switch (pattern1224 (x1, 
AND))
                {
                case 0:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9087; /* *andvnx16bi3_cc */

                case 1:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9090; /* *andvnx8bi3_cc */

                case 2:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9093; /* *andvnx4bi3_cc */

                case 3:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9096; /* *andvnx2bi3_cc */

                case 4:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9099; /* *andvnx16bi3_ptest */

                case 5:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9102; /* *andvnx8bi3_ptest */

                case 6:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9105; /* *andvnx4bi3_ptest */

                case 7:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9108; /* *andvnx2bi3_ptest */

                case 8:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9119; /* *bicvnx16bi3_cc */

                case 9:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9121; /* *bicvnx8bi3_cc */

                case 10:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9123; /* *bicvnx4bi3_cc */

                case 11:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9125; /* *bicvnx2bi3_cc */

                case 12:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9127; /* *bicvnx16bi3_ptest */

                case 13:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9129; /* *bicvnx8bi3_ptest */

                case 14:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9131; /* *bicvnx4bi3_ptest */

                case 15:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9133; /* *bicvnx2bi3_ptest */

                case 16:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9143; /* *norvnx16bi3_cc */

                case 17:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9145; /* *norvnx8bi3_cc */

                case 18:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9147; /* *norvnx4bi3_cc */

                case 19:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9149; /* *norvnx2bi3_cc */

                case 20:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9151; /* *norvnx16bi3_ptest */

                case 21:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9153; /* *norvnx8bi3_ptest */

                case 22:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9155; /* *norvnx4bi3_ptest */

                case 23:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9157; /* *norvnx2bi3_ptest */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern1224 (x1, 
IOR))
                {
                case 0:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9088; /* *iorvnx16bi3_cc */

                case 1:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9091; /* *iorvnx8bi3_cc */

                case 2:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9094; /* *iorvnx4bi3_cc */

                case 3:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9097; /* *iorvnx2bi3_cc */

                case 4:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9100; /* *iorvnx16bi3_ptest */

                case 5:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9103; /* *iorvnx8bi3_ptest */

                case 6:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9106; /* *iorvnx4bi3_ptest */

                case 7:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9109; /* *iorvnx2bi3_ptest */

                case 8:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9120; /* *ornvnx16bi3_cc */

                case 9:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9122; /* *ornvnx8bi3_cc */

                case 10:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9124; /* *ornvnx4bi3_cc */

                case 11:
                  if (!
#line 6940 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9126; /* *ornvnx2bi3_cc */

                case 12:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9128; /* *ornvnx16bi3_ptest */

                case 13:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9130; /* *ornvnx8bi3_ptest */

                case 14:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9132; /* *ornvnx4bi3_ptest */

                case 15:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9134; /* *ornvnx2bi3_ptest */

                case 16:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9144; /* *nandvnx16bi3_cc */

                case 17:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9146; /* *nandvnx8bi3_cc */

                case 18:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9148; /* *nandvnx4bi3_cc */

                case 19:
                  if (!
#line 7015 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9150; /* *nandvnx2bi3_cc */

                case 20:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9152; /* *nandvnx16bi3_ptest */

                case 21:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9154; /* *nandvnx8bi3_ptest */

                case 22:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9156; /* *nandvnx4bi3_ptest */

                case 23:
                  if (!
#line 7039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9158; /* *nandvnx2bi3_ptest */

                default:
                  return -1;
                }

            case XOR:
              x8 = XVECEXP (x3, 0, 1);
              operands[4] = x8;
              operands[5] = x4;
              x15 = XEXP (x7, 0);
              operands[2] = x15;
              x16 = XEXP (x7, 1);
              operands[3] = x16;
              x9 = XEXP (x6, 1);
              if (!rtx_equal_p (x9, operands[4]))
                return -1;
              switch (pattern1219 (x1, 
XOR))
                {
                case 0:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9089; /* *xorvnx16bi3_cc */

                case 1:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9092; /* *xorvnx8bi3_cc */

                case 2:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9095; /* *xorvnx4bi3_cc */

                case 3:
                  if (!
#line 6867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9098; /* *xorvnx2bi3_cc */

                case 4:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9101; /* *xorvnx16bi3_ptest */

                case 5:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9104; /* *xorvnx8bi3_ptest */

                case 6:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9107; /* *xorvnx4bi3_ptest */

                case 7:
                  if (!
#line 6889 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9110; /* *xorvnx2bi3_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 3)
            return -1;
          switch (XINT (x6, 1))
            {
            case 126:
              return recog_598 (x1, insn, pnum_clobbers);

            case 300:
              switch (pattern1249 (x1, 
300))
                {
                case 0:
                  if (!
#line 10146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11002; /* *aarch64_brka_cc */

                case 1:
                  if (!
#line 10168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11004; /* *aarch64_brka_ptest */

                default:
                  return -1;
                }

            case 301:
              switch (pattern1249 (x1, 
301))
                {
                case 0:
                  if (!
#line 10146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11003; /* *aarch64_brkb_cc */

                case 1:
                  if (!
#line 10168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11005; /* *aarch64_brkb_ptest */

                default:
                  return -1;
                }

            case 303:
              switch (pattern1250 (x1, 
303))
                {
                case 0:
                  if (!
#line 10277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11011; /* *aarch64_brkpa_cc */

                case 1:
                  if (!
#line 10299 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11013; /* *aarch64_brkpa_ptest */

                default:
                  return -1;
                }

            case 304:
              switch (pattern1250 (x1, 
304))
                {
                case 0:
                  if (!
#line 10277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11012; /* *aarch64_brkpb_cc */

                case 1:
                  if (!
#line 10299 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11014; /* *aarch64_brkpb_ptest */

                default:
                  return -1;
                }

            case 305:
              switch (pattern1252 (x1, 
305))
                {
                case 0:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11023; /* *aarch64_sve_pfirstvnx16bi_cc */

                case 1:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11025; /* *aarch64_sve_pfirstvnx8bi_cc */

                case 2:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11027; /* *aarch64_sve_pfirstvnx4bi_cc */

                case 3:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11029; /* *aarch64_sve_pfirstvnx2bi_cc */

                case 4:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11031; /* *aarch64_sve_pfirstvnx16bi_ptest */

                case 5:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11033; /* *aarch64_sve_pfirstvnx8bi_ptest */

                case 6:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11035; /* *aarch64_sve_pfirstvnx4bi_ptest */

                case 7:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11037; /* *aarch64_sve_pfirstvnx2bi_ptest */

                default:
                  return -1;
                }

            case 306:
              switch (pattern1252 (x1, 
306))
                {
                case 0:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11024; /* *aarch64_sve_pnextvnx16bi_cc */

                case 1:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11026; /* *aarch64_sve_pnextvnx8bi_cc */

                case 2:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11028; /* *aarch64_sve_pnextvnx4bi_cc */

                case 3:
                  if (!
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11030; /* *aarch64_sve_pnextvnx2bi_cc */

                case 4:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11032; /* *aarch64_sve_pnextvnx16bi_ptest */

                case 5:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11034; /* *aarch64_sve_pnextvnx8bi_ptest */

                case 6:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11036; /* *aarch64_sve_pnextvnx4bi_ptest */

                case 7:
                  if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 11038; /* *aarch64_sve_pnextvnx2bi_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 136:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12717; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12725; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12733; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12741; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12718; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12726; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12734; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12742; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12719; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12727; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12735; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12743; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12720; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12728; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12736; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12744; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12721; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12729; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12737; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12745; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12722; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12730; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12738; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12746; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12723; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12731; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12739; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12747; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern564 (x1))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12724; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12732; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12740; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12748; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 652:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 93)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 89
          || GET_MODE (x8) != E_DImode)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern453 (x10, 
652, 
4, 
UNSPEC) != 0)
        return -1;
      x12 = XEXP (x10, 1);
      x17 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 93)
        return -1;
      x18 = XVECEXP (x12, 0, 1);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 89
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XVECEXP (x12, 0, 3);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 93)
        return -1;
      x20 = XEXP (x2, 0);
      operands[0] = x20;
      x4 = XVECEXP (x3, 0, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x21 = XVECEXP (x12, 0, 2);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4DImode:
              if (!aligned_register_operand (operands[0], E_VNx4DImode)
                  || GET_MODE (x3) != E_VNx4DImode
                  || pattern681 (x1, 
E_VNx4DImode) != 0
                  || !
#line 945 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13343; /* aarch64_sme_readzvnx4di */

            case E_VNx8DImode:
              if (!aligned_register_operand (operands[0], E_VNx8DImode)
                  || GET_MODE (x3) != E_VNx8DImode
                  || pattern681 (x1, 
E_VNx8DImode) != 0
                  || !
#line 945 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13344; /* aarch64_sme_readzvnx8di */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x21 = XVECEXP (x12, 0, 2);
          if (GET_CODE (x21) != PLUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XEXP (x4, 0);
          operands[1] = x22;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x23 = XEXP (x4, 1);
          operands[2] = x23;
          if (!const_0_to_7_operand (operands[2], E_SImode))
            return -1;
          x24 = XEXP (x21, 0);
          if (!rtx_equal_p (x24, operands[1]))
            return -1;
          x25 = XEXP (x21, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4DImode:
              if (!aligned_register_operand (operands[0], E_VNx4DImode)
                  || GET_MODE (x3) != E_VNx4DImode
                  || pattern681 (x1, 
E_VNx4DImode) != 0
                  || !
#line 966 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13345; /* *aarch64_sme_readzvnx4di_plus */

            case E_VNx8DImode:
              if (!aligned_register_operand (operands[0], E_VNx8DImode)
                  || GET_MODE (x3) != E_VNx8DImode
                  || pattern681 (x1, 
E_VNx8DImode) != 0
                  || !
#line 966 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13346; /* *aarch64_sme_readzvnx8di_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_622 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          switch (XINT (x1, 1))
            {
            case 165:
              if (GET_MODE (x1) != E_DImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              return 3; /* aarch64_write_sysregdi */

            case 166:
              if (GET_MODE (x1) != E_TImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_TImode)
                  || !
#line 673 "../../gcc/config/aarch64/aarch64.md"
(TARGET_D128))
                return -1;
              return 4; /* aarch64_write_sysregti */

            case 181:
              if (!const_int_operand (operands[0], E_VOIDmode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 1238; /* patchable_area */

            default:
              return -1;
            }

        case 1:
          switch (XINT (x1, 1))
            {
            case 5:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1167; /* blockage */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1177; /* aarch64_set_fpsrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1179; /* aarch64_set_fpsrdi */

                default:
                  return -1;
                }

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1178; /* aarch64_set_fpcrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1180; /* aarch64_set_fpcrdi */

                default:
                  return -1;
                }

            case 8:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1187; /* bti_noarg */

            case 9:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1188; /* bti_c */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1189; /* bti_j */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1190; /* bti_jc */

            case 7:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1191; /* speculation_barrier */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1244; /* aarch64_gcspopm_xzr */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              return 1245; /* aarch64_gcsss1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      return recog_623 (x1, insn, pnum_clobbers);

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          if (XINT (x1, 1) != 71)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 29; /* nop */

        case 2:
          if (XINT (x1, 1) != 167)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!aarch64_prefetch_operand (operands[1], E_DImode))
            return -1;
          return 31; /* aarch64_pldx */

        default:
          return -1;
        }

    case PREFETCH:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (aarch64_prefetch_operand (operands[0], E_DImode))
        {
          x5 = XEXP (x1, 1);
          operands[1] = x5;
          if (const_int_operand (operands[1], E_QImode))
            {
              x6 = XEXP (x1, 2);
              operands[2] = x6;
              if (const_int_operand (operands[2], E_QImode))
                return 30; /* prefetch */
            }
        }
      if (GET_CODE (x4) != UNSPEC
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!const_int_operand (x5, E_DImode))
        return -1;
      x6 = XEXP (x1, 2);
      if (!const_int_operand (x6, E_DImode))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          if (XINT (x4, 1) != 170)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          operands[3] = x5;
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[0], E_VNx16BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx16QImode)
                  || !
#line 2156 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6277; /* aarch64_sve_prefetchvnx16qi */

            case E_VNx8BImode:
              if (!register_operand (operands[0], E_VNx8BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx8HImode)
                  || !
#line 2156 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6278; /* aarch64_sve_prefetchvnx8hi */

            case E_VNx4BImode:
              if (!register_operand (operands[0], E_VNx4BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx4SImode)
                  || !
#line 2156 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6279; /* aarch64_sve_prefetchvnx4si */

            case E_VNx2BImode:
              if (!register_operand (operands[0], E_VNx2BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx2DImode)
                  || !
#line 2156 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6280; /* aarch64_sve_prefetchvnx2di */

            default:
              return -1;
            }

        case 7:
          if (XINT (x4, 1) != 171)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x10 = XVECEXP (x4, 0, 3);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x11 = XVECEXP (x4, 0, 4);
          operands[4] = x11;
          x12 = XVECEXP (x4, 0, 5);
          operands[5] = x12;
          x13 = XVECEXP (x4, 0, 6);
          operands[6] = x13;
          if (!const_int_operand (operands[6], E_DImode))
            return -1;
          operands[7] = x5;
          operands[8] = x6;
          x9 = XVECEXP (x4, 0, 2);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4BImode:
                  if (!register_operand (operands[0], E_VNx4BImode)
                      || !register_operand (operands[2], E_VNx4SImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6281; /* aarch64_sve_gather_prefetchvnx16qivnx4si */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6282; /* aarch64_sve_gather_prefetchvnx8hivnx4si */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6283; /* aarch64_sve_gather_prefetchvnx4sivnx4si */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6284; /* aarch64_sve_gather_prefetchvnx2divnx4si */

                case E_VNx2BImode:
                  if (!register_operand (operands[0], E_VNx2BImode)
                      || !register_operand (operands[2], E_VNx2DImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2225 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6285; /* aarch64_sve_gather_prefetchvnx16qivnx2di */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2225 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6286; /* aarch64_sve_gather_prefetchvnx8hivnx2di */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2225 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6287; /* aarch64_sve_gather_prefetchvnx4sivnx2di */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2225 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6288; /* aarch64_sve_gather_prefetchvnx2divnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern583 (x9) != 0
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x14 = XVECEXP (x9, 0, 0);
              operands[9] = x14;
              x15 = XVECEXP (x9, 0, 1);
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2256 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6289; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_sxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2256 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6290; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_sxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2256 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6291; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_sxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2256 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6292; /* *aarch64_sve_gather_prefetchvnx2divnx2di_sxtw */

            case AND:
              if (GET_MODE (x9) != E_VNx2DImode
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x18 = XEXP (x9, 0);
              operands[2] = x18;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x19 = XEXP (x9, 1);
              operands[9] = x19;
              if (!aarch64_sve_uxtw_immediate (operands[9], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6293; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_uxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6294; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_uxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6295; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_uxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6296; /* *aarch64_sve_gather_prefetchvnx2divnx2di_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x4 = XEXP (x1, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 32; /* trap */

    case RETURN:
      return 33; /* *do_return */

    case SIMPLE_RETURN:
      return 34; /* simple_return */

    default:
      return -1;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2954 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2962 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2970 (insn, operands);
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2948 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2956 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2964 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2857 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2898 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2938 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2821 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2868 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2908 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2855 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2896 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2936 (insn, operands);
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2842 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2885 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2925 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2829 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2874 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2914 (insn, operands);
}

 rtx_insn *
split_43 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2815 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2863 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2903 (insn, operands);
}

 rtx_insn *
split_48 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2849 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2891 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2931 (insn, operands);
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2824 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2870 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2910 (insn, operands);
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1048 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1690 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1763 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1815 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1703 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1776 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1828 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1716 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1789 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1841 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1729 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1802 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1854 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1736 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1743 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1750 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 7:
      if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1867 (insn, operands);

    case 8:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1880 (insn, operands);

    case 9:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1893 (insn, operands);

    case 10:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 11:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1934 (insn, operands);

    case 12:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 13:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1948 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1048 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1682 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1755 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1807 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1695 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1768 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1820 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1708 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1781 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1833 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1721 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1794 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1846 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1730 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1907 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1737 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1914 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1744 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1921 (insn, operands);

    case 7:
      if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1859 (insn, operands);

    case 8:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1872 (insn, operands);

    case 9:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1885 (insn, operands);

    case 10:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1898 (insn, operands);

    case 11:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1928 (insn, operands);

    case 12:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1935 (insn, operands);

    case 13:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1942 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[4] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern696 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1260 (insn, operands);

        case E_VNx8QImode:
          if (pattern696 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1277 (insn, operands);

        case E_VNx4QImode:
          if (pattern696 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1294 (insn, operands);

        case E_VNx2QImode:
          if (pattern696 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1311 (insn, operands);

        case E_VNx8HImode:
          if (pattern696 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1328 (insn, operands);

        case E_VNx4HImode:
          if (pattern696 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1345 (insn, operands);

        case E_VNx2HImode:
          if (pattern696 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1362 (insn, operands);

        case E_VNx4SImode:
          if (pattern696 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1379 (insn, operands);

        case E_VNx2SImode:
          if (pattern696 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1396 (insn, operands);

        case E_VNx2DImode:
          if (pattern696 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4101 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1413 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1050 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1547 (insn, operands);

        case E_VNx8QImode:
          if (pattern1050 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1550 (insn, operands);

        case E_VNx4QImode:
          if (pattern1050 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1553 (insn, operands);

        case E_VNx2QImode:
          if (pattern1050 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1556 (insn, operands);

        case E_VNx8HImode:
          if (pattern1050 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1559 (insn, operands);

        case E_VNx4HImode:
          if (pattern1050 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1562 (insn, operands);

        case E_VNx2HImode:
          if (pattern1050 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1565 (insn, operands);

        case E_VNx4SImode:
          if (pattern1050 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1568 (insn, operands);

        case E_VNx2SImode:
          if (pattern1050 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1571 (insn, operands);

        case E_VNx2DImode:
          if (pattern1050 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 5006 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5012 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1574 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 123
      || GET_MODE (x2) != E_BLKmode)
    return NULL;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125
      || GET_MODE (x3) != E_VNx2DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return NULL;
  x6 = XVECEXP (x2, 0, 0);
  operands[5] = x6;
  if (!register_operand (operands[5], E_VNx2BImode))
    return NULL;
  x7 = XVECEXP (x2, 0, 1);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x8 = XVECEXP (x3, 0, 0);
  operands[6] = x8;
  x9 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x9) != E_VNx2DImode)
    return NULL;
  x10 = XVECEXP (x2, 0, 3);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_DImode))
    return NULL;
  x11 = XVECEXP (x2, 0, 4);
  operands[3] = x11;
  switch (pattern1314 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1014 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1321 ())
            {
            case 0:
              if ((
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1016 (insn, operands);
              break;

            case 1:
              if ((
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1018 (insn, operands);
              break;

            case 2:
              if ((
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1020 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1022 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1024 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1026 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1028 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1030 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1321 ())
            {
            case 0:
              if ((
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1031 (insn, operands);
              break;

            case 1:
              if ((
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1032 (insn, operands);
              break;

            case 2:
              if ((
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1033 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1034 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1035 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1036 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2563 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2568 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1037 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x12 = XVECEXP (x2, 0, 5);
      if (GET_MODE (x12) == E_VNx2QImode
          && aarch64_gather_scale_operand_b (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2672 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1038 (insn, operands);
        }
      if (GET_MODE (x12) == E_VNx2HImode
          && aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2672 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1039 (insn, operands);
        }
      if (GET_MODE (x12) != E_VNx2SImode
          || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
        return NULL;
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VNx2DImode)
          || !(
#line 2667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2672 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
        return NULL;
      return gen_split_1040 (insn, operands);

    case 3:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1015 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1321 ())
            {
            case 0:
              if ((
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1017 (insn, operands);
              break;

            case 1:
              if ((
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1019 (insn, operands);
              break;

            case 2:
              if ((
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1021 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1023 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1025 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1027 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2535 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2540 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1029 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern2 (x3))
        {
        case 0:
          if (aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2550 "../../gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_15 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !(
#line 2582 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2592 "../../gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], SImode))))
            return NULL;
          return gen_split_17 (insn, operands);

        case 1:
          if (aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2550 "../../gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_16 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !(
#line 2582 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2592 "../../gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], DImode))))
            return NULL;
          return gen_split_18 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          switch (pattern457 (x3))
            {
            case 0:
              if (!
#line 5177 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_42 (insn, operands);

            case 1:
              if (!
#line 5177 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_46 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern458 (x3))
            {
            case 0:
              if (!
#line 5199 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 1:
              if (!
#line 5199 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 2:
              if (!
#line 5228 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 3:
              if (!
#line 5228 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_62 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != PLUS)
        return NULL;
      switch (pattern389 (x3))
        {
        case 0:
          if (!(
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5018 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_192 (insn, operands);

        case 1:
          if (!(
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5018 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_193 (insn, operands);

        case 2:
          if (!(
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5018 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_194 (insn, operands);

        default:
          return NULL;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT)
        return NULL;
      switch (pattern460 (x3))
        {
        case 0:
          if (!(
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7505 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_237 (insn, operands);

        case 1:
          if (!(
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7505 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_238 (insn, operands);

        case 2:
          if (!(
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7505 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_239 (insn, operands);

        case 3:
          if (!(
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7505 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_240 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          if (XINT (x4, 1) != 125)
            return NULL;
          x7 = XVECEXP (x4, 0, 1);
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              x8 = XEXP (x7, 1);
              operands[3] = x8;
              switch (pattern813 (x3))
                {
                case 0:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1424 (insn, operands);

                case 1:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1425 (insn, operands);

                case 2:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1426 (insn, operands);

                case 3:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1427 (insn, operands);

                case 4:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1428 (insn, operands);

                case 5:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1429 (insn, operands);

                case 6:
                  if (!(
#line 4260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4262 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1430 (insn, operands);

                case 7:
                  if (!(
#line 4284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4286 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
                    return NULL;
                  return gen_split_1431 (insn, operands);

                case 8:
                  if (!(
#line 4305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4307 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
                    return NULL;
                  return gen_split_1432 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              switch (pattern786 (x3))
                {
                case 0:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3019 (insn, operands);

                case 1:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3021 (insn, operands);

                case 2:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3023 (insn, operands);

                case 3:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3025 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              switch (pattern786 (x3))
                {
                case 0:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3020 (insn, operands);

                case 1:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3022 (insn, operands);

                case 2:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3024 (insn, operands);

                case 3:
                  if (!(
#line 1960 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3026 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          if (XINT (x4, 1) != 307)
            return NULL;
          switch (pattern622 (x3))
            {
            case 0:
              if (!(
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10789 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2717 (insn, operands);

            case 1:
              if (!(
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10789 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2718 (insn, operands);

            case 2:
              if (!(
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10789 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2719 (insn, operands);

            case 3:
              if (!(
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10789 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2720 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (pattern38 (x4, 
E_DImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x6 = XEXP (x4, 0);
      x9 = XVECEXP (x6, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x6, 0, 2);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      switch (pattern19 ())
        {
        case 0:
          if (!(
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10770 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2705 (insn, operands);

        case 1:
          if (!(
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10770 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2708 (insn, operands);

        case 2:
          if (!(
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10770 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2711 (insn, operands);

        case 3:
          if (!(
#line 10768 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10770 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2714 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (pattern20 (x3))
        {
        case 0:
          if (!(
#line 10875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10880 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2729 (insn, operands);

        case 1:
          if (!(
#line 10914 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10919 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2732 (insn, operands);

        case 2:
          if (!(
#line 10955 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10960 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2735 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_93 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2544 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2554 (insn, operands);
}

 rtx_insn *
split_96 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2484 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2494 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2424 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2434 (insn, operands);
}

 rtx_insn *
split_103 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2503 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2513 (insn, operands);
}

 rtx_insn *
split_109 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2542 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2552 (insn, operands);
}

 rtx_insn *
split_116 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2561 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8519 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2571 (insn, operands);
}

 rtx_insn *
split_123 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2421 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2431 (insn, operands);
}

 rtx_insn *
split_130 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2440 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2450 (insn, operands);
}

 rtx_insn *
split_137 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern347 (x1))
        {
        case 0:
          if (!(
#line 4507 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4511 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 1:
          if (!(
#line 4507 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4511 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_22 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern347 (x1))
        {
        case 0:
          if (!(
#line 4507 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4511 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_21 (insn, operands);

        case 1:
          if (!(
#line 4507 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4511 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_23 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern372 (x1, 
E_CCmode, 
66, 
CLOBBER) != 0)
        return NULL;
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SMAX:
          switch (pattern988 (x3))
            {
            case 0:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_29 (insn, operands);

            case 1:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_33 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern988 (x3))
            {
            case 0:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_30 (insn, operands);

            case 1:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_34 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern988 (x3))
            {
            case 0:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_31 (insn, operands);

            case 1:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern988 (x3))
            {
            case 0:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_32 (insn, operands);

            case 1:
              if (!(
#line 5016 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 5018 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CC_NZVmode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern701 (x1, 
CLOBBER, 
E_CC_NZVmode) != 0)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (!register_operand (x7, E_SImode))
        return NULL;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          operands[2] = x7;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !aarch64_mov_imm_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_73 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !aarch64_mov_imm_operand (operands[1], E_DImode))
                return NULL;
              return gen_split_74 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern1115 (x1))
            {
            case 0:
              return gen_split_75 (insn, operands);

            case 1:
              return gen_split_80 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern1115 (x1))
            {
            case 0:
              return gen_split_76 (insn, operands);

            case 1:
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern1115 (x1))
            {
            case 0:
              return gen_split_77 (insn, operands);

            case 1:
              return gen_split_82 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern1115 (x1))
            {
            case 0:
              return gen_split_78 (insn, operands);

            case 1:
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          switch (pattern1115 (x1))
            {
            case 0:
              return gen_split_79 (insn, operands);

            case 1:
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case US_PLUS:
      switch (pattern349 (x1))
        {
        case 0:
          if (!
#line 5315 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_211 (insn, operands);

        case 1:
          if (!
#line 5315 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_219 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      switch (pattern349 (x1))
        {
        case 0:
          if (!
#line 5315 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_215 (insn, operands);

        case 1:
          if (!
#line 5315 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_223 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern350 (x1))
        {
        case 0:
          if (!(
#line 7213 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7215 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 1:
          if (!(
#line 7213 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7215 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_228 (insn, operands);

        case 2:
          if (!(
#line 7213 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7215 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_229 (insn, operands);

        case 3:
          if (!(
#line 7213 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7215 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_230 (insn, operands);

        case 4:
          if (!(
#line 7213 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7215 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 5:
          if (!(
#line 7276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_232 (insn, operands);

        case 6:
          if (!(
#line 7276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_233 (insn, operands);

        case 7:
          if (!(
#line 7276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 8:
          if (!(
#line 7276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 9:
          if (!(
#line 7364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7366 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_236 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 127
          || pattern563 (x2) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 2);
      if (XWINT (x10, 0) == 1L)
        {
          x11 = XVECEXP (x3, 0, 3);
          switch (GET_CODE (x11))
            {
            case CONST:
              switch (pattern1095 (x1))
                {
                case 0:
                  if ((
#line 1000 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1004 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_566 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1056 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_570 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
              switch (pattern1097 (x1))
                {
                case 0:
                  if ((
#line 1026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1030 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_567 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1030 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_568 (insn, operands);
                  break;

                case 2:
                  if ((
#line 1026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1030 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_569 (insn, operands);
                  break;

                case 3:
                  if ((
#line 1078 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1082 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_571 (insn, operands);
                  break;

                case 4:
                  if ((
#line 1078 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1082 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_572 (insn, operands);
                  break;

                case 5:
                  if ((
#line 1078 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1082 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_573 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case UNSPEC:
              res = split_132 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
        }
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 3)
        return NULL;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !aarch64_sve_ptrue_flag (x10, E_SImode))
        return NULL;
      x13 = XVECEXP (x11, 0, 1);
      if (!aarch64_sve_ptrue_flag (x13, E_SImode))
        return NULL;
      return split_135 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern355 (x1))
        {
        case 0:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1041 (insn, operands);

        case 1:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1060 (insn, operands);

        case 2:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1042 (insn, operands);

        case 3:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1043 (insn, operands);

        case 4:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1044 (insn, operands);

        case 5:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1045 (insn, operands);

        case 6:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1061 (insn, operands);

        case 7:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1046 (insn, operands);

        case 8:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1047 (insn, operands);

        case 9:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1048 (insn, operands);

        case 10:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1062 (insn, operands);

        case 11:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1049 (insn, operands);

        case 12:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1050 (insn, operands);

        case 13:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1063 (insn, operands);

        case 14:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1051 (insn, operands);

        case 15:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1065 (insn, operands);

        case 16:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1052 (insn, operands);

        case 17:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1053 (insn, operands);

        case 18:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1054 (insn, operands);

        case 19:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1064 (insn, operands);

        case 20:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1055 (insn, operands);

        case 21:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1056 (insn, operands);

        case 22:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1057 (insn, operands);

        case 23:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1066 (insn, operands);

        case 24:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1058 (insn, operands);

        case 25:
          if (!(
#line 2750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2756 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1059 (insn, operands);

        case 26:
          if (!(
#line 2783 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2796 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1067 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      return split_136 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2SFmode))
    {
      switch (pattern934 (
E_V2SFmode))
        {
        case 0:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_24 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_36 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_42 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_48 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_54 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2SFmode))
    {
      if (register_operand (operands[1], E_V2SFmode))
        {
          switch (pattern990 ())
            {
            case 0:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_60 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_66 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_72 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_78 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_84 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_90 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern992 (x2, 
E_V2SFmode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2SFmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_237 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern936 (x2, 
E_V2SFmode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2SFmode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_241 (insn, operands);
}
