/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case SUBREG:
    case TRUNCATE:
      return pattern17 (x3); /* [-1, 1] */

    case MINUS:
      res = pattern4 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case REG:
      operands[2] = x5;
      if (!aarch64_simd_register (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!aarch64_simd_register (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !aarch64_simd_register (operands[1], E_DImode))
            return -1;
          return 4;

        case E_SImode:
          if (!aarch64_simd_register (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !aarch64_simd_register (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern34 (x1, 
E_VNx16QImode, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern34 (x1, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern34 (x1, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern34 (x1, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx64QImode:
      if (pattern34 (x1, 
E_VNx16QImode, 
E_VNx64QImode) != 0)
        return -1;
      return 4;

    case E_VNx32HImode:
      if (pattern34 (x1, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
        return -1;
      return 5;

    case E_VNx16SImode:
      if (pattern34 (x1, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
        return -1;
      return 6;

    case E_VNx8DImode:
      if (pattern34 (x1, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern47 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern47 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          return 0;

        case E_VNx16QImode:
          if (!register_operand (operands[0], E_VNx16QImode)
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[1], E_VNx16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != XOR)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern64 (x3, 
E_V16QImode) != 0)
            return -1;
          return 2;

        case E_VNx16QImode:
          if (pattern64 (x3, 
E_VNx16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_tls_le_symref (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern77 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern77 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern77 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern77 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_di (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return pattern108 (x2); /* [-1, 1] */

    case VEC_SELECT:
      if (GET_MODE (x5) != E_V8QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!vect_par_cnst_hi_half (operands[2], E_V16QImode))
        return -1;
      res = pattern108 (x2);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern90 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern90 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern90 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern90 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern125 (x3); /* [-1, 2] */
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern116 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern116 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern116 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern124 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern124 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || pattern83 (x1, 
E_DImode, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 86
      || GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return 0;

    case E_VNx8HImode:
      return 1;

    case E_VNx4SImode:
      return 2;

    case E_VNx2DImode:
      return 3;

    case E_VNx8BFmode:
      return 4;

    case E_VNx8HFmode:
      return 5;

    case E_VNx4SFmode:
      return 6;

    case E_VNx2DFmode:
      return 7;

    default:
      return -1;
    }
}

int
pattern174 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !register_operand (operands[3], i1))
        return -1;
      return 0;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !register_operand (operands[3], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16BImode))
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern190 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern190 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern190 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern190 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern196 (x3, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern196 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern196 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern196 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern193 (x2, 
E_V16QImode, 
E_V8HFmode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern193 (x2, 
E_VNx16QImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern205 (x2, 
E_V8HFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || pattern213 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  return pattern218 (x3); /* [-1, 2] */
}

int
pattern225 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_VNx16QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 93
      || GET_MODE (x2) != E_VNx16QImode)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 4);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern231 (x3, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern231 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern231 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern231 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aligned_register_operand (operands[2], i1)
      || !aligned_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode)
          || !aligned_register_operand (operands[2], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode)
          || !aligned_register_operand (operands[2], E_VNx64QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode)
          || !aligned_register_operand (operands[2], E_VNx16HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode)
          || !aligned_register_operand (operands[2], E_VNx32HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!register_operand (operands[2], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!register_operand (operands[2], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!register_operand (operands[2], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!register_operand (operands[2], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!register_operand (operands[1], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!register_operand (operands[1], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!register_operand (operands[1], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!register_operand (operands[1], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern264 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || pattern264 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ldff1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          return pattern273 (x2, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern273 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern273 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern273 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx1TImode:
          if (pattern273 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[3] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          if (pattern274 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 5;

        case E_VNx8HImode:
          if (pattern274 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern274 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2DImode:
          if (pattern274 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx1TImode:
          if (pattern274 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern292 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern292 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern292 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1
      || !register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      return 0;

    case LSHIFTRT:
      res = pattern304 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern308 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      return 0;

    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern313 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 1;

        case E_VNx8QImode:
          if (pattern313 (x1, 
E_VNx8QImode) != 0)
            return -1;
          return 2;

        case E_VNx4QImode:
          if (pattern313 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 3;

        case E_VNx2QImode:
          if (pattern313 (x1, 
E_VNx2QImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern313 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 5;

        case E_VNx4HImode:
          if (pattern313 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 6;

        case E_VNx2HImode:
          if (pattern313 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 7;

        case E_VNx4SImode:
          if (pattern313 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 8;

        case E_VNx2SImode:
          if (pattern313 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 9;

        case E_VNx2DImode:
          if (pattern313 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern313 (x1, 
E_V2DImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern35 (x1);
      if (res >= 0)
        return res + 12; /* [12, 19] */
      return -1;

    default:
      return -1;
    }
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern325 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern325 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern325 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern325 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern351 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern351 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern351 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern351 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern364 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern365 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern365 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern365 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern380 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!aarch64_imm3 (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern384 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern384 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern390 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (XVECLEN (x3, 0) != 3
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern392 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CC_SWPmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CC_SWPmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  return pattern391 (x4); /* [-1, 1] */
}

int
pattern395 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 5;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 9;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 10;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 11;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 12;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 13;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 14;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 15;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 16;

    default:
      return -1;
    }
}

int
pattern423 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern422 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern422 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern422 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern428 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern427 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern427 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern427 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern438 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HImode)
      || GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
    return -1;
  return 0;
}

int
pattern443 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || pattern440 (x3, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || pattern441 (x3, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || pattern442 (x3, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern454 (rtx x1, unsigned int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern458 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      operands[4] = x8;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !const_int_operand (operands[3], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !const_int_operand (operands[3], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case AND:
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x9 = XEXP (x6, 1);
      operands[3] = x9;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !const_int_operand (operands[4], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !const_int_operand (operands[3], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !const_int_operand (operands[4], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !const_int_operand (operands[3], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern480 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[6], E_VNx2BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[5], E_VNx2BImode)
      || !register_operand (operands[2], E_VNx2DImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx2QImode:
      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_sve_gather_offset_w (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern493 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern510 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern504 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern504 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern504 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 168)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern509 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern509 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      res = pattern16 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern541 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern560 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (!register_operand (x7, i1))
    return -1;
  return 0;
}

int
pattern570 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern574 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern574 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern574 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern574 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern585 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern587 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  return 0;
}

int
pattern593 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_VNx2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_VNx2SImode)
    return -1;
  return 0;
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return pattern331 (x3); /* [-1, 4] */
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern603 (x1, 
E_SImode); /* [-1, 5] */

    case E_DImode:
      res = pattern603 (x1, 
E_DImode);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  return pattern293 (x1); /* [-1, 2] */
}

int
pattern612 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x4, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern610 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern610 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 1;

        case E_V2DImode:
          if (pattern610 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT)
        return -1;
      x10 = XEXP (x6, 0);
      operands[2] = x10;
      x11 = XEXP (x6, 1);
      operands[4] = x11;
      x12 = XEXP (x7, 0);
      operands[3] = x12;
      x13 = XEXP (x7, 1);
      if (!rtx_equal_p (x13, operands[4]))
        return -1;
      x14 = XEXP (x8, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x8, 1);
      if (!rtx_equal_p (x15, operands[4]))
        return -1;
      x16 = XEXP (x9, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern611 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V4SImode:
          if (pattern611 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern611 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return pattern631 (x1); /* [-1, 2] */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 168)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern632 (x1, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern632 (x1, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern646 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  if (!register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern661 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern655 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern655 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern655 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern655 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern655 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern655 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern671 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern669 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern669 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern669 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern670 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern670 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern670 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern686 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern691 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_lo_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern696 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern696 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern696 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern696 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern696 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern696 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern696 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern696 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern696 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern696 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern696 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern698 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern698 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern698 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern698 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern698 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern698 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern698 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern698 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern698 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern698 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern726 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ld1rq_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern729 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx2BImode)
      || !aarch64_sve_ld1ro_operand_d (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern735 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern596 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern596 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern596 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern596 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern596 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern596 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern596 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern596 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern596 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern596 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern755 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_imm24 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern760 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern759 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern759 (x1, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern759 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern759 (x1, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern759 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern759 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern764 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern764 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern764 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern764 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern764 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern764 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern784 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_V8DImode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_V8DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8DImode))
    return -1;
  return 0;
}

int
pattern796 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern805 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern812 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !const_1_to_3_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern819 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern828 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern834 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern842 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern848 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern857 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern863 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC)
    return -1;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 415:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              return pattern857 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

            case E_VNx8QImode:
              if (pattern857 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 1;

            case E_VNx4QImode:
              if (pattern857 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 2;

            case E_VNx2QImode:
              if (pattern857 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 3;

            case E_VNx8HImode:
              if (pattern857 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 4;

            case E_VNx4HImode:
              if (pattern857 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 5;

            case E_VNx2HImode:
              if (pattern857 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 6;

            case E_VNx4SImode:
              if (pattern857 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 7;

            case E_VNx2SImode:
              if (pattern857 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 8;

            case E_VNx2DImode:
              if (pattern857 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 9;

            default:
              return -1;
            }

        case 226:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 10;

            case E_VNx8QImode:
              if (pattern858 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 11;

            case E_VNx4QImode:
              if (pattern858 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 12;

            case E_VNx2QImode:
              if (pattern858 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 13;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 14;

            case E_VNx4HImode:
              if (pattern858 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 15;

            case E_VNx2HImode:
              if (pattern858 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 16;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 17;

            case E_VNx2SImode:
              if (pattern858 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 18;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 19;

            default:
              return -1;
            }

        case 224:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern857 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 20;

            case E_VNx8QImode:
              if (pattern857 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 21;

            case E_VNx4QImode:
              if (pattern857 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 22;

            case E_VNx2QImode:
              if (pattern857 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 23;

            case E_VNx8HImode:
              if (pattern857 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 24;

            case E_VNx4HImode:
              if (pattern857 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 25;

            case E_VNx2HImode:
              if (pattern857 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 26;

            case E_VNx4SImode:
              if (pattern857 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 27;

            case E_VNx2SImode:
              if (pattern857 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 28;

            case E_VNx2DImode:
              if (pattern857 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 29;

            default:
              return -1;
            }

        case 225:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern857 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 30;

            case E_VNx8QImode:
              if (pattern857 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 31;

            case E_VNx4QImode:
              if (pattern857 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 32;

            case E_VNx2QImode:
              if (pattern857 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 33;

            case E_VNx8HImode:
              if (pattern857 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 34;

            case E_VNx4HImode:
              if (pattern857 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 35;

            case E_VNx2HImode:
              if (pattern857 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 36;

            case E_VNx4SImode:
              if (pattern857 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 37;

            case E_VNx2SImode:
              if (pattern857 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 38;

            case E_VNx2DImode:
              if (pattern857 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 39;

            default:
              return -1;
            }

        case 210:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 40;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 41;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 42;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 43;

            default:
              return -1;
            }

        case 214:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 44;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 45;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 46;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 47;

            default:
              return -1;
            }

        case 233:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 48;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 49;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 50;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 51;

            default:
              return -1;
            }

        case 212:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 52;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 53;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 54;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 55;

            default:
              return -1;
            }

        case 231:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 56;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 57;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 58;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 59;

            default:
              return -1;
            }

        case 221:
          res = pattern861 (x1);
          if (res >= 0)
            return res + 60; /* [60, 67] */
          return -1;

        case 211:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 68;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 69;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 70;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 71;

            default:
              return -1;
            }

        case 215:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 72;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 73;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 74;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 75;

            default:
              return -1;
            }

        case 234:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 76;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 77;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 78;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 79;

            default:
              return -1;
            }

        case 213:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 80;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 81;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 82;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 83;

            default:
              return -1;
            }

        case 232:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 84;

            case E_VNx8HImode:
              if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 85;

            case E_VNx4SImode:
              if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 86;

            case E_VNx2DImode:
              if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 87;

            default:
              return -1;
            }

        case 220:
          res = pattern861 (x1);
          if (res >= 0)
            return res + 88; /* [88, 95] */
          return -1;

        case 227:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern862 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 96;

            case E_VNx8HImode:
              if (pattern862 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 97;

            case E_VNx4SImode:
              if (pattern862 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 98;

            case E_VNx2DImode:
              if (pattern862 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 99;

            default:
              return -1;
            }

        case 228:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern862 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 100;

            case E_VNx8HImode:
              if (pattern862 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 101;

            case E_VNx4SImode:
              if (pattern862 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 102;

            case E_VNx2DImode:
              if (pattern862 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 103;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      operands[4] = x6;
      if (GET_MODE (x3) != E_VNx4SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 26:
          return 104;

        case 111:
          return 105;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1052 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1062 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      return pattern1046 (x1); /* [-1, 6] */

    case 1L:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      res = pattern1046 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1070 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1079 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1078 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1086 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1091 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1)
      || !aarch64_simd_umax_half_mode (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  return 0;
}

int
pattern1106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_mul_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1110 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1110 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1110 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1111 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1111 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1111 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1130 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern1144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SFmode
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1153 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1)
      || pattern991 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1177 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1184 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i4))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern1183 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1192 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1195 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1195 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1195 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1195 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[5] = x6;
  if (!aarch64_sve_ptrue_flag (operands[5], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[6] = x7;
  switch (GET_MODE (x4))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[6], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[6], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[6], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[6], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern1226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_b (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1245 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_int_rnd_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1255 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1267 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!aarch64_valid_symref (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1284 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern1293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16BImode)
      || !register_operand (operands[4], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern1292 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern1292 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern1292 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1303 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!aarch64_imm3 (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1302 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1302 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1316 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_VNx16QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!register_operand (operands[2], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!register_operand (operands[2], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1336 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[2], E_VNx4SImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1343 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !aarch64_borrow_operation (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1362 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 126)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x6, operands[6]))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x7, operands[7]))
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          return pattern1361 (x1, 
E_VNx16BImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1361 (x1, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1361 (x1, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 3;

        case E_VNx8BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8HImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 4;

        case E_VNx4BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4SImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10514; /* aarch64_sve_revvnx16qi */

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x3) != E_VNx8QImode
          || !register_operand (operands[1], E_VNx8QImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10515; /* aarch64_sve_revvnx8qi */

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x3) != E_VNx4QImode
          || !register_operand (operands[1], E_VNx4QImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10516; /* aarch64_sve_revvnx4qi */

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x3) != E_VNx2QImode
          || !register_operand (operands[1], E_VNx2QImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10517; /* aarch64_sve_revvnx2qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10518; /* aarch64_sve_revvnx8hi */

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x3) != E_VNx4HImode
          || !register_operand (operands[1], E_VNx4HImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10519; /* aarch64_sve_revvnx4hi */

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x3) != E_VNx2HImode
          || !register_operand (operands[1], E_VNx2HImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10520; /* aarch64_sve_revvnx2hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10521; /* aarch64_sve_revvnx4si */

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x3) != E_VNx2SImode
          || !register_operand (operands[1], E_VNx2SImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10522; /* aarch64_sve_revvnx2si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10523; /* aarch64_sve_revvnx2di */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10524; /* aarch64_sve_revvnx8hf */

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x3) != E_VNx4HFmode
          || !register_operand (operands[1], E_VNx4HFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10525; /* aarch64_sve_revvnx4hf */

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x3) != E_VNx2HFmode
          || !register_operand (operands[1], E_VNx2HFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10526; /* aarch64_sve_revvnx2hf */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !register_operand (operands[1], E_VNx8BFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10527; /* aarch64_sve_revvnx8bf */

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x3) != E_VNx4BFmode
          || !register_operand (operands[1], E_VNx4BFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10528; /* aarch64_sve_revvnx4bf */

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x3) != E_VNx2BFmode
          || !register_operand (operands[1], E_VNx2BFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10529; /* aarch64_sve_revvnx2bf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10530; /* aarch64_sve_revvnx4sf */

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x3) != E_VNx2SFmode
          || !register_operand (operands[1], E_VNx2SFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10531; /* aarch64_sve_revvnx2sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 9223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10532; /* aarch64_sve_revvnx2df */

    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || !
#line 9314 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10798; /* aarch64_sve_revvnx16bi */

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || !
#line 9314 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10799; /* aarch64_sve_revvnx8bi */

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !
#line 9314 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10800; /* aarch64_sve_revvnx4bi */

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || !
#line 9314 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10801; /* aarch64_sve_revvnx2bi */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5156; /* aarch64_frecpev4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5157; /* aarch64_frecpev8hf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5158; /* aarch64_frecpev2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5159; /* aarch64_frecpev4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5160; /* aarch64_frecpev2df */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5161; /* aarch64_frecpehf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5162; /* aarch64_frecpesf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 8840 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5163; /* aarch64_frecpedf */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3702 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7199; /* aarch64_sve_frecpevnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 3702 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7201; /* aarch64_sve_frecpevnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 3702 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7203; /* aarch64_sve_frecpevnx2df */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x16QImode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4459; /* aarch64_simd_ld3v16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HImode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4460; /* aarch64_simd_ld3v8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SImode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4461; /* aarch64_simd_ld3v4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DImode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4462; /* aarch64_simd_ld3v2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HFmode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4463; /* aarch64_simd_ld3v8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SFmode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4464; /* aarch64_simd_ld3v4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DFmode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4465; /* aarch64_simd_ld3v2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8BFmode)
          || !
#line 7664 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4466; /* aarch64_simd_ld3v8bf */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern61 (x1))
    {
    case 0:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5030; /* aarch64_rev16v8qi */

    case 1:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5035; /* aarch64_rev16v16qi */

    case 2:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5042; /* aarch64_rev16v4hi */

    case 3:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5047; /* aarch64_rev16v8hi */

    case 4:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5054; /* aarch64_rev16v2si */

    case 5:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5059; /* aarch64_rev16v4si */

    case 6:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5062; /* aarch64_rev16v2di */

    case 7:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5069; /* aarch64_rev16v4hf */

    case 8:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5074; /* aarch64_rev16v8hf */

    case 9:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5081; /* aarch64_rev16v4bf */

    case 10:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5086; /* aarch64_rev16v8bf */

    case 11:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5093; /* aarch64_rev16v2sf */

    case 12:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5098; /* aarch64_rev16v4sf */

    case 13:
      if (!
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5101; /* aarch64_rev16v2df */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern55 (x1))
    {
    case 0:
      if (!(
#line 6857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 900; /* floorhf2 */

    case 1:
      if (!
#line 6857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 907; /* floorsf2 */

    case 2:
      if (!
#line 6857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 914; /* floordf2 */

    case 3:
      if (!(
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2495; /* floorv4hf2 */

    case 4:
      if (!(
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2512; /* floorv8hf2 */

    case 5:
      if (!
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2523; /* floorv2sf2 */

    case 6:
      if (!
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2540; /* floorv4sf2 */

    case 7:
      if (!
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2547; /* floorv2df2 */

    case 8:
      if (!
#line 700 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11459; /* floorvnx8sf2 */

    case 9:
      if (!
#line 700 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11463; /* floorvnx16sf2 */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 8869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5175; /* aarch64_urecpev2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 8869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5176; /* aarch64_urecpev4si */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 8L:
      if (!
#line 596 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11434; /* aarch64_sve_ptrue_c8 */

    case 16L:
      if (!
#line 596 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11435; /* aarch64_sve_ptrue_c16 */

    case 32L:
      if (!
#line 596 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11436; /* aarch64_sve_ptrue_c32 */

    case 64L:
      if (!
#line 596 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11437; /* aarch64_sve_ptrue_c64 */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern716 (x2))
        {
        case 0:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
            return -1;
          return 7002; /* *extendvnx8qivnx8hi2 */

        case 1:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
            return -1;
          return 7004; /* *extendvnx4qivnx8hi2 */

        case 2:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
            return -1;
          return 7006; /* *extendvnx2qivnx8hi2 */

        case 3:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
            return -1;
          return 7008; /* *extendvnx4hivnx8hi2 */

        case 4:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
            return -1;
          return 7010; /* *extendvnx2hivnx8hi2 */

        case 5:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
            return -1;
          return 7012; /* *extendvnx2sivnx8hi2 */

        case 6:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
            return -1;
          return 7014; /* *extendvnx8qivnx4hi2 */

        case 7:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
            return -1;
          return 7016; /* *extendvnx4qivnx4hi2 */

        case 8:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
            return -1;
          return 7018; /* *extendvnx2qivnx4hi2 */

        case 9:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
            return -1;
          return 7020; /* *extendvnx4hivnx4hi2 */

        case 10:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
            return -1;
          return 7022; /* *extendvnx2hivnx4hi2 */

        case 11:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
            return -1;
          return 7024; /* *extendvnx2sivnx4hi2 */

        case 12:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
            return -1;
          return 7026; /* *extendvnx8qivnx2hi2 */

        case 13:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
            return -1;
          return 7028; /* *extendvnx4qivnx2hi2 */

        case 14:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
            return -1;
          return 7030; /* *extendvnx2qivnx2hi2 */

        case 15:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
            return -1;
          return 7032; /* *extendvnx4hivnx2hi2 */

        case 16:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
            return -1;
          return 7034; /* *extendvnx2hivnx2hi2 */

        case 17:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
            return -1;
          return 7036; /* *extendvnx2sivnx2hi2 */

        case 18:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
            return -1;
          return 7038; /* *extendvnx8qivnx4si2 */

        case 19:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
            return -1;
          return 7040; /* *extendvnx4qivnx4si2 */

        case 20:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
            return -1;
          return 7042; /* *extendvnx2qivnx4si2 */

        case 21:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
            return -1;
          return 7044; /* *extendvnx4hivnx4si2 */

        case 22:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
            return -1;
          return 7046; /* *extendvnx2hivnx4si2 */

        case 23:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
            return -1;
          return 7048; /* *extendvnx2sivnx4si2 */

        case 24:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
            return -1;
          return 7050; /* *extendvnx8qivnx2si2 */

        case 25:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
            return -1;
          return 7052; /* *extendvnx4qivnx2si2 */

        case 26:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
            return -1;
          return 7054; /* *extendvnx2qivnx2si2 */

        case 27:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
            return -1;
          return 7056; /* *extendvnx4hivnx2si2 */

        case 28:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
            return -1;
          return 7058; /* *extendvnx2hivnx2si2 */

        case 29:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
            return -1;
          return 7060; /* *extendvnx2sivnx2si2 */

        case 30:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
            return -1;
          return 7062; /* *extendvnx8qivnx2di2 */

        case 31:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
            return -1;
          return 7064; /* *extendvnx4qivnx2di2 */

        case 32:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
            return -1;
          return 7066; /* *extendvnx2qivnx2di2 */

        case 33:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
            return -1;
          return 7068; /* *extendvnx4hivnx2di2 */

        case 34:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
            return -1;
          return 7070; /* *extendvnx2hivnx2di2 */

        case 35:
          if (!
#line 3407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
            return -1;
          return 7072; /* *extendvnx2sivnx2di2 */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          switch (pattern943 (x2, 
E_VNx8HImode, 
E_VNx8BImode))
            {
            case 0:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x81) == 0))
                return -1;
              return 7074; /* aarch64_pred_sxtvnx8hivnx8qi */

            case 1:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x41) == 0))
                return -1;
              return 7075; /* aarch64_pred_sxtvnx8hivnx4qi */

            case 2:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x21) == 0))
                return -1;
              return 7076; /* aarch64_pred_sxtvnx8hivnx2qi */

            case 3:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x42) == 0))
                return -1;
              return 7077; /* aarch64_pred_sxtvnx8hivnx4hi */

            case 4:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x22) == 0))
                return -1;
              return 7078; /* aarch64_pred_sxtvnx8hivnx2hi */

            case 5:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x24) == 0))
                return -1;
              return 7079; /* aarch64_pred_sxtvnx8hivnx2si */

            default:
              return -1;
            }

        case E_VNx4SImode:
          switch (pattern943 (x2, 
E_VNx4SImode, 
E_VNx4BImode))
            {
            case 0:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x81) == 0))
                return -1;
              return 7080; /* aarch64_pred_sxtvnx4sivnx8qi */

            case 1:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x41) == 0))
                return -1;
              return 7081; /* aarch64_pred_sxtvnx4sivnx4qi */

            case 2:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x21) == 0))
                return -1;
              return 7082; /* aarch64_pred_sxtvnx4sivnx2qi */

            case 3:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x42) == 0))
                return -1;
              return 7083; /* aarch64_pred_sxtvnx4sivnx4hi */

            case 4:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x22) == 0))
                return -1;
              return 7084; /* aarch64_pred_sxtvnx4sivnx2hi */

            case 5:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x24) == 0))
                return -1;
              return 7085; /* aarch64_pred_sxtvnx4sivnx2si */

            default:
              return -1;
            }

        case E_VNx2DImode:
          switch (pattern943 (x2, 
E_VNx2DImode, 
E_VNx2BImode))
            {
            case 0:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x81) == 0))
                return -1;
              return 7086; /* aarch64_pred_sxtvnx2divnx8qi */

            case 1:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x41) == 0))
                return -1;
              return 7087; /* aarch64_pred_sxtvnx2divnx4qi */

            case 2:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x21) == 0))
                return -1;
              return 7088; /* aarch64_pred_sxtvnx2divnx2qi */

            case 3:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x42) == 0))
                return -1;
              return 7089; /* aarch64_pred_sxtvnx2divnx4hi */

            case 4:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x22) == 0))
                return -1;
              return 7090; /* aarch64_pred_sxtvnx2divnx2hi */

            case 5:
              if (!
#line 3423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x24) == 0))
                return -1;
              return 7091; /* aarch64_pred_sxtvnx2divnx2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HFmode:
          if (pattern77 (x3, 
E_V4HFmode) != 0
              || !(
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 3223; /* aarch64_fmulxv4hf */

        case E_V8HFmode:
          if (pattern77 (x3, 
E_V8HFmode) != 0
              || !(
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 3224; /* aarch64_fmulxv8hf */

        case E_V2SFmode:
          if (pattern77 (x3, 
E_V2SFmode) != 0
              || !
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3225; /* aarch64_fmulxv2sf */

        case E_V4SFmode:
          if (pattern77 (x3, 
E_V4SFmode) != 0
              || !
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3226; /* aarch64_fmulxv4sf */

        case E_V2DFmode:
          if (pattern77 (x3, 
E_V2DFmode) != 0
              || !
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3227; /* aarch64_fmulxv2df */

        case E_HFmode:
          if (pattern77 (x3, 
E_HFmode) != 0
              || !(
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 3228; /* aarch64_fmulxhf */

        case E_SFmode:
          if (pattern77 (x3, 
E_SFmode) != 0
              || !
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3229; /* aarch64_fmulxsf */

        case E_DFmode:
          if (pattern77 (x3, 
E_DFmode) != 0
              || !
#line 5089 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3230; /* aarch64_fmulxdf */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case VEC_SELECT:
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL
              || XVECLEN (x7, 0) != 1)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XVECEXP (x7, 0, 0);
          operands[3] = x9;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern1120 (x3, 
E_SFmode, 
E_V2SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[2], E_V4SFmode)
                      || !
#line 5105 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3231; /* *aarch64_mulx_elt_to_128v2sf */

                case E_V2SFmode:
                  if (!register_operand (operands[2], E_V2SFmode)
                      || !
#line 5124 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3233; /* *aarch64_mulx_eltv2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern1120 (x3, 
E_SFmode, 
E_V4SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[2], E_V2SFmode)
                      || !
#line 5105 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3232; /* *aarch64_mulx_elt_to_64v4sf */

                case E_V4SFmode:
                  if (!register_operand (operands[2], E_V4SFmode)
                      || !
#line 5124 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3234; /* *aarch64_mulx_eltv4sf */

                default:
                  return -1;
                }

            case E_V2DFmode:
              if (pattern1120 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !register_operand (operands[2], E_V2DFmode)
                  || !
#line 5124 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3235; /* *aarch64_mulx_eltv2df */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HFmode:
              if (pattern796 (x3, 
E_HFmode, 
E_V4HFmode) != 0
                  || !(
#line 5141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 3236; /* *aarch64_mulx_elt_from_dupv4hf */

            case E_V8HFmode:
              if (pattern796 (x3, 
E_HFmode, 
E_V8HFmode) != 0
                  || !(
#line 5141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 3237; /* *aarch64_mulx_elt_from_dupv8hf */

            case E_V2SFmode:
              if (pattern796 (x3, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 5141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3238; /* *aarch64_mulx_elt_from_dupv2sf */

            case E_V4SFmode:
              if (pattern796 (x3, 
E_SFmode, 
E_V4SFmode) != 0
                  || !
#line 5141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3239; /* *aarch64_mulx_elt_from_dupv4sf */

            case E_V2DFmode:
              if (pattern796 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 5141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3240; /* *aarch64_mulx_elt_from_dupv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x11 = XVECEXP (x10, 0, 0);
      operands[3] = x11;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || GET_MODE (x5) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SFmode:
              if (!register_operand (operands[2], E_V2SFmode)
                  || !
#line 5158 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3241; /* *aarch64_vgetfmulxv2sf */

            case E_V4SFmode:
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 5158 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3242; /* *aarch64_vgetfmulxv4sf */

            default:
              return -1;
            }

        case E_DFmode:
          if (pattern796 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 5158 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3243; /* *aarch64_vgetfmulxv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern97 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_V4HImode) != 0
              || !
#line 5557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3445; /* aarch64_sqrdmulhv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_V8HImode) != 0
              || !
#line 5557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3449; /* aarch64_sqrdmulhv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_V2SImode) != 0
              || !
#line 5557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3453; /* aarch64_sqrdmulhv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_V4SImode) != 0
              || !
#line 5557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3457; /* aarch64_sqrdmulhv4si */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_HImode) != 0
              || !
#line 5557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3459; /* aarch64_sqrdmulhhi */

        case E_SImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_SImode) != 0
              || !
#line 5557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3461; /* aarch64_sqrdmulhsi */

        case E_VNx16QImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_VNx16QImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11814; /* aarch64_sve_sqrdmulhvnx16qi */

        case E_VNx8HImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_VNx8HImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11816; /* aarch64_sve_sqrdmulhvnx8hi */

        case E_VNx4SImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_VNx4SImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11818; /* aarch64_sve_sqrdmulhvnx4si */

        case E_VNx2DImode:
          x2 = XEXP (x1, 1);
          if (pattern77 (x2, 
E_VNx2DImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11820; /* aarch64_sve_sqrdmulhvnx2di */

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern796 (x2, 
E_HImode, 
E_V4HImode) != 0
              || !
#line 5569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3465; /* aarch64_sqrdmulh_nv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern796 (x2, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 5569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3469; /* aarch64_sqrdmulh_nv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern796 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 5569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3473; /* aarch64_sqrdmulh_nv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern796 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 5569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3477; /* aarch64_sqrdmulh_nv4si */

        default:
          return -1;
        }

    case 2:
      if (!
#line 5584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3481; /* aarch64_sqrdmulh_lanev4hi */

    case 3:
      if (!
#line 5599 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3497; /* aarch64_sqrdmulh_laneqv4hi */

    case 4:
      if (!
#line 5584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3485; /* aarch64_sqrdmulh_lanev8hi */

    case 5:
      if (!
#line 5599 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3501; /* aarch64_sqrdmulh_laneqv8hi */

    case 6:
      if (!
#line 5584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3489; /* aarch64_sqrdmulh_lanev2si */

    case 7:
      if (!
#line 5599 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3505; /* aarch64_sqrdmulh_laneqv2si */

    case 8:
      if (!
#line 5584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3493; /* aarch64_sqrdmulh_lanev4si */

    case 9:
      if (!
#line 5599 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3509; /* aarch64_sqrdmulh_laneqv4si */

    case 10:
      if (!
#line 5614 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3511; /* aarch64_sqrdmulh_lanehi */

    case 11:
      if (!
#line 5629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3515; /* aarch64_sqrdmulh_laneqhi */

    case 12:
      if (!
#line 5614 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3513; /* aarch64_sqrdmulh_lanesi */

    case 13:
      if (!
#line 5629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3517; /* aarch64_sqrdmulh_laneqsi */

    case 14:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11822; /* aarch64_sve_sqrdmulh_lane_vnx8hi */

    case 15:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11824; /* aarch64_sve_sqrdmulh_lane_vnx4si */

    case 16:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11826; /* aarch64_sve_sqrdmulh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[1], E_V3x8QImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4507; /* aarch64_vec_store_lanesv3x8qi_lanev8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[1], E_V3x4HImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4508; /* aarch64_vec_store_lanesv3x4hi_lanev4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[1], E_V3x2SImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4509; /* aarch64_vec_store_lanesv3x2si_lanev2si */

    case E_V3x1DImode:
      if (!register_operand (operands[1], E_V3x1DImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4510; /* aarch64_vec_store_lanesv3x1di_lanedi */

    case E_V3x4HFmode:
      if (!register_operand (operands[1], E_V3x4HFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4511; /* aarch64_vec_store_lanesv3x4hf_lanev4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[1], E_V3x2SFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4512; /* aarch64_vec_store_lanesv3x2sf_lanev2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[1], E_V3x1DFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4513; /* aarch64_vec_store_lanesv3x1df_lanedf */

    case E_V3x4BFmode:
      if (!register_operand (operands[1], E_V3x4BFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4514; /* aarch64_vec_store_lanesv3x4bf_lanev4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[1], E_V3x16QImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4515; /* aarch64_vec_store_lanesv3x16qi_lanev16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[1], E_V3x8HImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4516; /* aarch64_vec_store_lanesv3x8hi_lanev8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[1], E_V3x4SImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4517; /* aarch64_vec_store_lanesv3x4si_lanev4si */

    case E_V3x2DImode:
      if (!register_operand (operands[1], E_V3x2DImode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4518; /* aarch64_vec_store_lanesv3x2di_lanev2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[1], E_V3x8HFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4519; /* aarch64_vec_store_lanesv3x8hf_lanev8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[1], E_V3x4SFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4520; /* aarch64_vec_store_lanesv3x4sf_lanev4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[1], E_V3x2DFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4521; /* aarch64_vec_store_lanesv3x2df_lanev2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[1], E_V3x8BFmode)
          || !
#line 7730 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4522; /* aarch64_vec_store_lanesv3x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern99 (x1))
    {
    case 0:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3650; /* aarch64_srshlv8qi */

    case 1:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3658; /* aarch64_srshlv16qi */

    case 2:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3666; /* aarch64_srshlv4hi */

    case 3:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3674; /* aarch64_srshlv8hi */

    case 4:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3682; /* aarch64_srshlv2si */

    case 5:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3690; /* aarch64_srshlv4si */

    case 6:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3694; /* aarch64_srshlv2di */

    case 7:
      if (!
#line 6509 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3702; /* aarch64_srshldi */

    case 8:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11539; /* aarch64_sve_srshlvnx32qi */

    case 9:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11542; /* aarch64_sve_srshlvnx16hi */

    case 10:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11545; /* aarch64_sve_srshlvnx8si */

    case 11:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11548; /* aarch64_sve_srshlvnx4di */

    case 12:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11551; /* aarch64_sve_srshlvnx64qi */

    case 13:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11554; /* aarch64_sve_srshlvnx32hi */

    case 14:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11557; /* aarch64_sve_srshlvnx16si */

    case 15:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11560; /* aarch64_sve_srshlvnx8di */

    case 16:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11563; /* aarch64_sve_single_srshlvnx32qi */

    case 17:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11566; /* aarch64_sve_single_srshlvnx16hi */

    case 18:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11569; /* aarch64_sve_single_srshlvnx8si */

    case 19:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11572; /* aarch64_sve_single_srshlvnx4di */

    case 20:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11575; /* aarch64_sve_single_srshlvnx64qi */

    case 21:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11578; /* aarch64_sve_single_srshlvnx32hi */

    case 22:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11581; /* aarch64_sve_single_srshlvnx16si */

    case 23:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11584; /* aarch64_sve_single_srshlvnx8di */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10550; /* aarch64_sve_zipq2vnx16qi */

    case 1:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10560; /* aarch64_sve_zipq2vnx8qi */

    case 2:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10570; /* aarch64_sve_zipq2vnx4qi */

    case 3:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10580; /* aarch64_sve_zipq2vnx2qi */

    case 4:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10590; /* aarch64_sve_zipq2vnx8hi */

    case 5:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10600; /* aarch64_sve_zipq2vnx4hi */

    case 6:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10610; /* aarch64_sve_zipq2vnx2hi */

    case 7:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10620; /* aarch64_sve_zipq2vnx4si */

    case 8:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10630; /* aarch64_sve_zipq2vnx2si */

    case 9:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10640; /* aarch64_sve_zipq2vnx2di */

    case 10:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10650; /* aarch64_sve_zipq2vnx8hf */

    case 11:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10660; /* aarch64_sve_zipq2vnx4hf */

    case 12:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10670; /* aarch64_sve_zipq2vnx2hf */

    case 13:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10680; /* aarch64_sve_zipq2vnx8bf */

    case 14:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10690; /* aarch64_sve_zipq2vnx4bf */

    case 15:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10700; /* aarch64_sve_zipq2vnx2bf */

    case 16:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10710; /* aarch64_sve_zipq2vnx4sf */

    case 17:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10720; /* aarch64_sve_zipq2vnx2sf */

    case 18:
      if (!(
#line 9267 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10730; /* aarch64_sve_zipq2vnx2df */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern77 (x3, 
E_VNx16QImode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10468; /* aarch64_sve_tblqvnx16qi */

    case E_VNx8HImode:
      if (pattern77 (x3, 
E_VNx8HImode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10470; /* aarch64_sve_tblqvnx8hi */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10472; /* aarch64_sve_tblqvnx4si */

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10474; /* aarch64_sve_tblqvnx2di */

    case E_VNx8BFmode:
      if (pattern116 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10476; /* aarch64_sve_tblqvnx8bf */

    case E_VNx8HFmode:
      if (pattern116 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10478; /* aarch64_sve_tblqvnx8hf */

    case E_VNx4SFmode:
      if (pattern116 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10480; /* aarch64_sve_tblqvnx4sf */

    case E_VNx2DFmode:
      if (pattern116 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !(
#line 9145 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3190 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10482; /* aarch64_sve_tblqvnx2df */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern116 (x3, 
E_V4HImode, 
E_V4HFmode) != 0
          || !(
#line 10143 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5332; /* aarch64_fscalev4hf */

    case E_V8HFmode:
      if (pattern116 (x3, 
E_V8HImode, 
E_V8HFmode) != 0
          || !(
#line 10143 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5333; /* aarch64_fscalev8hf */

    case E_V2SFmode:
      if (pattern116 (x3, 
E_V2SImode, 
E_V2SFmode) != 0
          || !
#line 10143 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5334; /* aarch64_fscalev2sf */

    case E_V4SFmode:
      if (pattern116 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 10143 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5335; /* aarch64_fscalev4sf */

    case E_V2DFmode:
      if (pattern116 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 10143 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5336; /* aarch64_fscalev2df */

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern118 (x1))
    {
    case 0:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9026; /* *andvnx8hf3 */

    case 1:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9029; /* *andvnx4hf3 */

    case 2:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9032; /* *andvnx2hf3 */

    case 3:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9035; /* *andvnx8bf3 */

    case 4:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9038; /* *andvnx4bf3 */

    case 5:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9041; /* *andvnx2bf3 */

    case 6:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9044; /* *andvnx4sf3 */

    case 7:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9047; /* *andvnx2sf3 */

    case 8:
      if (!
#line 6631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9050; /* *andvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern122 (x1))
    {
    case 0:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10734; /* aarch64_sve_trn2qvnx16qi */

    case 1:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10740; /* aarch64_sve_trn2qvnx8hi */

    case 2:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10746; /* aarch64_sve_trn2qvnx4si */

    case 3:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10752; /* aarch64_sve_trn2qvnx2di */

    case 4:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10758; /* aarch64_sve_trn2qvnx8bf */

    case 5:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10764; /* aarch64_sve_trn2qvnx8hf */

    case 6:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10770; /* aarch64_sve_trn2qvnx4sf */

    case 7:
      if (!
#line 9279 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10776; /* aarch64_sve_trn2qvnx2df */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern92 (x1))
    {
    case 0:
      if (!(
#line 1813 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2173; /* aarch64_smin_nanpv4hf */

    case 1:
      if (!(
#line 1813 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2183; /* aarch64_smin_nanpv8hf */

    case 2:
      if (!
#line 1813 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2189; /* aarch64_smin_nanpv2sf */

    case 3:
      if (!
#line 1813 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2199; /* aarch64_smin_nanpv4sf */

    case 4:
      if (!
#line 1813 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2203; /* aarch64_smin_nanpv2df */

    case 5:
      if (!
#line 9079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10452; /* aarch64_pred_reduc_smin_nan_vnx8hf */

    case 6:
      if (!
#line 9079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10457; /* aarch64_pred_reduc_smin_nan_vnx4sf */

    case 7:
      if (!
#line 9079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10462; /* aarch64_pred_reduc_smin_nan_vnx2df */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x4QImode:
      if (pattern709 (x3, 
E_SImode, 
E_V2x4QImode) != 0)
        return -1;
      return 91; /* *store_pair_4 */

    case E_V2x8QImode:
      if (pattern709 (x3, 
E_DImode, 
E_V2x8QImode) != 0)
        return -1;
      return 92; /* *store_pair_8 */

    case E_V2x16QImode:
      if (!aarch64_mem_pair_lanes_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !aarch64_ldp_reg_operand (operands[1], E_TImode)
          || !aarch64_ldp_reg_operand (operands[2], E_TImode)
          || !
#line 2110 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 93; /* *store_pair_16 */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern128 (x1))
    {
    case 0:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12142; /* aarch64_sve_smulltvnx8hi */

    case 1:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12163; /* aarch64_sve_smulltvnx4si */

    case 2:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12184; /* aarch64_sve_smulltvnx2di */

    case 3:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12200; /* aarch64_sve_smullt_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12206; /* aarch64_sve_smullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12787; /* aarch64_pred_reduc_umaxqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12795; /* aarch64_pred_reduc_umaxqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12803; /* aarch64_pred_reduc_umaxqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12811; /* aarch64_pred_reduc_umaxqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12559; /* aarch64_sve_cadd90vnx16qi */

    case 1:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12563; /* aarch64_sve_cadd90vnx8hi */

    case 2:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12567; /* aarch64_sve_cadd90vnx4si */

    case 3:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12571; /* aarch64_sve_cadd90vnx2di */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (XWINT (x4, 0) == 0L)
    {
      x5 = XVECEXP (x3, 0, 2);
      x6 = XVECEXP (x5, 0, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x5, 0, 0);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1275 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) == 0
                  && 
#line 6406 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 9007; /* *aarch64_cond_abdvnx8hf_3_relaxed */
              break;

            case E_VNx4SFmode:
              if (pattern1275 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) == 0
                  && 
#line 6406 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 9008; /* *aarch64_cond_abdvnx4sf_3_relaxed */
              break;

            case E_VNx2DFmode:
              if (pattern1275 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) == 0
                  && 
#line 6406 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 9009; /* *aarch64_cond_abdvnx2df_3_relaxed */
              break;

            default:
              break;
            }
        }
    }
  operands[4] = x4;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern1275 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9010; /* *aarch64_cond_abdvnx8hf_3_strict */

    case E_VNx4SFmode:
      if (pattern1275 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9011; /* *aarch64_cond_abdvnx4sf_3_strict */

    case E_VNx2DFmode:
      if (pattern1275 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9012; /* *aarch64_cond_abdvnx2df_3_strict */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern871 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7247; /* *cond_btruncvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7313; /* *cond_btruncvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7258; /* *cond_btruncvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7324; /* *cond_btruncvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7269; /* *cond_btruncvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7335; /* *cond_btruncvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7280; /* *cond_btruncvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7346; /* *cond_btruncvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7291; /* *cond_btruncvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7357; /* *cond_btruncvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3784 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7302; /* *cond_btruncvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3833 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7368; /* *cond_btruncvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11723; /* *cond_urshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11764; /* *cond_urshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11804; /* *cond_urshlvnx2di_any */
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11698; /* *cond_urhaddvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11743; /* *cond_urhaddvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11783; /* *cond_urhaddvnx8hi_any */
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11684; /* *cond_uhsubvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11731; /* *cond_uhsubvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11771; /* *cond_uhsubvnx16qi_any */
}

 int
recog_240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11704; /* *cond_srhaddvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11748; /* *cond_srhaddvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11788; /* *cond_srhaddvnx4si_any */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11678; /* *cond_shsubvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11726; /* *cond_shsubvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11766; /* *cond_shsubvnx16qi_any */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1062 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8544; /* *cond_fmaxvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8690; /* *cond_fmaxvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8794; /* *cond_fmaxvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8557; /* *cond_fmaxvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8703; /* *cond_fmaxvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8807; /* *cond_fmaxvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8570; /* *cond_fmaxvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8716; /* *cond_fmaxvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8820; /* *cond_fmaxvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8583; /* *cond_fmaxvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8729; /* *cond_fmaxvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8833; /* *cond_fmaxvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8644; /* *cond_fmaxvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8894; /* *cond_fmaxvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8651; /* *cond_fmaxvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8901; /* *cond_fmaxvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8658; /* *cond_fmaxvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8908; /* *cond_fmaxvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8596; /* *cond_fmaxvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8742; /* *cond_fmaxvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8846; /* *cond_fmaxvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8609; /* *cond_fmaxvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8755; /* *cond_fmaxvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8859; /* *cond_fmaxvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8622; /* *cond_fmaxvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8768; /* *cond_fmaxvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8872; /* *cond_fmaxvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5549 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8635; /* *cond_fmaxvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5635 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8781; /* *cond_fmaxvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8885; /* *cond_fmaxvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5592 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8665; /* *cond_fmaxvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8915; /* *cond_fmaxvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5592 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8672; /* *cond_fmaxvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8922; /* *cond_fmaxvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5592 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8679; /* *cond_fmaxvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8929; /* *cond_fmaxvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[4] = x7;
  switch (XINT (x3, 1))
    {
    case 376:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9273; /* *cond_fmavnx8hf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9301; /* *cond_fmavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9333; /* *cond_fmavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9277; /* *cond_fmavnx4sf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9305; /* *cond_fmavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9337; /* *cond_fmavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9281; /* *cond_fmavnx2df_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9309; /* *cond_fmavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9341; /* *cond_fmavnx2df_any_relaxed */

        case 3:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9297; /* *cond_fmavnx8bf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9329; /* *cond_fmavnx8bf_any_relaxed */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9285; /* *cond_fmavnx8hf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9317; /* *cond_fmavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9349; /* *cond_fmavnx8hf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9289; /* *cond_fmavnx4sf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9321; /* *cond_fmavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9353; /* *cond_fmavnx4sf_any_strict */

        case 6:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9293; /* *cond_fmavnx2df_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9325; /* *cond_fmavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9357; /* *cond_fmavnx2df_any_strict */

        case 7:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9313; /* *cond_fmavnx8bf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9345; /* *cond_fmavnx8bf_any_strict */

        default:
          return -1;
        }

    case 377:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9274; /* *cond_fnmavnx8hf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9302; /* *cond_fnmavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9334; /* *cond_fnmavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9278; /* *cond_fnmavnx4sf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9306; /* *cond_fnmavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9338; /* *cond_fnmavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9282; /* *cond_fnmavnx2df_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9310; /* *cond_fnmavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9342; /* *cond_fnmavnx2df_any_relaxed */

        case 3:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7606 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9298; /* *cond_fnmavnx8bf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9330; /* *cond_fnmavnx8bf_any_relaxed */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9286; /* *cond_fnmavnx8hf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9318; /* *cond_fnmavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9350; /* *cond_fnmavnx8hf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9290; /* *cond_fnmavnx4sf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9322; /* *cond_fnmavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9354; /* *cond_fnmavnx4sf_any_strict */

        case 6:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9294; /* *cond_fnmavnx2df_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9326; /* *cond_fnmavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9358; /* *cond_fnmavnx2df_any_strict */

        case 7:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9314; /* *cond_fnmavnx8bf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7698 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9346; /* *cond_fnmavnx8bf_any_strict */

        default:
          return -1;
        }

    case 381:
      return recog_265 (x1, insn, pnum_clobbers);

    case 382:
      return recog_264 (x1, insn, pnum_clobbers);

    case 360:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9381; /* *cond_fcmlavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9405; /* *cond_fcmlavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9385; /* *cond_fcmlavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9409; /* *cond_fcmlavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9389; /* *cond_fcmlavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9413; /* *cond_fcmlavnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9393; /* *cond_fcmlavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9417; /* *cond_fcmlavnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9397; /* *cond_fcmlavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9421; /* *cond_fcmlavnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9401; /* *cond_fcmlavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9425; /* *cond_fcmlavnx2df_any_strict */

        default:
          return -1;
        }

    case 361:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9382; /* *cond_fcmla90vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9406; /* *cond_fcmla90vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9386; /* *cond_fcmla90vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9410; /* *cond_fcmla90vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9390; /* *cond_fcmla90vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9414; /* *cond_fcmla90vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9394; /* *cond_fcmla90vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9418; /* *cond_fcmla90vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9398; /* *cond_fcmla90vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9422; /* *cond_fcmla90vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9402; /* *cond_fcmla90vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9426; /* *cond_fcmla90vnx2df_any_strict */

        default:
          return -1;
        }

    case 362:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9383; /* *cond_fcmla180vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9407; /* *cond_fcmla180vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9387; /* *cond_fcmla180vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9411; /* *cond_fcmla180vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9391; /* *cond_fcmla180vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9415; /* *cond_fcmla180vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9395; /* *cond_fcmla180vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9419; /* *cond_fcmla180vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9399; /* *cond_fcmla180vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9423; /* *cond_fcmla180vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9403; /* *cond_fcmla180vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9427; /* *cond_fcmla180vnx2df_any_strict */

        default:
          return -1;
        }

    case 363:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9384; /* *cond_fcmla270vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9408; /* *cond_fcmla270vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9388; /* *cond_fcmla270vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9412; /* *cond_fcmla270vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9392; /* *cond_fcmla270vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7899 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9416; /* *cond_fcmla270vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9396; /* *cond_fcmla270vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9420; /* *cond_fcmla270vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9400; /* *cond_fcmla270vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9424; /* *cond_fcmla270vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7878 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9404; /* *cond_fcmla270vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9428; /* *cond_fcmla270vnx2df_any_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern735 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7495; /* *cond_iorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7665; /* *cond_iorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7835; /* *cond_iorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7512; /* *cond_iorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7682; /* *cond_iorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7852; /* *cond_iorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7529; /* *cond_iorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7699; /* *cond_iorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7869; /* *cond_iorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7546; /* *cond_iorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7716; /* *cond_iorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7886; /* *cond_iorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7563; /* *cond_iorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7733; /* *cond_iorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7903; /* *cond_iorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7580; /* *cond_iorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7750; /* *cond_iorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7920; /* *cond_iorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7597; /* *cond_iorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7767; /* *cond_iorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7937; /* *cond_iorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7614; /* *cond_iorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7784; /* *cond_iorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7954; /* *cond_iorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7631; /* *cond_iorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7801; /* *cond_iorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7971; /* *cond_iorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4057 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7648; /* *cond_iorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4074 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7818; /* *cond_iorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4091 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7988; /* *cond_iorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern595 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6746; /* *cond_popcountvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6836; /* *cond_popcountvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6755; /* *cond_popcountvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6845; /* *cond_popcountvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6764; /* *cond_popcountvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6854; /* *cond_popcountvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6773; /* *cond_popcountvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6863; /* *cond_popcountvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6782; /* *cond_popcountvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6872; /* *cond_popcountvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6791; /* *cond_popcountvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6881; /* *cond_popcountvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6800; /* *cond_popcountvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6890; /* *cond_popcountvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6809; /* *cond_popcountvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6899; /* *cond_popcountvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6818; /* *cond_popcountvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6908; /* *cond_popcountvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3280 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6827; /* *cond_popcountvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3302 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6917; /* *cond_popcountvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !register_operand (operands[2], E_V2x8QImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4419; /* aarch64_vec_load_lanesv2x8qi_lanev8qi */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !register_operand (operands[2], E_V2x4HImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4420; /* aarch64_vec_load_lanesv2x4hi_lanev4hi */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !register_operand (operands[2], E_V2x2SImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4421; /* aarch64_vec_load_lanesv2x2si_lanev2si */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !register_operand (operands[2], E_V2x1DImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4422; /* aarch64_vec_load_lanesv2x1di_lanedi */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !register_operand (operands[2], E_V2x4HFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4423; /* aarch64_vec_load_lanesv2x4hf_lanev4hf */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !register_operand (operands[2], E_V2x2SFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4424; /* aarch64_vec_load_lanesv2x2sf_lanev2sf */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !register_operand (operands[2], E_V2x1DFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4425; /* aarch64_vec_load_lanesv2x1df_lanedf */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !register_operand (operands[2], E_V2x4BFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4426; /* aarch64_vec_load_lanesv2x4bf_lanev4bf */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !register_operand (operands[2], E_V2x16QImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4427; /* aarch64_vec_load_lanesv2x16qi_lanev16qi */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode)
          || GET_MODE (x3) != E_V2x8HImode
          || !register_operand (operands[2], E_V2x8HImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4428; /* aarch64_vec_load_lanesv2x8hi_lanev8hi */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode)
          || GET_MODE (x3) != E_V2x4SImode
          || !register_operand (operands[2], E_V2x4SImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4429; /* aarch64_vec_load_lanesv2x4si_lanev4si */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode)
          || GET_MODE (x3) != E_V2x2DImode
          || !register_operand (operands[2], E_V2x2DImode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4430; /* aarch64_vec_load_lanesv2x2di_lanev2di */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode)
          || GET_MODE (x3) != E_V2x8HFmode
          || !register_operand (operands[2], E_V2x8HFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4431; /* aarch64_vec_load_lanesv2x8hf_lanev8hf */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode)
          || GET_MODE (x3) != E_V2x4SFmode
          || !register_operand (operands[2], E_V2x4SFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4432; /* aarch64_vec_load_lanesv2x4sf_lanev4sf */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode)
          || GET_MODE (x3) != E_V2x2DFmode
          || !register_operand (operands[2], E_V2x2DFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4433; /* aarch64_vec_load_lanesv2x2df_lanev2df */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode)
          || GET_MODE (x3) != E_V2x8BFmode
          || !register_operand (operands[2], E_V2x8BFmode)
          || !
#line 7586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4434; /* aarch64_vec_load_lanesv2x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern801 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5748; /* *aarch64_maskloadvnx16qivnx16bi */

    case E_VNx8QImode:
      if (pattern801 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5749; /* *aarch64_maskloadvnx8qivnx8bi */

    case E_VNx4QImode:
      if (pattern801 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5750; /* *aarch64_maskloadvnx4qivnx4bi */

    case E_VNx2QImode:
      if (pattern801 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5751; /* *aarch64_maskloadvnx2qivnx2bi */

    case E_VNx8HImode:
      if (pattern801 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5752; /* *aarch64_maskloadvnx8hivnx8bi */

    case E_VNx4HImode:
      if (pattern801 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5753; /* *aarch64_maskloadvnx4hivnx4bi */

    case E_VNx2HImode:
      if (pattern801 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5754; /* *aarch64_maskloadvnx2hivnx2bi */

    case E_VNx4SImode:
      if (pattern801 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5755; /* *aarch64_maskloadvnx4sivnx4bi */

    case E_VNx2SImode:
      if (pattern801 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5756; /* *aarch64_maskloadvnx2sivnx2bi */

    case E_VNx2DImode:
      if (pattern801 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5757; /* *aarch64_maskloadvnx2divnx2bi */

    case E_VNx8HFmode:
      if (pattern801 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5758; /* *aarch64_maskloadvnx8hfvnx8bi */

    case E_VNx4HFmode:
      if (pattern801 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5759; /* *aarch64_maskloadvnx4hfvnx4bi */

    case E_VNx2HFmode:
      if (pattern801 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5760; /* *aarch64_maskloadvnx2hfvnx2bi */

    case E_VNx8BFmode:
      if (pattern801 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5761; /* *aarch64_maskloadvnx8bfvnx8bi */

    case E_VNx4BFmode:
      if (pattern801 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5762; /* *aarch64_maskloadvnx4bfvnx4bi */

    case E_VNx2BFmode:
      if (pattern801 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5763; /* *aarch64_maskloadvnx2bfvnx2bi */

    case E_VNx4SFmode:
      if (pattern801 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5764; /* *aarch64_maskloadvnx4sfvnx4bi */

    case E_VNx2SFmode:
      if (pattern801 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5765; /* *aarch64_maskloadvnx2sfvnx2bi */

    case E_VNx2DFmode:
      if (pattern801 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1330 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5766; /* *aarch64_maskloadvnx2dfvnx2bi */

    default:
      return -1;
    }
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9989; /* while_rwsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9999; /* while_rwdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10009; /* while_rwsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10019; /* while_rwdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10029; /* while_rwsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10039; /* while_rwdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10049; /* while_rwsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10059; /* while_rwdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9981; /* while_lesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9991; /* while_ledivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10001; /* while_lesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10011; /* while_ledivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10021; /* while_lesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10031; /* while_ledivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10041; /* while_lesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8466 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10051; /* while_ledivnx2bi */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern187 (x1))
    {
    case 0:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11201; /* aarch64_ldnt1vnx32qi */

    case 1:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11203; /* aarch64_ldnt1vnx16hi */

    case 2:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11205; /* aarch64_ldnt1vnx8si */

    case 3:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11207; /* aarch64_ldnt1vnx4di */

    case 4:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11209; /* aarch64_ldnt1vnx16bf */

    case 5:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11211; /* aarch64_ldnt1vnx16hf */

    case 6:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11213; /* aarch64_ldnt1vnx8sf */

    case 7:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11215; /* aarch64_ldnt1vnx4df */

    case 8:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11217; /* aarch64_ldnt1vnx64qi */

    case 9:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11219; /* aarch64_ldnt1vnx32hi */

    case 10:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11221; /* aarch64_ldnt1vnx16si */

    case 11:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11223; /* aarch64_ldnt1vnx8di */

    case 12:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11225; /* aarch64_ldnt1vnx32bf */

    case 13:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11227; /* aarch64_ldnt1vnx32hf */

    case 14:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11229; /* aarch64_ldnt1vnx16sf */

    case 15:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11231; /* aarch64_ldnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !register_operand (operands[2], E_V4HFmode)
              || !
#line 10106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
            return -1;
          return 5327; /* aarch64_fcvtnv4hf */

        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !
#line 10106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
            return -1;
          return 5329; /* aarch64_fcvtnv4sf */

        default:
          return -1;
        }

    case E_V16QImode:
      if (pattern124 (x2, 
E_V16QImode, 
E_V8HFmode) != 0
          || !
#line 10106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5328; /* aarch64_fcvtnv8hf */

    default:
      return -1;
    }
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern180 (x1))
    {
    case 0:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
        return -1;
      return 10856; /* aarch64_sve_fix_trunc_nontruncvnx8hfvnx8hi */

    case 1:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
        return -1;
      return 10858; /* aarch64_sve_fix_trunc_nontruncvnx4sfvnx8hi */

    case 2:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
        return -1;
      return 10860; /* aarch64_sve_fix_trunc_nontruncvnx2dfvnx8hi */

    case 3:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10862; /* aarch64_sve_fix_trunc_nontruncvnx8hfvnx4si */

    case 4:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10864; /* aarch64_sve_fix_trunc_nontruncvnx4sfvnx4si */

    case 5:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10866; /* aarch64_sve_fix_trunc_nontruncvnx2dfvnx4si */

    case 6:
      if (!
#line 9472 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10874; /* aarch64_sve_fix_trunc_truncvnx2dfvnx4si */

    case 7:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 10868; /* aarch64_sve_fix_trunc_nontruncvnx8hfvnx2di */

    case 8:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 10870; /* aarch64_sve_fix_trunc_nontruncvnx4sfvnx2di */

    case 9:
      if (!
#line 9457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 10872; /* aarch64_sve_fix_trunc_nontruncvnx2dfvnx2di */

    default:
      return -1;
    }
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12581; /* aarch64_sve_sqrdcmlah180vnx16qi */

    case 1:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12589; /* aarch64_sve_sqrdcmlah180vnx8hi */

    case 2:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12597; /* aarch64_sve_sqrdcmlah180vnx4si */

    case 3:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12605; /* aarch64_sve_sqrdcmlah180vnx2di */

    case 4:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12613; /* aarch64_sqrdcmlah180_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12621; /* aarch64_sqrdcmlah180_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern58 (x2, 
E_DImode, 
31, 
E_BLKmode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode)
      || !
#line 7893 "../../gcc/config/aarch64/aarch64.md"
(REGNO (operands[0]) == INTVAL (operands[1])))
    return -1;
  return 1156; /* stack_tie */
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12624; /* aarch64_sve_cdot90vnx4si */

    case 1:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12628; /* aarch64_sve_cdot90vnx2di */

    case 2:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12632; /* aarch64_cdot90_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12636; /* aarch64_cdot90_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11888; /* aarch64_sve_eortbvnx16qi */

    case 1:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11896; /* aarch64_sve_eortbvnx8hi */

    case 2:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11904; /* aarch64_sve_eortbvnx4si */

    case 3:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11912; /* aarch64_sve_eortbvnx2di */

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern185 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 10323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 8))
        return -1;
      *pnum_clobbers = 1;
      return 11015; /* aarch64_sve_pfirstvnx16bi */

    case 1:
      if (!
#line 10323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
        return -1;
      *pnum_clobbers = 1;
      return 11017; /* aarch64_sve_pfirstvnx8bi */

    case 2:
      if (!
#line 10323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
        return -1;
      *pnum_clobbers = 1;
      return 11019; /* aarch64_sve_pfirstvnx4bi */

    case 3:
      if (!
#line 10323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
        return -1;
      *pnum_clobbers = 1;
      return 11021; /* aarch64_sve_pfirstvnx2bi */

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (XVECLEN (x3, 0) != 3)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 126:
      x5 = XVECEXP (x2, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[6] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[7] = x8;
      if (!aarch64_sve_ptrue_flag (operands[7], E_SImode))
        return -1;
      x9 = XVECEXP (x3, 0, 2);
      switch (GET_CODE (x9))
        {
        case LT:
          switch (pattern1319 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9691; /* *cmpltvnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9701; /* *cmpltvnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9731; /* *cmpltvnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9711; /* *cmpltvnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9741; /* *cmpltvnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9761; /* *cmpltvnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9721; /* *cmpltvnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9751; /* *cmpltvnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9771; /* *cmpltvnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9781; /* *cmpltvnx2di_ptest */

            default:
              return -1;
            }

        case LE:
          switch (pattern1319 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9692; /* *cmplevnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9702; /* *cmplevnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9732; /* *cmplevnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9712; /* *cmplevnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9742; /* *cmplevnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9762; /* *cmplevnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9722; /* *cmplevnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9752; /* *cmplevnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9772; /* *cmplevnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9782; /* *cmplevnx2di_ptest */

            default:
              return -1;
            }

        case EQ:
          switch (pattern1319 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9693; /* *cmpeqvnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9703; /* *cmpeqvnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9733; /* *cmpeqvnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9713; /* *cmpeqvnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9743; /* *cmpeqvnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9763; /* *cmpeqvnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9723; /* *cmpeqvnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9753; /* *cmpeqvnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9773; /* *cmpeqvnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9783; /* *cmpeqvnx2di_ptest */

            default:
              return -1;
            }

        case NE:
          switch (pattern1319 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9694; /* *cmpnevnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9704; /* *cmpnevnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9734; /* *cmpnevnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9714; /* *cmpnevnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9744; /* *cmpnevnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9764; /* *cmpnevnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9724; /* *cmpnevnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9754; /* *cmpnevnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9774; /* *cmpnevnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9784; /* *cmpnevnx2di_ptest */

            default:
              return -1;
            }

        case GE:
          switch (pattern1319 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9695; /* *cmpgevnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9705; /* *cmpgevnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9735; /* *cmpgevnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9715; /* *cmpgevnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9745; /* *cmpgevnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9765; /* *cmpgevnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9725; /* *cmpgevnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9755; /* *cmpgevnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9775; /* *cmpgevnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9785; /* *cmpgevnx2di_ptest */

            default:
              return -1;
            }

        case GT:
          switch (pattern1319 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9696; /* *cmpgtvnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9706; /* *cmpgtvnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9736; /* *cmpgtvnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9716; /* *cmpgtvnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9746; /* *cmpgtvnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9766; /* *cmpgtvnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9726; /* *cmpgtvnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9756; /* *cmpgtvnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9776; /* *cmpgtvnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9786; /* *cmpgtvnx2di_ptest */

            default:
              return -1;
            }

        case LTU:
          switch (pattern1320 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9697; /* *cmplovnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9707; /* *cmplovnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9737; /* *cmplovnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9717; /* *cmplovnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9747; /* *cmplovnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9767; /* *cmplovnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9727; /* *cmplovnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9757; /* *cmplovnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9777; /* *cmplovnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9787; /* *cmplovnx2di_ptest */

            default:
              return -1;
            }

        case LEU:
          switch (pattern1320 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9698; /* *cmplsvnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9708; /* *cmplsvnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9738; /* *cmplsvnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9718; /* *cmplsvnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9748; /* *cmplsvnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9768; /* *cmplsvnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9728; /* *cmplsvnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9758; /* *cmplsvnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9778; /* *cmplsvnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9788; /* *cmplsvnx2di_ptest */

            default:
              return -1;
            }

        case GEU:
          switch (pattern1320 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9699; /* *cmphsvnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9709; /* *cmphsvnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9739; /* *cmphsvnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9719; /* *cmphsvnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9749; /* *cmphsvnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9769; /* *cmphsvnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9729; /* *cmphsvnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9759; /* *cmphsvnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9779; /* *cmphsvnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9789; /* *cmphsvnx2di_ptest */

            default:
              return -1;
            }

        case GTU:
          switch (pattern1320 (x3))
            {
            case 0:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9700; /* *cmphivnx16qi_ptest */

            case 1:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9710; /* *cmphivnx8qi_ptest */

            case 2:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9740; /* *cmphivnx8hi_ptest */

            case 3:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9720; /* *cmphivnx4qi_ptest */

            case 4:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9750; /* *cmphivnx4hi_ptest */

            case 5:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9770; /* *cmphivnx4si_ptest */

            case 6:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9730; /* *cmphivnx2qi_ptest */

            case 7:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9760; /* *cmphivnx2hi_ptest */

            case 8:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9780; /* *cmphivnx2si_ptest */

            case 9:
              if (!
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9790; /* *cmphivnx2di_ptest */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x9, 0) != 2)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x9, 0, 1);
          operands[3] = x11;
          switch (XINT (x9, 1))
            {
            case 341:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9951; /* *aarch64_pred_cmpeqvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9961; /* *aarch64_pred_cmpeqvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9971; /* *aarch64_pred_cmpeqvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 342:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9952; /* *aarch64_pred_cmpgevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9962; /* *aarch64_pred_cmpgevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9972; /* *aarch64_pred_cmpgevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 343:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9953; /* *aarch64_pred_cmpgtvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9963; /* *aarch64_pred_cmpgtvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9973; /* *aarch64_pred_cmpgtvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 344:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9954; /* *aarch64_pred_cmphivnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9964; /* *aarch64_pred_cmphivnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9974; /* *aarch64_pred_cmphivnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 345:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9955; /* *aarch64_pred_cmphsvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9965; /* *aarch64_pred_cmphsvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9975; /* *aarch64_pred_cmphsvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 346:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9956; /* *aarch64_pred_cmplevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9966; /* *aarch64_pred_cmplevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9976; /* *aarch64_pred_cmplevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 347:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9957; /* *aarch64_pred_cmplovnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9967; /* *aarch64_pred_cmplovnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9977; /* *aarch64_pred_cmplovnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 348:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9958; /* *aarch64_pred_cmplsvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9968; /* *aarch64_pred_cmplsvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9978; /* *aarch64_pred_cmplsvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 349:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9959; /* *aarch64_pred_cmpltvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9969; /* *aarch64_pred_cmpltvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9979; /* *aarch64_pred_cmpltvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 350:
              switch (pattern1351 (x3))
                {
                case 0:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9960; /* *aarch64_pred_cmpnevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9970; /* *aarch64_pred_cmpnevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9980; /* *aarch64_pred_cmpnevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 473:
              switch (pattern1352 (x3))
                {
                case 0:
                  if (!
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12971; /* *aarch64_pred_matchvnx16qi_ptest */

                case 1:
                  if (!
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12973; /* *aarch64_pred_matchvnx8hi_ptest */

                default:
                  return -1;
                }

            case 474:
              switch (pattern1352 (x3))
                {
                case 0:
                  if (!
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12972; /* *aarch64_pred_nmatchvnx16qi_ptest */

                case 1:
                  if (!
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12974; /* *aarch64_pred_nmatchvnx8hi_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 300:
      if (pattern1205 (x2) != 0
          || !
#line 10168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 11004; /* *aarch64_brka_ptest */

    case 301:
      if (pattern1205 (x2) != 0
          || !
#line 10168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 11005; /* *aarch64_brkb_ptest */

    case 303:
      if (pattern1206 (x2) != 0
          || !
#line 10299 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 11013; /* *aarch64_brkpa_ptest */

    case 304:
      if (pattern1206 (x2) != 0
          || !
#line 10299 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 11014; /* *aarch64_brkpb_ptest */

    case 305:
      switch (pattern1207 (x2))
        {
        case 0:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11031; /* *aarch64_sve_pfirstvnx16bi_ptest */

        case 1:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11033; /* *aarch64_sve_pfirstvnx8bi_ptest */

        case 2:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11035; /* *aarch64_sve_pfirstvnx4bi_ptest */

        case 3:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11037; /* *aarch64_sve_pfirstvnx2bi_ptest */

        default:
          return -1;
        }

    case 306:
      switch (pattern1207 (x2))
        {
        case 0:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11032; /* *aarch64_sve_pnextvnx16bi_ptest */

        case 1:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11034; /* *aarch64_sve_pnextvnx8bi_ptest */

        case 2:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11036; /* *aarch64_sve_pnextvnx4bi_ptest */

        case 3:
          if (!
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 11038; /* *aarch64_sve_pnextvnx2bi_ptest */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 266; /* *subsi3_uxtw */

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode
              || !register_operand (x5, E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              return 293; /* *sub_lsl_si_uxtw */

            case SIGN_EXTEND:
              switch (pattern1002 (x4))
                {
                case 0:
                  return 324; /* *sub_extendqi_shft_si_uxtw */

                case 1:
                  return 326; /* *sub_extendhi_shft_si_uxtw */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern1002 (x4))
                {
                case 0:
                  return 325; /* *sub_zero_extendqi_shft_si_uxtw */

                case 1:
                  return 327; /* *sub_zero_extendhi_shft_si_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern807 (x4) != 0)
            return -1;
          return 294; /* *sub_asr_si_uxtw */

        case LSHIFTRT:
          if (pattern807 (x4) != 0)
            return -1;
          return 295; /* *sub_lsr_si_uxtw */

        case SIGN_EXTEND:
          switch (pattern808 (x4))
            {
            case 0:
              return 308; /* *sub_extendqi_si_uxtw */

            case 1:
              return 310; /* *sub_extendhi_si_uxtw */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern808 (x4))
            {
            case 0:
              return 309; /* *sub_zero_extendqi_si_uxtw */

            case 1:
              return 311; /* *sub_zero_extendhi_si_uxtw */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!aarch64_borrow_operation (operands[2], E_SImode))
            return -1;
          operands[1] = x5;
          if (!aarch64_reg_or_zero (operands[1], E_SImode))
            return -1;
          return 330; /* *subsi3_carryin_uxtw */

        case AND:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_SImode)
            return -1;
          operands[4] = x5;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!aarch64_imm3 (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 3976 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]),INTVAL (operands[3])) != 0))
            return -1;
          return 349; /* *sub_uxtsi_shift2_uxtw */

        case MULT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 385; /* *msubsi_uxtw */

        default:
          return -1;
        }

    case MINUS:
      if (pattern380 (x3) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!aarch64_reg_or_zero (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!aarch64_borrow_operation (operands[3], E_SImode))
            return -1;
          return 333; /* *subsi3_carryin_uxtw */

        case GEU:
        case LTU:
          operands[3] = x12;
          if (!aarch64_borrow_operation (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 336; /* *subsi3_carryin_alt_uxtw */

        default:
          return -1;
        }

    case NEG:
      if (pattern380 (x3) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      if (!aarch64_borrow_operation (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 357; /* *ngcsi_uxtw */

    case SMAX:
      switch (pattern383 (x3, 
SMIN))
        {
        case 0:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1667; /* aarch64_sabdlv8qi */

        case 1:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1669; /* aarch64_sabdlv4hi */

        case 2:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1671; /* aarch64_sabdlv2si */

        case 3:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1673; /* aarch64_sabdl2v16qi_insn */

        case 4:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1675; /* aarch64_sabdl2v8hi_insn */

        case 5:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1677; /* aarch64_sabdl2v4si_insn */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern383 (x3, 
UMIN))
        {
        case 0:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1668; /* aarch64_uabdlv8qi */

        case 1:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1670; /* aarch64_uabdlv4hi */

        case 2:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1672; /* aarch64_uabdlv2si */

        case 3:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1674; /* aarch64_uabdl2v16qi_insn */

        case 4:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1676; /* aarch64_uabdl2v8hi_insn */

        case 5:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1678; /* aarch64_uabdl2v4si_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!aarch64_pluslong_operand (operands[2], E_SImode))
        return -1;
      return 122; /* *addsi3_aarch64_uxtw */

    case ASHIFT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern809 (x3))
            {
            case 0:
              return 212; /* *add_lsl_si_uxtw */

            case 1:
              if (!
#line 6246 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
                return -1;
              return 791; /* *extrsi5_insn_uxtw */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern884 (x3))
            {
            case 0:
              return 247; /* *add_extendqi_shft_si_uxtw */

            case 1:
              return 249; /* *add_extendhi_shft_si_uxtw */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern884 (x3))
            {
            case 0:
              return 248; /* *add_zero_extendqi_shft_si_uxtw */

            case 1:
              return 250; /* *add_zero_extendhi_shft_si_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern736 (x3) != 0)
        return -1;
      return 213; /* *add_asr_si_uxtw */

    case LSHIFTRT:
      switch (pattern737 (x3))
        {
        case 0:
          return 214; /* *add_lsr_si_uxtw */

        case 1:
          if (!
#line 6260 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
            return -1;
          return 794; /* *extrsi5_insn_uxtw_alt */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern739 (x3))
        {
        case 0:
          return 227; /* *add_extendqi_si_uxtw */

        case 1:
          return 229; /* *add_extendqi_si_uxtw */

        case 2:
          return 231; /* *add_extendhi_si_uxtw */

        case 3:
          return 233; /* *add_extendhi_si_uxtw */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern739 (x3))
        {
        case 0:
          return 228; /* *add_zero_extendqi_si_uxtw */

        case 1:
          return 230; /* *add_zero_extendqi_si_uxtw */

        case 2:
          return 232; /* *add_zero_extendhi_si_uxtw */

        case 3:
          return 234; /* *add_zero_extendhi_si_uxtw */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!aarch64_carry_operation (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 253; /* *addsi3_carryin_uxtw */

    case AND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != ASHIFT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!aarch64_imm3 (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      if (!register_operand (operands[4], E_SImode)
          || !
#line 3270 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
        return -1;
      return 264; /* *add_uxtsi_shift2_uxtw */

    case MULT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 382; /* *maddsi_uxtw */

    default:
      return -1;
    }
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_458 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 407:
          switch (pattern619 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1456; /* aarch64_fcmla_lane0v4hf */

            case 1:
              if (!
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1492; /* aarch64_fcmla_laneq0v4hf */

            case 2:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1468; /* aarch64_fcmla_lane0v8hf */

            case 3:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1504; /* aarch64_fcmlaq_lane0v8hf */

            case 4:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1472; /* aarch64_fcmla_lane0v2sf */

            case 5:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1484; /* aarch64_fcmla_lane0v4sf */

            case 6:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1508; /* aarch64_fcmlaq_lane0v4sf */

            case 7:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1488; /* aarch64_fcmla_lane0v2df */

            default:
              return -1;
            }

        case 408:
          switch (pattern619 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1459; /* aarch64_fcmla_lane90v4hf */

            case 1:
              if (!
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1495; /* aarch64_fcmla_laneq90v4hf */

            case 2:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1469; /* aarch64_fcmla_lane90v8hf */

            case 3:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1505; /* aarch64_fcmlaq_lane90v8hf */

            case 4:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1475; /* aarch64_fcmla_lane90v2sf */

            case 5:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1485; /* aarch64_fcmla_lane90v4sf */

            case 6:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1509; /* aarch64_fcmlaq_lane90v4sf */

            case 7:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1489; /* aarch64_fcmla_lane90v2df */

            default:
              return -1;
            }

        case 409:
          switch (pattern619 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1462; /* aarch64_fcmla_lane180v4hf */

            case 1:
              if (!
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1498; /* aarch64_fcmla_laneq180v4hf */

            case 2:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1470; /* aarch64_fcmla_lane180v8hf */

            case 3:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1506; /* aarch64_fcmlaq_lane180v8hf */

            case 4:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1478; /* aarch64_fcmla_lane180v2sf */

            case 5:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1486; /* aarch64_fcmla_lane180v4sf */

            case 6:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1510; /* aarch64_fcmlaq_lane180v4sf */

            case 7:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1490; /* aarch64_fcmla_lane180v2df */

            default:
              return -1;
            }

        case 410:
          switch (pattern619 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1465; /* aarch64_fcmla_lane270v4hf */

            case 1:
              if (!
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1501; /* aarch64_fcmla_laneq270v4hf */

            case 2:
              if (!(
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1471; /* aarch64_fcmla_lane270v8hf */

            case 3:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1507; /* aarch64_fcmlaq_lane270v8hf */

            case 4:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1481; /* aarch64_fcmla_lane270v2sf */

            case 5:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1487; /* aarch64_fcmla_lane270v4sf */

            case 6:
              if (!
#line 501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1511; /* aarch64_fcmlaq_lane270v4sf */

            case 7:
              if (!
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1491; /* aarch64_fcmla_lane270v2df */

            default:
              return -1;
            }

        case 279:
          switch (pattern621 (x2))
            {
            case 0:
              if (!
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1524; /* aarch64_sdot_lanev8qi */

            case 1:
              if (!
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1532; /* aarch64_sdot_laneqv8qi */

            case 2:
              if (!
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1530; /* aarch64_sdot_lanev16qi */

            case 3:
              if (!
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1538; /* aarch64_sdot_laneqv16qi */

            default:
              return -1;
            }

        case 280:
          switch (pattern621 (x2))
            {
            case 0:
              if (!
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1527; /* aarch64_udot_lanev8qi */

            case 1:
              if (!
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1535; /* aarch64_udot_laneqv8qi */

            case 2:
              if (!
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1531; /* aarch64_udot_lanev16qi */

            case 3:
              if (!
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1539; /* aarch64_udot_laneqv16qi */

            default:
              return -1;
            }

        case 573:
          switch (pattern621 (x2))
            {
            case 0:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1540; /* aarch64_usdot_lanev8qi */

            case 1:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1548; /* aarch64_usdot_laneqv8qi */

            case 2:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1546; /* aarch64_usdot_lanev16qi */

            case 3:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1554; /* aarch64_usdot_laneqv16qi */

            default:
              return -1;
            }

        case 578:
          switch (pattern621 (x2))
            {
            case 0:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1543; /* aarch64_sudot_lanev8qi */

            case 1:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1551; /* aarch64_sudot_laneqv8qi */

            case 2:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1547; /* aarch64_sudot_lanev16qi */

            case 3:
              if (!
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1555; /* aarch64_sudot_laneqv16qi */

            default:
              return -1;
            }

        case 579:
          x5 = XVECEXP (x3, 0, 0);
          operands[2] = x5;
          x6 = XVECEXP (x3, 0, 1);
          operands[3] = x6;
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              switch (pattern1005 (x2, 
E_V2SFmode, 
E_V4BFmode))
                {
                case 0:
                  if (!
#line 9912 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5261; /* aarch64_bfdot_lanev2sf */

                case 1:
                  if (!
#line 9912 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5263; /* aarch64_bfdot_laneqv2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1005 (x2, 
E_V4SFmode, 
E_V8BFmode))
                {
                case 0:
                  if (!
#line 9912 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5262; /* aarch64_bfdot_lanev4sf */

                case 1:
                  if (!
#line 9912 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5264; /* aarch64_bfdot_laneqv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 169:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x5 = XVECEXP (x3, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 10450 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11043; /* *aarch64_sve_incsi_pat */

        case 307:
          switch (pattern622 (x2))
            {
            case 0:
              if (!
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11086; /* *aarch64_incsivnx16bi_cntp */

            case 1:
              if (!
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11087; /* *aarch64_incsivnx8bi_cntp */

            case 2:
              if (!
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11088; /* *aarch64_incsivnx4bi_cntp */

            case 3:
              if (!
#line 10787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11089; /* *aarch64_incsivnx2bi_cntp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) != 0)
            return -1;
          return 265; /* subsi3 */

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) != 0)
            return -1;
          return 267; /* subdi3 */

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) != 0
              || !(
#line 7284 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1062; /* subhf3 */

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) != 0
              || !
#line 7284 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1063; /* subsf3 */

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) != 0
              || !
#line 7284 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1064; /* subdf3 */

        case E_V8QImode:
          if (pattern31 (x2, 
E_V8QImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1368; /* subv8qi3 */

        case E_V16QImode:
          if (pattern31 (x2, 
E_V16QImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1371; /* subv16qi3 */

        case E_V4HImode:
          if (pattern31 (x2, 
E_V4HImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1372; /* subv4hi3 */

        case E_V8HImode:
          if (pattern31 (x2, 
E_V8HImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1375; /* subv8hi3 */

        case E_V2SImode:
          if (pattern31 (x2, 
E_V2SImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1376; /* subv2si3 */

        case E_V4SImode:
          if (pattern31 (x2, 
E_V4SImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1379; /* subv4si3 */

        case E_V2DImode:
          if (pattern31 (x2, 
E_V2DImode) != 0
              || !
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1380; /* subv2di3 */

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) != 0
              || !(
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2371; /* subv4hf3 */

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) != 0
              || !(
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2374; /* subv8hf3 */

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) != 0
              || !
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2375; /* subv2sf3 */

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) != 0
              || !
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2378; /* subv4sf3 */

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) != 0
              || !
#line 2646 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2379; /* subv2df3 */

        case E_VNx16QImode:
          if (pattern746 (x2, 
E_VNx16QImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8004; /* subvnx16qi3 */

        case E_VNx8QImode:
          if (pattern746 (x2, 
E_VNx8QImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8005; /* subvnx8qi3 */

        case E_VNx4QImode:
          if (pattern746 (x2, 
E_VNx4QImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8006; /* subvnx4qi3 */

        case E_VNx2QImode:
          if (pattern746 (x2, 
E_VNx2QImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8007; /* subvnx2qi3 */

        case E_VNx8HImode:
          if (pattern746 (x2, 
E_VNx8HImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8008; /* subvnx8hi3 */

        case E_VNx4HImode:
          if (pattern746 (x2, 
E_VNx4HImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8009; /* subvnx4hi3 */

        case E_VNx2HImode:
          if (pattern746 (x2, 
E_VNx2HImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8010; /* subvnx2hi3 */

        case E_VNx4SImode:
          if (pattern746 (x2, 
E_VNx4SImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8011; /* subvnx4si3 */

        case E_VNx2SImode:
          if (pattern746 (x2, 
E_VNx2SImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8012; /* subvnx2si3 */

        case E_VNx2DImode:
          if (pattern746 (x2, 
E_VNx2DImode) != 0
              || !
#line 4159 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8013; /* subvnx2di3 */

        case E_VNx8BFmode:
          if (pattern31 (x2, 
E_VNx8BFmode) != 0
              || !(
#line 5424 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8510; /* *post_ra_fsubvnx8bf3 */

        case E_VNx8HFmode:
          if (pattern31 (x2, 
E_VNx8HFmode) != 0
              || !
#line 5424 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8513; /* *post_ra_fsubvnx8hf3 */

        case E_VNx4SFmode:
          if (pattern31 (x2, 
E_VNx4SFmode) != 0
              || !
#line 5424 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8516; /* *post_ra_fsubvnx4sf3 */

        case E_VNx2DFmode:
          if (pattern31 (x2, 
E_VNx2DFmode) != 0
              || !
#line 5424 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8519; /* *post_ra_fsubvnx2df3 */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 0);
          operands[3] = x4;
          switch (pattern393 (x2))
            {
            case 0:
              return 287; /* *sub_lsl_si */

            case 1:
              return 290; /* *sub_lsl_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern520 (x2))
            {
            case 0:
              return 312; /* *sub_extendqi_shft_si */

            case 1:
              return 316; /* *sub_extendhi_shft_si */

            case 2:
              return 320; /* *sub_extendsi_shft_si */

            case 3:
              return 314; /* *sub_extendqi_shft_di */

            case 4:
              return 318; /* *sub_extendhi_shft_di */

            case 5:
              return 322; /* *sub_extendsi_shft_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern520 (x2))
            {
            case 0:
              return 313; /* *sub_zero_extendqi_shft_si */

            case 1:
              return 317; /* *sub_zero_extendhi_shft_si */

            case 2:
              return 321; /* *sub_zero_extendsi_shft_si */

            case 3:
              return 315; /* *sub_zero_extendqi_shft_di */

            case 4:
              return 319; /* *sub_zero_extendhi_shft_di */

            case 5:
              return 323; /* *sub_zero_extendsi_shft_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern394 (x2))
        {
        case 0:
          return 288; /* *sub_asr_si */

        case 1:
          return 291; /* *sub_asr_di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern394 (x2))
        {
        case 0:
          return 289; /* *sub_lsr_si */

        case 1:
          return 292; /* *sub_lsr_di */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern625 (x2))
            {
            case 0:
              return 296; /* *sub_extendqi_si */

            case 1:
              return 300; /* *sub_extendhi_si */

            case 2:
              return 304; /* *sub_extendsi_si */

            case 3:
              return 298; /* *sub_extendqi_di */

            case 4:
              return 302; /* *sub_extendhi_di */

            case 5:
              return 306; /* *sub_extendsi_di */

            case 6:
              if (!
#line 4671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3048; /* aarch64_ssubwv8qi */

            case 7:
              if (!
#line 4671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3050; /* aarch64_ssubwv4hi */

            case 8:
              if (!
#line 4671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3052; /* aarch64_ssubwv2si */

            default:
              return -1;
            }

        case VEC_SELECT:
          switch (pattern627 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4683 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3054; /* aarch64_ssubwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3060; /* aarch64_ssubw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4683 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3056; /* aarch64_ssubwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3062; /* aarch64_ssubw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4683 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3058; /* aarch64_ssubwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3064; /* aarch64_ssubw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern625 (x2))
            {
            case 0:
              return 297; /* *sub_zero_extendqi_si */

            case 1:
              return 301; /* *sub_zero_extendhi_si */

            case 2:
              return 305; /* *sub_zero_extendsi_si */

            case 3:
              return 299; /* *sub_zero_extendqi_di */

            case 4:
              return 303; /* *sub_zero_extendhi_di */

            case 5:
              return 307; /* *sub_zero_extendsi_di */

            case 6:
              if (!
#line 4671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3049; /* aarch64_usubwv8qi */

            case 7:
              if (!
#line 4671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3051; /* aarch64_usubwv4hi */

            case 8:
              if (!
#line 4671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3053; /* aarch64_usubwv2si */

            default:
              return -1;
            }

        case VEC_SELECT:
          switch (pattern627 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4683 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3055; /* aarch64_usubwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3061; /* aarch64_usubw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4683 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3057; /* aarch64_usubwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3063; /* aarch64_usubw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4683 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3059; /* aarch64_usubwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3065; /* aarch64_usubw2v4si_internal */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 3
              || pattern497 (x2, 
E_DImode) != 0)
            return -1;
          switch (pattern450 (x5))
            {
            case 0:
              if (!
#line 10583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11055; /* aarch64_sve_decdi_pat */

            case 1:
              if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11107; /* *aarch64_sve_decdivnx16bi_cntp */

            case 2:
              if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11110; /* *aarch64_sve_decdivnx8bi_cntp */

            case 3:
              if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11113; /* *aarch64_sve_decdivnx4bi_cntp */

            case 4:
              if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11116; /* *aarch64_sve_decdivnx2bi_cntp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern747 (x2, 
E_SImode) != 0)
            return -1;
          return 328; /* *subsi3_carryin0 */

        case E_DImode:
          if (pattern747 (x2, 
E_DImode) != 0)
            return -1;
          return 329; /* *subdi3_carryin0 */

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x4 = XEXP (x2, 0);
      operands[4] = x4;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!aarch64_imm3 (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1072 (x2, 
E_SImode) != 0
              || !
#line 3959 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]),INTVAL (operands[3])) != 0))
            return -1;
          return 347; /* *sub_uxtsi_shift2 */

        case E_DImode:
          if (pattern1072 (x2, 
E_DImode) != 0
              || !
#line 3959 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]),INTVAL (operands[3])) != 0))
            return -1;
          return 348; /* *sub_uxtdi_shift2 */

        default:
          return -1;
        }

    case MULT:
      return recog_466 (x1, insn, pnum_clobbers);

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          switch (XINT (x3, 1))
            {
            case 125:
              x9 = XVECEXP (x3, 0, 1);
              if (GET_CODE (x9) != MULT)
                return -1;
              x4 = XEXP (x2, 0);
              operands[4] = x4;
              x10 = XVECEXP (x3, 0, 0);
              operands[1] = x10;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              x12 = XEXP (x9, 1);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx16QImode:
                  if (pattern1073 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9199; /* aarch64_pred_fnmavnx16qi */

                case E_VNx8QImode:
                  if (pattern1073 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9200; /* aarch64_pred_fnmavnx8qi */

                case E_VNx4QImode:
                  if (pattern1073 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9201; /* aarch64_pred_fnmavnx4qi */

                case E_VNx2QImode:
                  if (pattern1073 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9202; /* aarch64_pred_fnmavnx2qi */

                case E_VNx8HImode:
                  if (pattern1073 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9203; /* aarch64_pred_fnmavnx8hi */

                case E_VNx4HImode:
                  if (pattern1073 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9204; /* aarch64_pred_fnmavnx4hi */

                case E_VNx2HImode:
                  if (pattern1073 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9205; /* aarch64_pred_fnmavnx2hi */

                case E_VNx4SImode:
                  if (pattern1073 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9206; /* aarch64_pred_fnmavnx4si */

                case E_VNx2SImode:
                  if (pattern1073 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9207; /* aarch64_pred_fnmavnx2si */

                case E_VNx2DImode:
                  if (pattern1073 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 7231 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9208; /* aarch64_pred_fnmavnx2di */

                default:
                  return -1;
                }

            case 505:
              switch (pattern634 (x2))
                {
                case 0:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12268; /* aarch64_sve_sub_smullbvnx8hi */

                case 1:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12272; /* aarch64_sve_sub_smullbvnx4si */

                case 2:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12276; /* aarch64_sve_sub_smullbvnx2di */

                case 3:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12280; /* aarch64_sve_sub_smullb_lane_vnx4si */

                case 4:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12284; /* aarch64_sve_sub_smullb_lane_vnx2di */

                default:
                  return -1;
                }

            case 506:
              switch (pattern634 (x2))
                {
                case 0:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12269; /* aarch64_sve_sub_smulltvnx8hi */

                case 1:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12273; /* aarch64_sve_sub_smulltvnx4si */

                case 2:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12277; /* aarch64_sve_sub_smulltvnx2di */

                case 3:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12281; /* aarch64_sve_sub_smullt_lane_vnx4si */

                case 4:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12285; /* aarch64_sve_sub_smullt_lane_vnx2di */

                default:
                  return -1;
                }

            case 557:
              switch (pattern634 (x2))
                {
                case 0:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12270; /* aarch64_sve_sub_umullbvnx8hi */

                case 1:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12274; /* aarch64_sve_sub_umullbvnx4si */

                case 2:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12278; /* aarch64_sve_sub_umullbvnx2di */

                case 3:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12282; /* aarch64_sve_sub_umullb_lane_vnx4si */

                case 4:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12286; /* aarch64_sve_sub_umullb_lane_vnx2di */

                default:
                  return -1;
                }

            case 558:
              switch (pattern634 (x2))
                {
                case 0:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12271; /* aarch64_sve_sub_umulltvnx8hi */

                case 1:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12275; /* aarch64_sve_sub_umulltvnx4si */

                case 2:
                  if (!
#line 2413 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12279; /* aarch64_sve_sub_umulltvnx2di */

                case 3:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12283; /* aarch64_sve_sub_umullt_lane_vnx4si */

                case 4:
                  if (!
#line 2432 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12287; /* aarch64_sve_sub_umullt_lane_vnx2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (XINT (x3, 1))
            {
            case 169:
              x10 = XVECEXP (x3, 0, 0);
              operands[2] = x10;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x9 = XVECEXP (x3, 0, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_DImode))
                return -1;
              x13 = XVECEXP (x3, 0, 2);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_DImode)
                  || !
#line 10600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11058; /* *aarch64_sve_decsi_pat */

            case 307:
              x9 = XVECEXP (x3, 0, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              switch (pattern1052 (x3))
                {
                case 0:
                  if (!
#line 11020 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11119; /* *aarch64_decsivnx16bi_cntp */

                case 1:
                  if (!
#line 11020 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11120; /* *aarch64_decsivnx8bi_cntp */

                case 2:
                  if (!
#line 11020 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11121; /* *aarch64_decsivnx4bi_cntp */

                case 3:
                  if (!
#line 11020 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 11122; /* *aarch64_decsivnx2bi_cntp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern452 (x2))
        {
        case 0:
          if (!
#line 10648 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11061; /* aarch64_sve_decvnx2di_pat */

        case 1:
          if (!
#line 11108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11131; /* *aarch64_sve_decvnx2di_cntp */

        case 2:
          if (!
#line 10669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11064; /* aarch64_sve_decvnx4si_pat */

        case 3:
          if (!
#line 11147 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11134; /* *aarch64_sve_decvnx4si_cntp */

        case 4:
          if (!
#line 10704 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11067; /* *aarch64_sve_decvnx8hi_pat */

        case 5:
          if (!
#line 11188 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11137; /* *aarch64_sve_decvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_484 (x1, insn, pnum_clobbers);

    case 1:
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 187:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern908 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1629; /* aarch64_absv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern908 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1633; /* aarch64_absv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern908 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1637; /* aarch64_absv2si_vec_concatz_be */

            case E_V2DImode:
              if (pattern908 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1642; /* aarch64_absdi_vec_concatz_be */

            default:
              return -1;
            }

        case 36:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2491; /* btruncv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2519; /* btruncv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2494; /* ceilv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2522; /* ceilv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2497; /* floorv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2525; /* floorv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2500; /* roundevenv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2528; /* roundevenv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 31:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2503; /* nearbyintv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2531; /* nearbyintv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2506; /* rintv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2534; /* rintv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 30:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2509; /* roundv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3007 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2537; /* roundv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 254:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern908 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5026; /* aarch64_rev64v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern908 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5038; /* aarch64_rev64v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern908 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5050; /* aarch64_rev64v2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5065; /* aarch64_rev64v4hf_vec_concatz_be */

            case E_V8BFmode:
              if (pattern908 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5077; /* aarch64_rev64v4bf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5089; /* aarch64_rev64v2sf_vec_concatz_be */

            default:
              return -1;
            }

        case 255:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern908 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5029; /* aarch64_rev32v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern908 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5041; /* aarch64_rev32v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern908 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5053; /* aarch64_rev32v2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5068; /* aarch64_rev32v4hf_vec_concatz_be */

            case E_V8BFmode:
              if (pattern908 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5080; /* aarch64_rev32v4bf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5092; /* aarch64_rev32v2sf_vec_concatz_be */

            default:
              return -1;
            }

        case 256:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern908 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5032; /* aarch64_rev16v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern908 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5044; /* aarch64_rev16v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern908 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5056; /* aarch64_rev16v2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern908 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5071; /* aarch64_rev16v4hf_vec_concatz_be */

            case E_V8BFmode:
              if (pattern908 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5083; /* aarch64_rev16v4bf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8679 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5095; /* aarch64_rev16v2sf_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 275:
          switch (pattern835 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5645 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3520; /* aarch64_sqrdmlahv4hi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5645 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3528; /* aarch64_sqrdmlahv2si_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5661 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3540; /* aarch64_sqrdmlah_lanev4hi_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3560; /* aarch64_sqrdmlah_laneqv4hi_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5661 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3548; /* aarch64_sqrdmlah_lanev2si_vec_concatz_be */

            case 5:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3568; /* aarch64_sqrdmlah_laneqv2si_vec_concatz_be */

            default:
              return -1;
            }

        case 276:
          switch (pattern835 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5645 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3523; /* aarch64_sqrdmlshv4hi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5645 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3531; /* aarch64_sqrdmlshv2si_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5661 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3543; /* aarch64_sqrdmlsh_lanev4hi_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3563; /* aarch64_sqrdmlsh_laneqv4hi_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5661 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3551; /* aarch64_sqrdmlsh_lanev2si_vec_concatz_be */

            case 5:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3571; /* aarch64_sqrdmlsh_laneqv2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_496 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern323 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1356; /* addv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1360; /* addv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1364; /* addv2si3_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2637 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2363; /* addv4hf3_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2637 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2367; /* addv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern773 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1421; /* aarch64_fcmla0v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1437; /* aarch64_fcmla0v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 408:
              switch (pattern773 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1424; /* aarch64_fcmla90v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1440; /* aarch64_fcmla90v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 409:
              switch (pattern773 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1427; /* aarch64_fcmla180v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1443; /* aarch64_fcmla180v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 410:
              switch (pattern773 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1430; /* aarch64_fcmla270v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1446; /* aarch64_fcmla270v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 279:
              if (pattern774 (x2) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1513; /* sdot_prodv2siv8qi_vec_concatz_le */

            case 280:
              if (pattern774 (x2) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1516; /* udot_prodv2siv8qi_vec_concatz_le */

            case 573:
              if (pattern774 (x2) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                return -1;
              return 1521; /* usdot_prodv2siv8qi_vec_concatz_le */

            default:
              return -1;
            }

        case 3:
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x4, 0, 1);
          operands[3] = x7;
          x8 = XVECEXP (x4, 0, 2);
          operands[4] = x8;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern1026 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1457; /* aarch64_fcmla_lane0v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1493; /* aarch64_fcmla_laneq0v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1473; /* aarch64_fcmla_lane0v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 408:
              switch (pattern1026 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1460; /* aarch64_fcmla_lane90v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1496; /* aarch64_fcmla_laneq90v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1476; /* aarch64_fcmla_lane90v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 409:
              switch (pattern1026 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1463; /* aarch64_fcmla_lane180v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1499; /* aarch64_fcmla_laneq180v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1479; /* aarch64_fcmla_lane180v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 410:
              switch (pattern1026 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1466; /* aarch64_fcmla_lane270v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1502; /* aarch64_fcmla_laneq270v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1482; /* aarch64_fcmla_lane270v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 279:
              switch (pattern1027 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1525; /* aarch64_sdot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1533; /* aarch64_sdot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 280:
              switch (pattern1027 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1528; /* aarch64_udot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1536; /* aarch64_udot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 573:
              switch (pattern1027 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1541; /* aarch64_usdot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1549; /* aarch64_usdot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 578:
              switch (pattern1027 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1544; /* aarch64_sudot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1552; /* aarch64_sudot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != VEC_SELECT)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      x13 = XEXP (x11, 1);
      operands[4] = x13;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      x5 = XEXP (x2, 1);
      operands[5] = x5;
      x14 = XEXP (x10, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTEND:
          switch (pattern1029 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1704; /* *aarch64_sadalpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1712; /* *aarch64_sadalpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1722; /* *aarch64_sadalpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1029 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1707; /* *aarch64_uadalpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1715; /* *aarch64_uadalpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1725; /* *aarch64_uadalpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      x5 = XEXP (x2, 1);
      operands[4] = x5;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SMAX:
          switch (pattern776 (x2, 
SMIN))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1728; /* aarch64_sabav8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1736; /* aarch64_sabav4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1744; /* aarch64_sabav2si_vec_concatz_le */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern776 (x2, 
UMIN))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1731; /* aarch64_uabav8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1739; /* aarch64_uabav4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1747; /* aarch64_uabav2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern970 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1638 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2003; /* aarch64_mlav8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern970 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1638 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2007; /* aarch64_mlav4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern970 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1638 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2011; /* aarch64_mlav2si_vec_concatz_le */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x14 = XEXP (x10, 0);
          switch (GET_CODE (x14))
            {
            case VEC_SELECT:
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x16 = XEXP (x14, 0);
              operands[1] = x16;
              x17 = XVECEXP (x15, 0, 0);
              operands[2] = x17;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x4, 1);
              operands[3] = x11;
              x9 = XEXP (x3, 1);
              operands[4] = x9;
              x5 = XEXP (x2, 1);
              operands[5] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1211 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[1], E_V4HImode)
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2015; /* *aarch64_mla_eltv4hi_vec_concatz_le */

                    case E_V8HImode:
                      if (!register_operand (operands[1], E_V8HImode)
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2023; /* *aarch64_mla_elt_to_128v4hi_vec_concatz_le */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (pattern1211 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[1], E_V2SImode)
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2019; /* *aarch64_mla_eltv2si_vec_concatz_le */

                    case E_V4SImode:
                      if (!register_operand (operands[1], E_V4SImode)
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2027; /* *aarch64_mla_elt_to_128v2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x14;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x9 = XEXP (x3, 1);
              operands[1] = x9;
              x5 = XEXP (x2, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1030 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2031; /* aarch64_mla_nv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1030 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2035; /* aarch64_mla_nv2si_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != VEC_SELECT)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          switch (pattern654 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2797; /* *aarch64_saddlpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2805; /* *aarch64_saddlpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2815; /* *aarch64_saddlpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern654 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2800; /* *aarch64_uaddlpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2808; /* *aarch64_uaddlpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2818; /* *aarch64_uaddlpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x18 = XEXP (x5, 0);
          if (GET_CODE (x18) != VEC_SELECT)
            return -1;
          x19 = XEXP (x5, 1);
          if (GET_CODE (x19) != VEC_SELECT)
            return -1;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x20 = XEXP (x9, 1);
          operands[4] = x20;
          x21 = XEXP (x18, 0);
          operands[2] = x21;
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x23 = XEXP (x18, 1);
          if (!rtx_equal_p (x23, operands[3]))
            return -1;
          x24 = XEXP (x19, 0);
          if (!rtx_equal_p (x24, operands[2]))
            return -1;
          x25 = XEXP (x19, 1);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1286 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 7464 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4369; /* aarch64_addpv16qi_insn */

            case E_V8HImode:
              if (pattern1286 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 7464 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4370; /* aarch64_addpv8hi_insn */

            case E_V4SImode:
              if (pattern1286 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 7464 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4371; /* aarch64_addpv4si_insn */

            case E_V2DImode:
              if (pattern1286 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 7464 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4372; /* aarch64_addpv2di_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x22 = XEXP (x9, 0);
          if (GET_CODE (x22) != VEC_CONCAT)
            return -1;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x20 = XEXP (x9, 1);
          operands[4] = x20;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          x26 = XEXP (x22, 0);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          x27 = XEXP (x22, 1);
          if (!rtx_equal_p (x27, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1212 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4374; /* aarch64_addpv8qi_vec_concatz_le_insn */

            case E_V8HImode:
              if (pattern1212 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4377; /* aarch64_addpv4hi_vec_concatz_le_insn */

            case E_V4SImode:
              if (pattern1212 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4380; /* aarch64_addpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x9 = XEXP (x3, 1);
          operands[4] = x9;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1031 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7333 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4214; /* aarch64_cmtstv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern1031 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7333 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4218; /* aarch64_cmtstv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern1031 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7333 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4222; /* aarch64_cmtstv2si_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern971 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4227; /* *aarch64_cmtst_same_v8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern971 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4231; /* *aarch64_cmtst_same_v4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern971 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4235; /* *aarch64_cmtst_same_v2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_447 (x1, insn, pnum_clobbers);

    case 2:
      return recog_443 (x1, insn, pnum_clobbers);

    case 3:
      return recog_446 (x1, insn, pnum_clobbers);

    case 4:
      return recog_445 (x1, insn, pnum_clobbers);

    case 5:
      return recog_444 (x1, insn, pnum_clobbers);

    case 7:
      switch (XINT (x2, 1))
        {
        case 120:
          x3 = XVECEXP (x2, 0, 6);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != SCRATCH)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 0);
          operands[5] = x6;
          x7 = XVECEXP (x2, 0, 1);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 3);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 4);
          operands[4] = x9;
          x10 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XVECEXP (x2, 0, 5);
              operands[6] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4QImode:
                  if (pattern1232 (x2, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1541 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6103; /* mask_gather_loadvnx4qivnx4si */

                case E_VNx4HImode:
                  if (pattern1233 (x2, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1541 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6104; /* mask_gather_loadvnx4hivnx4si */

                case E_VNx4HFmode:
                  if (pattern1233 (x2, 
E_VNx4HFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1541 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6105; /* mask_gather_loadvnx4hfvnx4si */

                case E_VNx4BFmode:
                  if (pattern1233 (x2, 
E_VNx4BFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1541 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6106; /* mask_gather_loadvnx4bfvnx4si */

                case E_VNx4SImode:
                  if (!register_operand (operands[0], E_VNx4SImode)
                      || GET_MODE (x2) != E_VNx4SImode
                      || !register_operand (operands[5], E_VNx4BImode)
                      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      || !register_operand (operands[2], E_VNx4SImode)
                      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      || !aarch64_maskload_else_operand (operands[6], E_VNx4SImode)
                      || !
#line 1541 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6107; /* mask_gather_loadvnx4sivnx4si */

                case E_VNx4SFmode:
                  if (pattern1234 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1541 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6108; /* mask_gather_loadvnx4sfvnx4si */

                case E_VNx2QImode:
                  if (pattern1232 (x2, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6109; /* mask_gather_loadvnx2qivnx2di */

                case E_VNx2HImode:
                  if (pattern1233 (x2, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6110; /* mask_gather_loadvnx2hivnx2di */

                case E_VNx2HFmode:
                  if (pattern1233 (x2, 
E_VNx2HFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6111; /* mask_gather_loadvnx2hfvnx2di */

                case E_VNx2BFmode:
                  if (pattern1233 (x2, 
E_VNx2BFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6112; /* mask_gather_loadvnx2bfvnx2di */

                case E_VNx2SImode:
                  if (pattern1234 (x2, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6113; /* mask_gather_loadvnx2sivnx2di */

                case E_VNx2SFmode:
                  if (pattern1234 (x2, 
E_VNx2SFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6114; /* mask_gather_loadvnx2sfvnx2di */

                case E_VNx2DImode:
                  if (pattern1235 (x2, 
E_VNx2DImode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6115; /* mask_gather_loadvnx2divnx2di */

                case E_VNx2DFmode:
                  if (pattern1235 (x2, 
E_VNx2DFmode) != 0
                      || !
#line 1571 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6116; /* mask_gather_loadvnx2dfvnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern1133 (x10) != 0
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x12 = XVECEXP (x10, 0, 0);
              operands[6] = x12;
              x13 = XVECEXP (x10, 0, 1);
              if (GET_MODE (x13) != E_VNx2DImode)
                return -1;
              switch (pattern1313 (x2))
                {
                case 0:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6117; /* *mask_gather_loadvnx2qivnx2di_sxtw_unpacked */

                case 1:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6119; /* *mask_gather_loadvnx2hivnx2di_sxtw_unpacked */

                case 2:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6121; /* *mask_gather_loadvnx2hfvnx2di_sxtw_unpacked */

                case 3:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6123; /* *mask_gather_loadvnx2bfvnx2di_sxtw_unpacked */

                case 4:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6125; /* *mask_gather_loadvnx2sivnx2di_sxtw_unpacked */

                case 5:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6127; /* *mask_gather_loadvnx2sfvnx2di_sxtw_unpacked */

                case 6:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6129; /* *mask_gather_loadvnx2divnx2di_sxtw_unpacked */

                case 7:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6131; /* *mask_gather_loadvnx2dfvnx2di_sxtw_unpacked */

                case 8:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6133; /* *mask_gather_loadvnx2qivnx2di_sxtw */

                case 9:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6134; /* *mask_gather_loadvnx2hivnx2di_sxtw */

                case 10:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6135; /* *mask_gather_loadvnx2hfvnx2di_sxtw */

                case 11:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6136; /* *mask_gather_loadvnx2bfvnx2di_sxtw */

                case 12:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6137; /* *mask_gather_loadvnx2sivnx2di_sxtw */

                case 13:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6138; /* *mask_gather_loadvnx2sfvnx2di_sxtw */

                case 14:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6139; /* *mask_gather_loadvnx2divnx2di_sxtw */

                case 15:
                  if (!
#line 1631 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6140; /* *mask_gather_loadvnx2dfvnx2di_sxtw */

                case 16:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6118; /* *mask_gather_loadvnx2qivnx2di_uxtw_unpacked */

                case 17:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6120; /* *mask_gather_loadvnx2hivnx2di_uxtw_unpacked */

                case 18:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6122; /* *mask_gather_loadvnx2hfvnx2di_uxtw_unpacked */

                case 19:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6124; /* *mask_gather_loadvnx2bfvnx2di_uxtw_unpacked */

                case 20:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6126; /* *mask_gather_loadvnx2sivnx2di_uxtw_unpacked */

                case 21:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6128; /* *mask_gather_loadvnx2sfvnx2di_uxtw_unpacked */

                case 22:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6130; /* *mask_gather_loadvnx2divnx2di_uxtw_unpacked */

                case 23:
                  if (!
#line 1600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6132; /* *mask_gather_loadvnx2dfvnx2di_uxtw_unpacked */

                default:
                  return -1;
                }

            case AND:
              if (pattern1134 (x10) != 0)
                return -1;
              x11 = XVECEXP (x2, 0, 5);
              operands[7] = x11;
              switch (pattern1311 (x2))
                {
                case 0:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6141; /* *mask_gather_loadvnx2qivnx2di_uxtw */

                case 1:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6142; /* *mask_gather_loadvnx2hivnx2di_uxtw */

                case 2:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6143; /* *mask_gather_loadvnx2hfvnx2di_uxtw */

                case 3:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6144; /* *mask_gather_loadvnx2bfvnx2di_uxtw */

                case 4:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6145; /* *mask_gather_loadvnx2sivnx2di_uxtw */

                case 5:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6146; /* *mask_gather_loadvnx2sfvnx2di_uxtw */

                case 6:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6147; /* *mask_gather_loadvnx2divnx2di_uxtw */

                case 7:
                  if (!
#line 1659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6148; /* *mask_gather_loadvnx2dfvnx2di_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          if (pattern263 (x2) != 0)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 0);
          operands[5] = x6;
          x7 = XVECEXP (x2, 0, 1);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 3);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 4);
          operands[4] = x9;
          x10 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
              operands[2] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4SImode:
                  if (pattern1284 (x2, 
E_VNx4SImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6247; /* aarch64_ldff1_gathervnx4si */

                case E_VNx4SFmode:
                  if (pattern1284 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6248; /* aarch64_ldff1_gathervnx4sf */

                case E_VNx2DImode:
                  if (pattern1285 (x2, 
E_VNx2DImode) != 0
                      || !
#line 1915 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6249; /* aarch64_ldff1_gathervnx2di */

                case E_VNx2DFmode:
                  if (pattern1285 (x2, 
E_VNx2DFmode) != 0
                      || !
#line 1915 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6250; /* aarch64_ldff1_gathervnx2df */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x10, 0) != 2
                  || XINT (x10, 1) != 125
                  || GET_MODE (x10) != E_VNx2DImode)
                return -1;
              x13 = XVECEXP (x10, 0, 1);
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_MODE (x13) != E_VNx2DImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != TRUNCATE
                  || GET_MODE (x14) != E_VNx2SImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x12 = XVECEXP (x10, 0, 0);
              operands[6] = x12;
              switch (pattern1360 (x2))
                {
                case 0:
                  if (!
#line 1945 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6251; /* *aarch64_ldff1_gathervnx2di_sxtw */

                case 1:
                  if (!
#line 1945 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6252; /* *aarch64_ldff1_gathervnx2df_sxtw */

                default:
                  return -1;
                }

            case AND:
              if (pattern1134 (x10) != 0)
                return -1;
              switch (pattern1346 (x2))
                {
                case 0:
                  if (!
#line 1972 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6253; /* *aarch64_ldff1_gathervnx2di_uxtw */

                case 1:
                  if (!
#line 1972 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6254; /* *aarch64_ldff1_gathervnx2df_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 659:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13941; /* aarch64_sme_smopavnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13957; /* aarch64_sme_smopavnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13949; /* aarch64_sme_smopavnx2divnx8hi */

            default:
              return -1;
            }

        case 660:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13942; /* aarch64_sme_smopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13958; /* aarch64_sme_smopsvnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13950; /* aarch64_sme_smopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 667:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13943; /* aarch64_sme_sumopavnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13951; /* aarch64_sme_sumopavnx2divnx8hi */

            default:
              return -1;
            }

        case 668:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13944; /* aarch64_sme_sumopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13952; /* aarch64_sme_sumopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 673:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13945; /* aarch64_sme_umopavnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13959; /* aarch64_sme_umopavnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13953; /* aarch64_sme_umopavnx2divnx8hi */

            default:
              return -1;
            }

        case 674:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13946; /* aarch64_sme_umopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13960; /* aarch64_sme_umopsvnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13954; /* aarch64_sme_umopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 677:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13947; /* aarch64_sme_usmopavnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13955; /* aarch64_sme_usmopavnx2divnx8hi */

            default:
              return -1;
            }

        case 678:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13948; /* aarch64_sme_usmopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13956; /* aarch64_sme_usmopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 637:
          if (pattern268 (x1) != 0
              || !
#line 1747 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13961; /* aarch64_sme_bmopavnx4sivnx4si */

        case 638:
          if (pattern268 (x1) != 0
              || !
#line 1747 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13962; /* aarch64_sme_bmopsvnx4sivnx4si */

        case 644:
          switch (pattern270 (x1))
            {
            case 0:
              if (!
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14155; /* aarch64_sme_fmopavnx4sfvnx4sf */

            case 1:
              if (!(
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 734 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
                return -1;
              return 14157; /* aarch64_sme_fmopavnx2dfvnx2df */

            case 2:
              if (!(
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 735 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
                return -1;
              return 14159; /* aarch64_sme_fmopavnx8hfvnx8hf */

            case 3:
              if (!(
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 736 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
                return -1;
              return 14161; /* aarch64_sme_fmopavnx8bfvnx8bf */

            case 4:
              if (!
#line 2121 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14163; /* aarch64_sme_fmopavnx4sivnx8bf */

            case 5:
              if (!
#line 2121 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14165; /* aarch64_sme_fmopavnx4sivnx8hf */

            default:
              return -1;
            }

        case 645:
          switch (pattern270 (x1))
            {
            case 0:
              if (!
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14156; /* aarch64_sme_fmopsvnx4sfvnx4sf */

            case 1:
              if (!(
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 734 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
                return -1;
              return 14158; /* aarch64_sme_fmopsvnx2dfvnx2df */

            case 2:
              if (!(
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 735 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
                return -1;
              return 14160; /* aarch64_sme_fmopsvnx8hfvnx8hf */

            case 3:
              if (!(
#line 2106 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 736 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
                return -1;
              return 14162; /* aarch64_sme_fmopsvnx8bfvnx8bf */

            case 4:
              if (!
#line 2121 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14164; /* aarch64_sme_fmopsvnx4sivnx8bf */

            case 5:
              if (!
#line 2121 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14166; /* aarch64_sme_fmopsvnx4sivnx8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 6:
      return recog_448 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 578; /* one_cmplsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 579; /* one_cmpldi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1804; /* one_cmplv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1807; /* one_cmplv16qi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1808; /* one_cmplv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1811; /* one_cmplv8hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1812; /* one_cmplv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1815; /* one_cmplv4si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1816; /* one_cmplv2di2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern298 (x3))
        {
        case 0:
          return 581; /* *one_cmpl_ashlsi2 */

        case 1:
          return 586; /* *one_cmpl_ashldi2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern298 (x3))
        {
        case 0:
          return 582; /* *one_cmpl_ashrsi2 */

        case 1:
          return 587; /* *one_cmpl_ashrdi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern298 (x3))
        {
        case 0:
          return 583; /* *one_cmpl_lshrsi2 */

        case 1:
          return 588; /* *one_cmpl_lshrdi2 */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern298 (x3))
        {
        case 0:
          return 584; /* *one_cmpl_rotrsi2 */

        case 1:
          return 589; /* *one_cmpl_rotrdi2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern298 (x3))
        {
        case 0:
          return 585; /* *one_cmpl_rotlsi2 */

        case 1:
          return 590; /* *one_cmpl_rotldi2 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern370 (x3))
            {
            case 0:
              return 598; /* *xor_one_cmplsi3 */

            case 1:
              return 599; /* *xor_one_cmpldi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern415 (x3))
            {
            case 0:
              return 650; /* *eor_one_cmpl_ashlsi3_alt */

            case 1:
              return 655; /* *eor_one_cmpl_ashldi3_alt */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern415 (x3))
            {
            case 0:
              return 651; /* *eor_one_cmpl_ashrsi3_alt */

            case 1:
              return 656; /* *eor_one_cmpl_ashrdi3_alt */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern415 (x3))
            {
            case 0:
              return 652; /* *eor_one_cmpl_lshrsi3_alt */

            case 1:
              return 657; /* *eor_one_cmpl_lshrdi3_alt */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern415 (x3))
            {
            case 0:
              return 653; /* *eor_one_cmpl_rotrsi3_alt */

            case 1:
              return 658; /* *eor_one_cmpl_rotrdi3_alt */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern415 (x3))
            {
            case 0:
              return 654; /* *eor_one_cmpl_rotlsi3_alt */

            case 1:
              return 659; /* *eor_one_cmpl_rotldi3_alt */

            default:
              return -1;
            }

        case AND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern900 (x3, 
E_V8QImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11972; /* *aarch64_sve2_nbsl_unpredv8qi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11973; /* *aarch64_sve2_nbsl_unpredv8qi */

            case E_V16QImode:
              if (pattern900 (x3, 
E_V16QImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11974; /* *aarch64_sve2_nbsl_unpredv16qi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11975; /* *aarch64_sve2_nbsl_unpredv16qi */

            case E_V4HImode:
              if (pattern900 (x3, 
E_V4HImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11976; /* *aarch64_sve2_nbsl_unpredv4hi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11977; /* *aarch64_sve2_nbsl_unpredv4hi */

            case E_V8HImode:
              if (pattern900 (x3, 
E_V8HImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11978; /* *aarch64_sve2_nbsl_unpredv8hi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11979; /* *aarch64_sve2_nbsl_unpredv8hi */

            case E_V2SImode:
              if (pattern900 (x3, 
E_V2SImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11980; /* *aarch64_sve2_nbsl_unpredv2si */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11981; /* *aarch64_sve2_nbsl_unpredv2si */

            case E_V4SImode:
              if (pattern900 (x3, 
E_V4SImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11982; /* *aarch64_sve2_nbsl_unpredv4si */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11983; /* *aarch64_sve2_nbsl_unpredv4si */

            case E_V2DImode:
              if (pattern900 (x3, 
E_V2DImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11984; /* *aarch64_sve2_nbsl_unpredv2di */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11985; /* *aarch64_sve2_nbsl_unpredv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern314 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern761 (x3, 
E_SImode) == 0
                  && 
#line 7398 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1084; /* *aarch64_smaxsi3_cssc */
              break;

            case E_DImode:
              if (pattern761 (x3, 
E_DImode) == 0
                  && 
#line 7398 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1088; /* *aarch64_smaxdi3_cssc */
              break;

            case E_SFmode:
              if (pattern31 (x3, 
E_SFmode) == 0
                  && 
#line 7423 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1096; /* smaxsf3 */
              break;

            case E_DFmode:
              if (pattern31 (x3, 
E_DFmode) == 0
                  && 
#line 7423 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1097; /* smaxdf3 */
              break;

            case E_V8QImode:
              if (pattern31 (x3, 
E_V8QImode) == 0
                  && 
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2074; /* smaxv8qi3 */
              break;

            case E_V16QImode:
              if (pattern31 (x3, 
E_V16QImode) == 0
                  && 
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2086; /* smaxv16qi3 */
              break;

            case E_V4HImode:
              if (pattern31 (x3, 
E_V4HImode) == 0
                  && 
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2090; /* smaxv4hi3 */
              break;

            case E_V8HImode:
              if (pattern31 (x3, 
E_V8HImode) == 0
                  && 
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2102; /* smaxv8hi3 */
              break;

            case E_V2SImode:
              if (pattern31 (x3, 
E_V2SImode) == 0
                  && 
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2106; /* smaxv2si3 */
              break;

            case E_V4SImode:
              if (pattern31 (x3, 
E_V4SImode) == 0
                  && 
#line 1756 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2118; /* smaxv4si3 */
              break;

            case E_V4HFmode:
              if (pattern31 (x3, 
E_V4HFmode) == 0
                  && (
#line 3350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2672; /* smaxv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern31 (x3, 
E_V8HFmode) == 0
                  && (
#line 3350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2674; /* smaxv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern31 (x3, 
E_V2SFmode) == 0
                  && 
#line 3350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2676; /* smaxv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern31 (x3, 
E_V4SFmode) == 0
                  && 
#line 3350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2678; /* smaxv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern31 (x3, 
E_V2DFmode) == 0
                  && 
#line 3350 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2680; /* smaxv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern32 (x3, 
E_VNx32QImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11466; /* *smaxvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern32 (x3, 
E_VNx16HImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11470; /* *smaxvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern32 (x3, 
E_VNx8SImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11474; /* *smaxvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern32 (x3, 
E_VNx4DImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11478; /* *smaxvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern32 (x3, 
E_VNx64QImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11482; /* *smaxvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern32 (x3, 
E_VNx32HImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11486; /* *smaxvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern32 (x3, 
E_VNx16SImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11490; /* *smaxvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern32 (x3, 
E_VNx8DImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11494; /* *smaxvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1092; /* *aarch64_smaxsi3_zero */

            case 1:
              return 1094; /* *aarch64_smaxdi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7430; /* *post_ra_smaxvnx16qi3 */

        case 2:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7435; /* *post_ra_smaxvnx8qi3 */

        case 3:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7440; /* *post_ra_smaxvnx4qi3 */

        case 4:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7445; /* *post_ra_smaxvnx2qi3 */

        case 5:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7450; /* *post_ra_smaxvnx8hi3 */

        case 6:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7455; /* *post_ra_smaxvnx4hi3 */

        case 7:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7460; /* *post_ra_smaxvnx2hi3 */

        case 8:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7465; /* *post_ra_smaxvnx4si3 */

        case 9:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7470; /* *post_ra_smaxvnx2si3 */

        case 10:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7475; /* *post_ra_smaxvnx2di3 */

        case 11:
          if (!
#line 4027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7480; /* *post_ra_smaxv2di3 */

        case 12:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11499; /* aarch64_sve_single_smaxvnx32qi */

        case 13:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11504; /* aarch64_sve_single_smaxvnx16hi */

        case 14:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11509; /* aarch64_sve_single_smaxvnx8si */

        case 15:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11514; /* aarch64_sve_single_smaxvnx4di */

        case 16:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11519; /* aarch64_sve_single_smaxvnx64qi */

        case 17:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11524; /* aarch64_sve_single_smaxvnx32hi */

        case 18:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11529; /* aarch64_sve_single_smaxvnx16si */

        case 19:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11534; /* aarch64_sve_single_smaxvnx8di */

        default:
          return -1;
        }

    case ABS:
      switch (pattern315 (x3))
        {
        case 0:
          if (!(
#line 10045 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5293; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 10045 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5295; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 10045 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5297; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 10045 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5299; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 10045 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5301; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      switch (pattern449 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3253; /* ussubv8qi3 */

        case 1:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3259; /* ussubv16qi3 */

        case 2:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3269; /* ussubv4hi3 */

        case 3:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3275; /* ussubv8hi3 */

        case 4:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3285; /* ussubv2si3 */

        case 5:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3291; /* ussubv4si3 */

        case 6:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3295; /* ussubv2di3 */

        case 7:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3299; /* ussubhi3 */

        case 8:
          if (!
#line 5172 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3303; /* ussubqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3309; /* ussubsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3311; /* ussubdi3 */

        case 11:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8117; /* ussubvnx16qi3 */

        case 12:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8119; /* ussubvnx8hi3 */

        case 13:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8121; /* ussubvnx4si3 */

        case 14:
          if (!
#line 4525 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8123; /* ussubvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern451 (x3))
        {
        case 0:
          if (!
#line 10583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11057; /* aarch64_sve_uqdecdi_pat */

        case 1:
          if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11109; /* *aarch64_sve_uqdecdivnx16bi_cntp */

        case 2:
          if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11112; /* *aarch64_sve_uqdecdivnx8bi_cntp */

        case 3:
          if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11115; /* *aarch64_sve_uqdecdivnx4bi_cntp */

        case 4:
          if (!
#line 11001 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11118; /* *aarch64_sve_uqdecdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern452 (x3))
        {
        case 0:
          if (!
#line 10648 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11063; /* aarch64_sve_uqdecvnx2di_pat */

        case 1:
          if (!
#line 11108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11133; /* *aarch64_sve_uqdecvnx2di_cntp */

        case 2:
          if (!
#line 10669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11066; /* aarch64_sve_uqdecvnx4si_pat */

        case 3:
          if (!
#line 11147 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11136; /* *aarch64_sve_uqdecvnx4si_cntp */

        case 4:
          if (!
#line 10704 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11069; /* *aarch64_sve_uqdecvnx8hi_pat */

        case 5:
          if (!
#line 11188 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11139; /* *aarch64_sve_uqdecvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10109; /* *while_rwsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10119; /* *while_rwdivnx4bi_cc */
}

 int
recog_567 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10108; /* *while_ugesivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10118; /* *while_ugedivnx4bi_cc */
}

 int
recog_575 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10107; /* *while_ugtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10117; /* *while_ugtdivnx4bi_cc */
}

 int
recog_585 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10066; /* *while_gtsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10076; /* *while_gtdivnx16bi_cc */
}

 int
recog_595 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  switch (GET_CODE (x4))
    {
    case CONST:
      switch (pattern1095 (x1))
        {
        case 0:
          if (!
#line 1000 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5728; /* *aarch64_sve_ptruevnx16bi_cc */

        case 1:
          if (!
#line 1052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5732; /* *aarch64_sve_ptruevnx16bi_ptest */

        default:
          return -1;
        }

    case SUBREG:
      switch (pattern1097 (x1))
        {
        case 0:
          if (!
#line 1026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5729; /* *aarch64_sve_ptruevnx8bi_cc */

        case 1:
          if (!
#line 1026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5730; /* *aarch64_sve_ptruevnx4bi_cc */

        case 2:
          if (!
#line 1026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5731; /* *aarch64_sve_ptruevnx2bi_cc */

        case 3:
          if (!
#line 1078 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5733; /* *aarch64_sve_ptruevnx8bi_ptest */

        case 4:
          if (!
#line 1078 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5734; /* *aarch64_sve_ptruevnx4bi_ptest */

        case 5:
          if (!
#line 1078 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5735; /* *aarch64_sve_ptruevnx2bi_ptest */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 86
          || GET_MODE (x4) != E_VNx16BImode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!scratch_operand (operands[0], E_VNx16BImode)
              || !
#line 1217 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 5744; /* *aarch64_rdffr_ptest */

        case SET:
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 86
              || GET_MODE (x9) != E_VNx16BImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_VNx16BImode)
              || !
#line 1259 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 5746; /* *aarch64_rdffr_cc */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_594 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (pattern1272 (x6, 
E_SImode) != 0
          || !
#line 3563 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 283; /* subsi3_compare1_imm */

    case E_DImode:
      if (pattern1272 (x6, 
E_DImode) != 0
          || !
#line 3563 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 284; /* subdi3_compare1_imm */

    default:
      return -1;
    }
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_TImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LTU
          || GET_MODE (x6) != E_TImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 66
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_TImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_TImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != NEG
          || GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != LTU
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 66
          || GET_MODE (x14) != E_CCmode)
        return -1;
      x15 = XEXP (x13, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != NEG
          || GET_MODE (x17) != E_DImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != LTU
          || GET_MODE (x19) != E_DImode)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 66
          || GET_MODE (x20) != E_CCmode)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_Vmode
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x23 = XEXP (x9, 0);
      operands[1] = x23;
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x24 = XEXP (x12, 1);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x18, 1);
      if (!rtx_equal_p (x25, operands[1]))
        return -1;
      return 279; /* negvdi_carryinV */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_NZmode
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      switch (GET_CODE (x17))
        {
        case NEG:
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode)
                return -1;
              return 358; /* negsi2_compare0 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode)
                return -1;
              return 359; /* negdi2_compare0 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1192 (x1, 
NEG) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          return 360; /* *negsi2_compare0_uxtw */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern924 (x1, 
ASHIFT))
        {
        case 0:
          return 361; /* *neg_lslsi3_compare0 */

        case 1:
          return 364; /* *neg_lsldi3_compare0 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern924 (x1, 
ASHIFTRT))
        {
        case 0:
          return 362; /* *neg_asrsi3_compare0 */

        case 1:
          return 365; /* *neg_asrdi3_compare0 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern924 (x1, 
LSHIFTRT))
        {
        case 0:
          return 363; /* *neg_lsrsi3_compare0 */

        case 1:
          return 366; /* *neg_lsrdi3_compare0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_613 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      return recog_608 (x1, insn, pnum_clobbers);

    case MINUS:
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case ASHIFT:
              x11 = XEXP (x4, 1);
              if (GET_CODE (x11) != MINUS)
                return -1;
              x12 = XEXP (x11, 1);
              if (GET_CODE (x12) != ASHIFT)
                return -1;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x12, 1);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              x16 = XEXP (x10, 0);
              switch (GET_CODE (x16))
                {
                case REG:
                case SUBREG:
                  operands[2] = x16;
                  x17 = XEXP (x12, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  switch (pattern1188 (x1))
                    {
                    case 0:
                      return 146; /* *subs_shift_imm_si */

                    case 1:
                      return 149; /* *subs_shift_imm_di */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern1317 (x1, 
SIGN_EXTEND))
                    {
                    case 0:
                      return 188; /* *subs_extendqi_shift_si */

                    case 1:
                      return 192; /* *subs_extendhi_shift_si */

                    case 2:
                      return 196; /* *subs_extendsi_shift_si */

                    case 3:
                      return 190; /* *subs_extendqi_shift_di */

                    case 4:
                      return 194; /* *subs_extendhi_shift_di */

                    case 5:
                      return 198; /* *subs_extendsi_shift_di */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern1317 (x1, 
ZERO_EXTEND))
                    {
                    case 0:
                      return 189; /* *subs_zero_extendqi_shift_si */

                    case 1:
                      return 193; /* *subs_zero_extendhi_shift_si */

                    case 2:
                      return 197; /* *subs_zero_extendsi_shift_si */

                    case 3:
                      return 191; /* *subs_zero_extendqi_shift_di */

                    case 4:
                      return 195; /* *subs_zero_extendhi_shift_di */

                    case 5:
                      return 199; /* *subs_zero_extendsi_shift_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1189 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 147; /* *subs_shift_imm_si */

                case 1:
                  return 150; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1189 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 148; /* *subs_shift_imm_si */

                case 1:
                  return 151; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern1191 (x1, 
SIGN_EXTEND))
                {
                case 0:
                  return 164; /* *subs_extendqi_si */

                case 1:
                  return 168; /* *subs_extendhi_si */

                case 2:
                  return 172; /* *subs_extendsi_si */

                case 3:
                  return 166; /* *subs_extendqi_di */

                case 4:
                  return 170; /* *subs_extendhi_di */

                case 5:
                  return 174; /* *subs_extendsi_di */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern1191 (x1, 
ZERO_EXTEND))
                {
                case 0:
                  return 165; /* *subs_zero_extendqi_si */

                case 1:
                  return 169; /* *subs_zero_extendhi_si */

                case 2:
                  return 173; /* *subs_zero_extendsi_si */

                case 3:
                  return 167; /* *subs_zero_extendqi_di */

                case 4:
                  return 171; /* *subs_zero_extendhi_di */

                case 5:
                  return 175; /* *subs_zero_extendsi_di */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case MINUS:
                  x14 = XEXP (x11, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1304 (x11, 
E_SImode) != 0)
                        return -1;
                      return 280; /* *subsi3_compare0 */

                    case E_DImode:
                      if (pattern1304 (x11, 
E_DImode) != 0)
                        return -1;
                      return 281; /* *subdi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (pattern1225 (x1, 
MINUS) != 0
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x14 = XEXP (x11, 0);
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 282; /* *subsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != MINUS)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x6) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case GEU:
            case LTU:
              operands[2] = x10;
              x23 = XEXP (x20, 1);
              operands[3] = x23;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1343 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 343; /* *subsi3_carryinV_z2 */

                case E_TImode:
                  if (pattern1343 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 344; /* *subdi3_carryinV_z2 */

                default:
                  return -1;
                }

            case PLUS:
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x23 = XEXP (x20, 1);
              if (GET_CODE (x23) != PLUS)
                return -1;
              x14 = XEXP (x11, 0);
              if (GET_CODE (x14) != MINUS)
                return -1;
              x24 = XEXP (x16, 0);
              operands[2] = x24;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x25 = XEXP (x23, 0);
              operands[4] = x25;
              x26 = XEXP (x23, 1);
              if (!rtx_equal_p (x26, operands[2]))
                return -1;
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1369 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 345; /* *subsi3_carryinV */

                case E_TImode:
                  if (pattern1369 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 346; /* *subdi3_carryinV */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x6) != E_CC_Vmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case MINUS:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != MINUS)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x27 = XEXP (x8, 1);
          operands[2] = x27;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x12 = XEXP (x11, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              x28 = XEXP (x9, 1);
              if (GET_CODE (x28) != SIGN_EXTEND)
                return -1;
              x29 = XEXP (x28, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1347 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 268; /* subvsi_insn */

                case E_TImode:
                  if (pattern1347 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 269; /* subvdi_insn */

                default:
                  return -1;
                }

            case CONST_INT:
              x28 = XEXP (x9, 1);
              if (!rtx_equal_p (x28, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1344 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 270; /* subvsi_imm */

                case E_TImode:
                  if (pattern1344 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 271; /* subvdi_imm */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != NEG)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1295 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 272; /* negvsi_insn */

            case E_TImode:
              if (pattern1295 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 273; /* negvdi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_609 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (GET_MODE (x3) != E_CCmode
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          res = recog_606 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_607 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != MINUS)
        return -1;
      operands[1] = x7;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (aarch64_reg_or_zero (operands[2], E_SImode)
          && pattern1193 (x11, 
E_SImode) == 0)
        return 285; /* subsi3_compare1 */
      if (!aarch64_reg_or_zero (operands[2], E_DImode)
          || pattern1193 (x11, 
E_DImode) != 0)
        return -1;
      return 286; /* subdi3_compare1 */

    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      switch (GET_CODE (x9))
        {
        case GEU:
        case LTU:
          operands[2] = x9;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x12 = XEXP (x11, 1);
          operands[3] = x12;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1273 (x11, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 339; /* *usubsi3_carryinC_z2 */

            case E_TImode:
              if (pattern1273 (x11, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 340; /* *usubdi3_carryinC_z2 */

            default:
              return -1;
            }

        case PLUS:
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != ZERO_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x14 = XEXP (x11, 0);
          if (GET_CODE (x14) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x22 = XEXP (x20, 0);
          operands[2] = x22;
          x28 = XEXP (x9, 1);
          operands[3] = x28;
          x12 = XEXP (x11, 1);
          operands[4] = x12;
          x18 = XEXP (x14, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x14, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1325 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 341; /* *usubsi3_carryinC */

            case E_TImode:
              if (pattern1325 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 342; /* *usubdi3_carryinC */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x9, 0) != 0L)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != ZERO_EXTEND
              || GET_MODE (x3) != E_CC_Zmode
              || GET_MODE (x6) != E_CC_Zmode)
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_SImode:
              switch (pattern1257 (x11, 
E_SImode))
                {
                case 0:
                  return 702; /* *andssi_compare0 */

                case 1:
                  return 704; /* *andssi_compare0 */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1257 (x11, 
E_DImode))
                {
                case 0:
                  return 703; /* *andsdi_compare0 */

                case 1:
                  return 705; /* *andsdi_compare0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_CC_NZVmode
          || GET_MODE (x6) != E_CC_NZVmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case AND:
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_SImode:
                  if (pattern1296 (x11, 
E_SImode) != 0)
                    return -1;
                  return 515; /* *andsi3_compare0 */

                case E_DImode:
                  if (pattern1296 (x11, 
E_DImode) != 0)
                    return -1;
                  return 516; /* *anddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1225 (x1, 
AND) != 0
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_logical_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x14 = XEXP (x11, 0);
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              return 517; /* *andsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern1102 (x1, 
ASHIFT))
            {
            case 0:
              return 518; /* *and_ashlsi3_compare0 */

            case 1:
              return 523; /* *and_ashldi3_compare0 */

            case 2:
              return 528; /* *and_ashlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern1102 (x1, 
ASHIFTRT))
            {
            case 0:
              return 519; /* *and_ashrsi3_compare0 */

            case 1:
              return 524; /* *and_ashrdi3_compare0 */

            case 2:
              return 529; /* *and_ashrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern1102 (x1, 
LSHIFTRT))
            {
            case 0:
              return 520; /* *and_lshrsi3_compare0 */

            case 1:
              return 525; /* *and_lshrdi3_compare0 */

            case 2:
              return 530; /* *and_lshrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern1102 (x1, 
ROTATERT))
            {
            case 0:
              return 521; /* *and_rotrsi3_compare0 */

            case 1:
              return 526; /* *and_rotrdi3_compare0 */

            case 2:
              return 531; /* *and_rotrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern1102 (x1, 
ROTATE))
            {
            case 0:
              return 522; /* *and_rotlsi3_compare0 */

            case 1:
              return 527; /* *and_rotldi3_compare0 */

            case 2:
              return 532; /* *and_rotlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case NOT:
          x21 = XEXP (x8, 0);
          switch (GET_CODE (x21))
            {
            case REG:
            case SUBREG:
              operands[1] = x21;
              x10 = XEXP (x7, 1);
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case AND:
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != NOT)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1318 (x1, 
E_SImode) != 0)
                        return -1;
                      return 600; /* *and_one_cmplsi3_compare0 */

                    case E_DImode:
                      if (pattern1318 (x1, 
E_DImode) != 0)
                        return -1;
                      return 601; /* *and_one_cmpldi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (GET_CODE (x18) != NOT
                      || GET_MODE (x18) != E_SImode
                      || GET_MODE (x7) != E_SImode
                      || GET_MODE (x8) != E_SImode
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x30 = XEXP (x18, 0);
                  if (!rtx_equal_p (x30, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 602; /* *and_one_cmplsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern1157 (x1, 
ASHIFT))
                {
                case 0:
                  return 665; /* *and_one_cmpl_ashlsi3_compare0 */

                case 1:
                  return 670; /* *and_one_cmpl_ashldi3_compare0 */

                case 2:
                  return 675; /* *and_one_cmpl_ashlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1157 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 666; /* *and_one_cmpl_ashrsi3_compare0 */

                case 1:
                  return 671; /* *and_one_cmpl_ashrdi3_compare0 */

                case 2:
                  return 676; /* *and_one_cmpl_ashrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1157 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 667; /* *and_one_cmpl_lshrsi3_compare0 */

                case 1:
                  return 672; /* *and_one_cmpl_lshrdi3_compare0 */

                case 2:
                  return 677; /* *and_one_cmpl_lshrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATERT:
              switch (pattern1157 (x1, 
ROTATERT))
                {
                case 0:
                  return 668; /* *and_one_cmpl_rotrsi3_compare0 */

                case 1:
                  return 673; /* *and_one_cmpl_rotrdi3_compare0 */

                case 2:
                  return 678; /* *and_one_cmpl_rotrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATE:
              switch (pattern1157 (x1, 
ROTATE))
                {
                case 0:
                  return 669; /* *and_one_cmpl_rotlsi3_compare0 */

                case 1:
                  return 674; /* *and_one_cmpl_rotldi3_compare0 */

                case 2:
                  return 679; /* *and_one_cmpl_rotlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8QImode:
      switch (pattern580 (x3, 
E_VNx8QImode))
        {
        case 0:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1076 (insn, operands);

        case 1:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1082 (insn, operands);

        case 2:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1088 (insn, operands);

        case 3:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1094 (insn, operands);

        case 4:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1100 (insn, operands);

        case 5:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1106 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx4QImode:
      switch (pattern580 (x3, 
E_VNx4QImode))
        {
        case 0:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1077 (insn, operands);

        case 1:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1083 (insn, operands);

        case 2:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1089 (insn, operands);

        case 3:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1095 (insn, operands);

        case 4:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1101 (insn, operands);

        case 5:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1107 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2QImode:
      switch (pattern580 (x3, 
E_VNx2QImode))
        {
        case 0:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1078 (insn, operands);

        case 1:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1084 (insn, operands);

        case 2:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1090 (insn, operands);

        case 3:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1096 (insn, operands);

        case 4:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1102 (insn, operands);

        case 5:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1108 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx4HImode:
      switch (pattern580 (x3, 
E_VNx4HImode))
        {
        case 0:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1079 (insn, operands);

        case 1:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1085 (insn, operands);

        case 2:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1091 (insn, operands);

        case 3:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1097 (insn, operands);

        case 4:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1103 (insn, operands);

        case 5:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1109 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2HImode:
      switch (pattern580 (x3, 
E_VNx2HImode))
        {
        case 0:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1080 (insn, operands);

        case 1:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1086 (insn, operands);

        case 2:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1092 (insn, operands);

        case 3:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1098 (insn, operands);

        case 4:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1104 (insn, operands);

        case 5:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1110 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2SImode:
      switch (pattern580 (x3, 
E_VNx2SImode))
        {
        case 0:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1081 (insn, operands);

        case 1:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1087 (insn, operands);

        case 2:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1093 (insn, operands);

        case 3:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1099 (insn, operands);

        case 4:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1105 (insn, operands);

        case 5:
          if (!(
#line 3509 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 3511 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1111 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern869 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3767 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1142 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3816 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1175 (insn, operands);

    case E_VNx4SFmode:
      if (pattern869 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3767 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1153 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3816 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1186 (insn, operands);

    case E_VNx2DFmode:
      if (pattern869 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3767 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1164 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3816 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1197 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern869 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3767 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1141 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3816 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1174 (insn, operands);

    case E_VNx4SFmode:
      if (pattern869 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3767 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1152 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3816 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1185 (insn, operands);

    case E_VNx2DFmode:
      if (pattern869 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3762 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3767 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1163 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3810 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3816 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1196 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2952 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2960 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2968 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2953 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2961 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2969 (insn, operands);
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2845 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2888 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2928 (insn, operands);
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2844 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2887 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2927 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2831 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2876 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2916 (insn, operands);
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2818 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2865 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2905 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2851 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2893 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2933 (insn, operands);
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2838 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2882 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2922 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2825 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2871 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2911 (insn, operands);
}

 rtx_insn *
split_56 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2847 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2889 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2929 (insn, operands);
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1048 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1685 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1758 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1810 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1698 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1771 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1823 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1711 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1784 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1836 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1724 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1797 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1849 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1733 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1910 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1740 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1917 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5569 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5574 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1747 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5737 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5743 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1924 (insn, operands);

    case 7:
      if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1862 (insn, operands);

    case 8:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1875 (insn, operands);

    case 9:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1888 (insn, operands);

    case 10:
      if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1901 (insn, operands);

    case 11:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1931 (insn, operands);

    case 12:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1938 (insn, operands);

    case 13:
      if (!(
#line 5773 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5779 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1945 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_68 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[3] = x6;
  switch (XINT (x3, 1))
    {
    case 391:
      switch (XWINT (x4, 0))
        {
        case 0L:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1164 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5293 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1657 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
                  || !(
#line 5333 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5340 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1660 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1164 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5293 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1658 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
                  || !(
#line 5333 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5340 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1661 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1164 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5293 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1659 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
                  || !(
#line 5333 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5340 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1662 (insn, operands);

            default:
              return NULL;
            }

        case 1L:
          x8 = XVECEXP (x2, 0, 2);
          operands[4] = x8;
          x7 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1228 (x2, 
E_VNx8HFmode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !(
#line 5370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5377 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1663 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1228 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !(
#line 5370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5377 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1664 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1228 (x2, 
E_VNx2DFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !(
#line 5370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5377 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1665 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 352:
      return split_59 (x1, insn);

    case 353:
      switch (pattern1044 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1679 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1752 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1804 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1692 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1765 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1817 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1705 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1778 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1718 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1791 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 4:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 5:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 6:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1882 (insn, operands);

        case 7:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3351 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1895 (insn, operands);

        default:
          return NULL;
        }

    case 354:
      switch (pattern1044 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1680 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1753 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1693 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1766 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1706 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1779 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1719 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1792 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1844 (insn, operands);

        case 4:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 5:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 6:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1883 (insn, operands);

        case 7:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3352 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1896 (insn, operands);

        default:
          return NULL;
        }

    case 371:
      switch (pattern1044 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1681 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1754 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1806 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1694 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1767 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1819 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1707 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1780 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1832 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1720 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1793 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1845 (insn, operands);

        case 4:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 5:
          if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1871 (insn, operands);

        case 6:
          if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1884 (insn, operands);

        case 7:
          if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1897 (insn, operands);

        default:
          return NULL;
        }

    case 372:
      return split_65 (x1, insn);

    case 373:
      return split_64 (x1, insn);

    case 374:
      return split_63 (x1, insn);

    case 375:
      return split_62 (x1, insn);

    case 378:
      return split_58 (x1, insn);

    case 379:
      switch (pattern1044 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1687 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1760 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1812 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1700 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1773 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1825 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1713 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1786 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1838 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5526 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5531 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1726 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5612 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5617 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1799 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5667 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1851 (insn, operands);

        case 4:
          if (!((
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1864 (insn, operands);

        case 5:
          if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1877 (insn, operands);

        case 6:
          if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1890 (insn, operands);

        case 7:
          if (!(
#line 5699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5711 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1903 (insn, operands);

        default:
          return NULL;
        }

    case 393:
      return split_57 (x1, insn);

    case 395:
      return split_61 (x1, insn);

    case 396:
      return split_60 (x1, insn);

    case 355:
      switch (pattern1049 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6013 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1958 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6058 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1964 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6013 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1960 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6058 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1966 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6013 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1962 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6058 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1968 (insn, operands);

        case 3:
          if (!(
#line 6088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6095 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1970 (insn, operands);

        case 4:
          if (!(
#line 6088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6095 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1972 (insn, operands);

        case 5:
          if (!(
#line 6088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6095 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1974 (insn, operands);

        default:
          return NULL;
        }

    case 356:
      switch (pattern1049 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6013 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1959 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6058 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1965 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6013 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1961 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6058 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1967 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6013 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1963 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6058 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1969 (insn, operands);

        case 3:
          if (!(
#line 6088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6095 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1971 (insn, operands);

        case 4:
          if (!(
#line 6088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6095 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1973 (insn, operands);

        case 5:
          if (!(
#line 6088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6095 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1975 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      switch (pattern302 (x3))
        {
        case 0:
          return gen_split_26 (insn, operands);

        case 1:
          return gen_split_27 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          switch (pattern457 (x3))
            {
            case 0:
              if (!
#line 5177 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!
#line 5177 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_45 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern458 (x3))
            {
            case 0:
              if (!
#line 5199 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (XOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 1:
              if (!
#line 5199 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (XOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 2:
              if (!
#line 5228 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (XOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 3:
              if (!
#line 5228 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (XOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return NULL;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DImode))
            return NULL;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x9 = XEXP (x3, 1);
          if (rtx_equal_p (x9, operands[3])
              && (
#line 3786 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 3793 "../../gcc/config/aarch64/aarch64-simd.md"
( REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0])))))
            return gen_split_176 (insn, operands);
          if (!rtx_equal_p (x9, operands[2])
              || !(
#line 3827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 3834 "../../gcc/config/aarch64/aarch64-simd.md"
( REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_177 (insn, operands);

        case UNSPEC:
          switch (pattern407 (x3))
            {
            case 0:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2975 (insn, operands);

            case 1:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2976 (insn, operands);

            case 2:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2977 (insn, operands);

            case 3:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2978 (insn, operands);

            case 4:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2995 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2996 (insn, operands);

            case 5:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2997 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2998 (insn, operands);

            case 6:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2999 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3000 (insn, operands);

            case 7:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3001 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3002 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern368 (x3))
        {
        case 0:
          if (!
#line 5251 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_65 (insn, operands);

        case 1:
          if (!
#line 5251 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_68 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_107 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2423 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2433 (insn, operands);
}

 rtx_insn *
split_114 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2442 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2452 (insn, operands);
}

 rtx_insn *
split_121 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2461 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2471 (insn, operands);
}

 rtx_insn *
split_128 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2480 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8490 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8494 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2490 (insn, operands);
}

 rtx_insn *
split_135 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  switch (XINT (x4, 1))
    {
    case 126:
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 0);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[7] = x8;
      x9 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x9))
        {
        case LT:
          switch (pattern1334 (x1, 
LT))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2116 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2126 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2156 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2136 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2166 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2186 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2146 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2176 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2196 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2206 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2216 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2226 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2256 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2236 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2266 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2286 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2246 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2276 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2296 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2306 (insn, operands);

            default:
              return NULL;
            }

        case LE:
          switch (pattern1334 (x1, 
LE))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2117 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2127 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2157 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2137 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2167 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2187 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2147 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2177 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2197 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2207 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2217 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2227 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2257 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2237 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2267 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2287 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2247 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2277 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2297 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2307 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern1334 (x1, 
EQ))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2118 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2128 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2158 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2138 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2168 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2188 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2148 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2178 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2198 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2208 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2218 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2228 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2258 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2238 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2268 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2288 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2248 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2278 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2298 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2308 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          switch (pattern1334 (x1, 
NE))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2119 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2129 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2159 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2139 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2169 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2189 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2149 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2179 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2199 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2209 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2219 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2229 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2259 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2239 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2269 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2289 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2249 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2279 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2299 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2309 (insn, operands);

            default:
              return NULL;
            }

        case GE:
          switch (pattern1334 (x1, 
GE))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2120 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2130 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2160 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2140 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2170 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2190 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2150 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2180 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2200 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2210 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2220 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2230 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2260 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2240 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2270 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2290 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2250 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2280 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2300 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2310 (insn, operands);

            default:
              return NULL;
            }

        case GT:
          switch (pattern1334 (x1, 
GT))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2121 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2131 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2161 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2141 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2171 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2191 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2151 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2181 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2201 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2211 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2221 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2231 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2261 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2241 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2271 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2291 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2251 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2281 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2301 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2311 (insn, operands);

            default:
              return NULL;
            }

        case LTU:
          switch (pattern1338 (x1, 
LTU))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2122 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2132 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2162 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2142 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2172 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2192 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2152 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2182 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2202 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2212 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2222 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2232 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2262 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2242 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2272 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2292 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2252 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2282 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2302 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2312 (insn, operands);

            default:
              return NULL;
            }

        case LEU:
          switch (pattern1338 (x1, 
LEU))
            {
            case 0:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2123 (insn, operands);

            case 1:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2133 (insn, operands);

            case 2:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2163 (insn, operands);

            case 3:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2143 (insn, operands);

            case 4:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2173 (insn, operands);

            case 5:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2193 (insn, operands);

            case 6:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2153 (insn, operands);

            case 7:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2183 (insn, operands);

            case 8:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2203 (insn, operands);

            case 9:
              if (!(
#line 8271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8281 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2213 (insn, operands);

            case 10:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2223 (insn, operands);

            case 11:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2233 (insn, operands);

            case 12:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2263 (insn, operands);

            case 13:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2243 (insn, operands);

            case 14:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2273 (insn, operands);

            case 15:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2293 (insn, operands);

            case 16:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2253 (insn, operands);

            case 17:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2283 (insn, operands);

            case 18:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 19:
              if (!(
#line 8305 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8315 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2313 (insn, operands);

            default:
              return NULL;
            }

        case GEU:
          return split_134 (x1, insn);

        case GTU:
          return split_133 (x1, insn);

        case UNSPEC:
          if (XVECLEN (x9, 0) != 2)
            return NULL;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x9, 0, 1);
          operands[3] = x11;
          switch (XINT (x9, 1))
            {
            case 473:
              switch (pattern1365 (x1, 
473))
                {
                case 0:
                  if (!(
#line 4054 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4058 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3053 (insn, operands);

                case 1:
                  if (!(
#line 4054 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4058 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3055 (insn, operands);

                case 2:
                  if (!(
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4086 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3057 (insn, operands);

                case 3:
                  if (!(
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4086 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3059 (insn, operands);

                default:
                  return NULL;
                }

            case 474:
              switch (pattern1365 (x1, 
474))
                {
                case 0:
                  if (!(
#line 4054 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4058 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3054 (insn, operands);

                case 1:
                  if (!(
#line 4054 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4058 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3056 (insn, operands);

                case 2:
                  if (!(
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4086 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3058 (insn, operands);

                case 3:
                  if (!(
#line 4082 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4086 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3060 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 305:
      switch (pattern1276 (x1, 
305))
        {
        case 0:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2689 (insn, operands);

        case 1:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2691 (insn, operands);

        case 2:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2693 (insn, operands);

        case 3:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2695 (insn, operands);

        case 4:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2697 (insn, operands);

        case 5:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2699 (insn, operands);

        case 6:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2701 (insn, operands);

        case 7:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2703 (insn, operands);

        default:
          return NULL;
        }

    case 306:
      switch (pattern1276 (x1, 
306))
        {
        case 0:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2690 (insn, operands);

        case 1:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2692 (insn, operands);

        case 2:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2694 (insn, operands);

        case 3:
          if (!(
#line 10346 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10350 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2696 (insn, operands);

        case 4:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2698 (insn, operands);

        case 5:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2700 (insn, operands);

        case 6:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 7:
          if (!(
#line 10371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10375 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2704 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
